!===============================================================================
! SVN $Id: main.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/main.F90 $
!===============================================================================

PROGRAM main

   use shr_timer_mod
   use kind_mod

   use map_mod
   use mapsort_mod
   use fixroff_mod
   use smooth_mod

   implicit none

   !--- mapping matricies ---
   type(sMatrix),target :: map_orig    ! orig matrix -- produced by scrip, may have runoff over land
   type(sMatrix),target :: map_corr    ! orig matrix, corrected -- no runoff over land
   type(sMatrix),target :: map_new     ! orig matrix, corrected, smoothed -- unsorted & sorted
   type(sMatrix),target :: map_smooth  ! smoothing matrix

   !--- for correction (runoff relocations) and smoothing ---
   integer(IN)       :: n               !
   real(R8)          :: eFold           ! smoothing e-fold curve
   real(R8)          :: rMax            ! max smoothing radius

   integer(IN)       :: t01,t02,t03,t04,t05,t06,t07,t08,t09,t10 ! timer numbers
   integer(IN)       :: rCode           ! return code
   character( 8)     :: dstr            ! wall clock date
   character(10)     :: tstr            ! wall clock time

   !--- namelis vars ---
   character(180) :: gridtype      ! type of run-off grid
   character(180) :: file_roff     ! file name: rtm rdirc file
   character(180) :: file_ocn      ! file name: ocn scrip grid file
   character(180) :: file_nn       ! file name: orig matrix, corrected
   character(180) :: file_new      ! file name: orig matrix, corrected, smoothed, sorted -- done
   character(180) :: file_smooth   ! file name: smoothing matrix
   character(180) :: title         ! netCDF title attribute
   logical        :: step1         ! gen nn
   logical        :: step2         ! gen smooth
   logical        :: step3         ! mat mult


   namelist / input_nml / &
      gridtype      &
   ,  file_roff     &
   ,  file_ocn      &
   ,  file_nn       &
   ,  file_new      &
   ,  file_smooth   &
   ,  title         &
   ,  eFold         &
   ,  rMax          &
   ,  step1, step2, step3

   !--- formats ---
   character(*),parameter :: F00 = "('(main) ',6a)"
   character(*),parameter :: F01 = "('(main) ',a,i7)"
   character(*),parameter :: F02 = "('(main) ',a,es13.6)"
   character(*),parameter :: F03 = "('(main) ',a,l1)"
   character(*),parameter :: F10 = "('(main) ',73('-')/,'(main) ',a/,'(main) ',73('-'))"
   character(*),parameter :: F12 = "('(main) date & time:',1x,a4,2('-',a2),2x,a2,2(':',a2))"

!-------------------------------------------------------------------------------
! PURPOSE:
!   Take a scrip conservative map matrix, runoff->ocean (unmasked ocean)
!   and produce a runoff->ocean map suitable for use in CCSM
! 
! Step 1: Read raw grids and genearate nearest neighbor mapping file
!         (or read nearest neighbor map)
! Step 2: Create the smoothing map (and sort it)
!         smoothing map determines how runoff gets spread to more ocean cells
! Step 3: Multiply corrected original with smoothing (and sort new map)
!-------------------------------------------------------------------------------

   write(6,F10) "correct/smooth/sort runoff -> ocean map"
   write(6,F10) "SVN &
   & $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/main.F90 $"

   call shr_timer_init()

   !----------------------------------------------------------------------------
   write(6,F10) "Step 0:  read input namelist data"
   !----------------------------------------------------------------------------

   gridtype      = 'unset'
   file_roff     = 'unset'
   file_ocn      = 'unset'
   file_nn       = 'unset'
   file_smooth   = 'unset'
   file_new      = 'unset'
   title         = 'unset'
   eFold         = 1000000.00000 ! smoothing eFold distance in meters
   rMax          =  500000.00000 ! max smoothing radius in meters
   step1         = .true.
   step2         = .true.
   step3         = .true.

   open (10,file="runoff_map.nml",status="old",action="read")
   read (10,nml=input_nml,iostat=rCode)
   close(10)
   write(6,F00) "Namelist values..."
   write(6,F00) "   gridtype       = ",trim(gridtype      )
   write(6,F00) "   file_roff      = ",trim(file_roff     )
   write(6,F00) "   file_ocn       = ",trim(file_ocn      )
   write(6,F00) "   file_nn        = ",trim(file_nn       )
   write(6,F00) "   file_smooth    = ",trim(file_smooth   )
   write(6,F00) "   file_new       = ",trim(file_new      )
   write(6,F00) "   title          = ",trim(title         )
   write(6,F02) "   eFold distance = ",eFold
   write(6,F02) "   rMax  distance = ",rMax
   write(6,F03) "   step1          = ",step1
   write(6,F03) "   step2          = ",step2
   write(6,F03) "   step3          = ",step3
!  if (rCode > 0) then
!     write(6,F01) 'ERROR: reading input namelist, iostat=',rCode
!     stop
!  end if

   call date_and_time(dstr,tstr)
   write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)

   !----------------------------------------------------------------------------
   write(6,F10) "Step 1: read grid info & create nearest neighbor map"
   !----------------------------------------------------------------------------
   call shr_timer_get  (t01,"Step 1: Grid Read, Gen NN")
   call shr_timer_start(t01)
if (step1) then
   call map_gridRead(map_orig , trim(file_roff), trim(file_ocn), gridtype)

   call date_and_time(dstr,tstr)
   call map_print(map_orig)
!  call map_gennn(map_orig)     ! optimized nn map generation -- has bugs?
   call map_gennn0(map_orig)    ! non-optimized nn map generation
   call mapsort_sort(map_orig)  ! sort map
   call map_check(map_orig)
   call map_write(map_orig, trim(file_nn)) 
else
   call map_read (map_orig, trim(file_nn))  ! read corrected r2o map
   call mapsort_sort(map_orig)  ! sort map
   call map_check(map_orig)
endif
   call shr_timer_stop (t01)
   call shr_timer_print(t01)


   !----------------------------------------------------------------------------
   write(6,F10) "Step 2:  create smoothing map"
   !----------------------------------------------------------------------------
   call shr_timer_get  (t06,"Step 2: Create the smoothing map")
   call shr_timer_start(t06)
if (step2) then
   write(6,F02) "   eFold distance = ",eFold
   write(6,F02) "   rMax  distance = ",rMax
   call smooth_init(map_orig,map_smooth)
!  call restrictSources(map_smooth,trim(file_sources)) ! restrict cells subject to smoothing
   call smooth(map_smooth,eFold,rMax)
   call mapsort_sort(map_smooth)
   call map_check(map_smooth)
   call map_write(map_smooth, trim(file_smooth)) 
else
   call map_read (map_smooth, trim(file_smooth))  ! read corrected r2o map
   call mapsort_sort(map_smooth)  ! sort map
   call map_check(map_smooth)
endif
   call shr_timer_stop (t06)
   call shr_timer_print(t06)

   call shr_timer_get  (t07,"Step 3:  Matrix Multiply")
   call shr_timer_start(t07)


if (step3) then
   !----------------------------------------------------------------------------
   write(6,F10) "Step 3:  create smoothed version of nearest neighbor  map"
   !----------------------------------------------------------------------------
   !--- create new map datatype to hold result of matrix-matrix multiply ---
   call map_dup(map_orig,map_new)
   map_new%title  = trim(title)
   call map_matMatMult(map_orig,map_new,map_smooth) ! mult(A,B,S): B=S*A
   call mapsort_sort(map_new)
   call map_check(map_new)
   call map_write(map_new, trim(file_new)) 
else
   call map_read(map_new, trim(file_new)) 
   call mapsort_sort(map_new)
   call map_check(map_new)
endif
   call shr_timer_stop (t07)
   call shr_timer_print(t07)

   call shr_timer_print_all()
   stop

END PROGRAM main

!===============================================================================

!===============================================================================
! SVN $Id: fixroff_mod.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/fixroff_mod.F90 $
!===============================================================================

MODULE fixroff_mod

   use shr_sys_mod
   use kind_mod
   use map_mod

   implicit none

   private ! default private

   public  :: fixroff_modifyMap   ! modify map wrt relocated points
   private :: fixroff_findActive  ! determine if & where to relocate runoff

   logical :: debug = .false. ! trigger debug statements

!===============================================================================
CONTAINS 
!===============================================================================

SUBROUTINE fixroff_modifyMap(map, map2)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map        ! map: original
   type(sMatrix), intent(inout) :: map2       ! map: modified wrt newpt

   !--- local ---
   integer(IN),allocatable :: newpt(:,:)          ! cell relocation info

   integer(IN)             :: i,j,i2,j2           ! 2d row,col indecies
   integer(IN)             :: n                   ! 2d vector index
   integer(IN),allocatable :: badpts (:)          ! 0 <=> no relocation necessary
   integer(IN),allocatable :: badptsf(:)          ! 0 <=> relocation necessary but not done
   integer(IN)             :: newptr(map%n_b)     ! 
   integer(IN)             :: cnt1,cnt2,cnt3,cnt4 ! counts various cases
   real(R8)   ,allocatable :: wcol(:)             ! cnt2 weight corrections
   real(R8)                :: dist,distMin        ! distance, min distance
   real(R8)                :: element             ! a matrix element

   !--- formats ---
   character(*),parameter :: subName = "(fixroff_modifyMap) "
   character(*),parameter :: F00 =   "('(fixroff_modifyMap) ',4a)"
   character(*),parameter :: F01 =   "('(fixroff_modifyMap) ',a,i8)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o Returns a new version of "map", "map2", which corrects three kinds
!   of scrip mapping "errors" (errors wrt runoff mapping):
!
!   (case 1) cnt1 points: mask_a is non-zero, but frac_a = 0.0
!      issue:
!         the source cell is active, but 0% participates in the mapping;  
!         these represent active source cells which 
!         do not intersect any destination cells.
!      correction:  
!         make frac_a = 1.0; add links for these points to 
!         closest destination grid cell with s weight based 
!         on simple area ratio. (NOTE:  may result in S>1.0)
!
!   (case 2) cnt2 points: mask_a is non-zero  and  0 < frac_a < 1
!      issue:
!         the source cell is active but only partially intersects
!         the active destination domain.
!      correction:
!         make frac_a = 1.0 and apply correction factor to s weight of 1/old_frac_a. 
!         NOTE:  may result in S>1.0
!
!   (case 3) cnt3 points: mask_a is zero  and  0 < frac_a 1
!      issue:
!         the source cell is inactive, but the scrip matrix will map the data anyway
!         This indicates a script error that deserves attention.
!      correction:
!         no correction. (?but should set matrix element to 0?)
!
!   (case 4) cnt4 points: mask_b is zero, any runoff to this cell needs to be relocated
!      issue:
!         since scrip creates links on the basis of mask_a values, 
!         (ie. assumes mask_b /= 0 everywhere), a link to this cell exists.
!         Since this is for runoff mapping, we cannot accept
!         such links to land cells on the destination grid.
!      correction:
!         Shift the flux to the nearest mask_b /= 0 point, as determined previously by 
!         fixroff_findActive.  NOTE: this may result in a "doubling-up" of links 
!         (non-unique links) between a given source and destination cell.
!-------------------------------------------------------------------------------

   !----------------------------------------------------------------------------
   ! preliminary data: determine where to relocate runoff, if necessary
   !----------------------------------------------------------------------------
   allocate(newpt(map%ni_b,map%nj_b))
   call fixroff_findActive(map, newpt) 

   !----------------------------------------------------------------------------
   ! determine how many, and what types of, corrections are necessary
   !----------------------------------------------------------------------------
   cnt1 = 0 ! counts cells wrt case (1)
   cnt2 = 0 ! counts cells wrt case (2)
   cnt3 = 0 ! counts cells wrt case (3)
   cnt4 = 0 ! counts cells wrt case (4)

   allocate(badpts (map%n_b))
   allocate(badptsf(map%n_b))
   allocate(   wcol(map%n_a))

   wcol = 1.0_R8
   do n=1,map%n_a
      if (map%frac_a(n) == 0.0_R8 .and. map%mask_a(n) /= 0) then
         cnt1=cnt1+1
      endif
      if (map%frac_a(n) /= 0.0_R8 .and. abs(map%frac_a(n)-1.0_R8) > 1.e-20_R8 .and. &
      &   map%mask_a(n) /= 0) then
         wcol(n)       = 1.0_r8/map%frac_a(n) ! apply this correction to s(n)
         map%frac_a(n) = 1.0_R8
         cnt2=cnt2+1
      endif
      if (map%frac_a(n) /= 0.0_R8 .and. map%frac_a(n) /= 1.0_R8 .and. &
      &   map%mask_a(n) == 0) then
         cnt3=cnt3+1
      endif
      if (map%mask_b(n) == 0) then
         cnt4 = cnt4+1
      endif
   enddo
   write(6,F01) 'case(1): mask_a /= 0 AND  frac_a == 0.0     : ',cnt1
   write(6,F01) 'case(2): mask_a /= 0 AND (0 < frac_a < 1)   : ',cnt2
   write(6,F01) 'case(3): mask_a == 0 AND (0 < frac_a < 1)   : ',cnt3
   write(6,F01) 'case(4): mask_b == 0 AND is being mapped to : ',cnt4

   !----------------------------------------------------------------------------
   ! initialize up new map that is sufficiently larger (will add cnt1 links)
   !----------------------------------------------------------------------------

   !--- duplicate ---
   call map_dup(map,map2) 

   !--- resize ---
   write(6,F01) "Original matrix size = ",map2%n_s 
   deallocate( map2%s   )
   deallocate( map2%row )
   deallocate( map2%col )
   map2%n_s  = map%n_s + cnt1
   allocate(map2%s  (map2%n_s) )
   allocate(map2%row(map2%n_s) )
   allocate(map2%col(map2%n_s) )
   write(6,F01) "Modified matrix size = ",map2%n_s 

   !--- copy initial data ---
   map2%s  (1:map%n_s) = map%s
   map2%row(1:map%n_s) = map%row
   map2%col(1:map%n_s) = map%col

   !----------------------------------------------------------------------------
   ! case (1) add new links for active src cells that are currently unmapped
   !----------------------------------------------------------------------------
   cnt1 = 0
   n    = map%n_s
   do j=1,map%n_a ! for each column
      if (map%frac_a(j) == 0.0_R8 .and. map%mask_a(j) /= 0) then
         !--- none of this src grid cell is mapped to the dest grid ---
         n    = n    + 1
         cnt1 = cnt1 + 1

         !--- find closest grid_b(i) cell to this grid_a(j) cell ---
         i = 1
         distMin = 1.e30_R8
         do i2 = 1,map%n_b
            dist = (map%yc_b(i2)-map%yc_a(j))**2 + (map%xc_b(i2)-map%xc_a(j))**2
            if (dist < distMin) then
               i = i2
               distMin = dist
            endif
         enddo

         !--- compute new matrix element for this i,j pair ---
         if (map%normal == 'fracarea') then
            element = (map%area_a(j)*map%frac_a(j))/(map%area_b(i)*map%frac_b(i))
         elseif (map%normal == 'destarea') then
            element =                map%area_a(j) / map%area_b(i)
         endif

         !--- add new element to matrix ---
         map2%frac_a(j) = 1.0_R8
         map2%row(n)    = i
         map2%col(n)    = j
         map2%S  (n)    = element

         if (debug) write(6,*) subName,'added element: ',n, &
         &  map2%xc_a(j),map2%yc_a(j),map2%xc_b(i),map2%yc_b(i),map2%s(n)
       endif
   enddo
   write(6,F01) 'case (1): new links added: ',cnt1

   !----------------------------------------------------------------------------
   ! case (2) adjust matrix weights for non-unity src fractions 
   ! case (4) relocate links that map to mask_b=0 points.
   !    Do this by changing the element's row to the row specified by newpt index.
   !    Also must correct the matrix element value wrt src & dest cell areas
   !----------------------------------------------------------------------------
   badpts (:) = 0 ! 1 <=> cell needs relocation
   badptsf(:) = 0 ! 1 <=> cell relocation error
   newptr = reshape(newpt,(/map%n_b/))
   do n=1,map2%n_s

      i = map2%row(n) ! original/unmodified row
      j = map2%col(n) ! original col (this won't change)

      !--- case (2) adjust for non-unity src fractions ---
      map2%s(n)=map2%s(n)*wcol(j)

      !--- case (4) relocate mapping to masked out destination cell ---
      if (map2%mask_b(i) == 0) then
         badpts   (i) = 1 ! 1 <=> cell needs relocation
         badptsf  (i) = 1 ! 1 <=> cell relocation error
         i2=newptr(i)     ! new/modified row
         if (map2%mask_b(i2) /= 0) then ! OK to relocate row to here
            badptsf(i)=0 ! row was successfully relocated
            if ( i  < 1 .or. map2%n_b < i ) write(6,*) subName,'ERROR1 n,i1,i2:',n,i,i2
            if ( i2 < 1 .or. map2%n_b < i2) write(6,*) subName,'ERROR2:n,i1,i2:',n,i,i2
            if (map2%normal == 'fracarea') then
               if (map2%frac_b(i) == 0.0_R8 .or. map2%frac_b(i2) == 0.0_R8) then
                  write(6,*) subName,'ij3 ',n,i2,map2%frac_b(i),map2%frac_b(i2)
                  element = map2%s(n)*map2%area_b(i)/map2%area_b(i2)
               else
                  element = map2%s(n)*(map2%area_b(i )*map2%frac_b(i )) / &
                  &                   (map2%area_b(i2)*map2%frac_b(i2))
               endif
            elseif (map2%normal == 'destarea') then
                element = map2%s(n)*map2%area_b(i)/map2%area_b(i2)
            endif
            map2%s  (n) = element  ! corrected matrix element
            map2%row(n) = i2       ! new row
        endif
      endif
   enddo

   open(20,file="fixroff_modifyMap_info.txt",form="formatted")
   do n=1,map2%n_b
      if (badptsf(n) /= 0) write(6,F01) 'CAUTION: badpt /= 0 ',n
      write(20,*) map2%mask_b(n),badpts(n),badptsf(n),newptr(n)
   enddo
   close(20)

END SUBROUTINE fixroff_modifyMap

!===============================================================================
!===============================================================================

SUBROUTINE fixroff_findActive(map, newpt)

   implicit none

   !--- arguments ---
   type(sMatrix),intent(in)    :: map        ! map in question
   integer(IN)  ,intent(inout) :: newpt(:,:) ! indicates where to relocate runoff

   !--- local ---
   integer(IN),allocatable :: newpt_old(:,:) ! temporary work array

   integer(IN) :: ni,nj       ! size of grid_b
   integer(IN) :: i,j         ! loop index into 2D array
   integer(IN) :: n           ! loop index into 1D vector
   integer(IN) :: i2,j2       ! index of neighbor cells

   integer(IN) :: nFound      ! # cells whose nearest active neighbor was found
   integer(IN) :: nNotFound   ! # cells whose nearest active neighbor is unknown
   logical     :: found       ! an active cell has been found 
   logical     :: done        ! T => active cells have been found for all cells

   !--- formats ---
   character(*),parameter :: subName = "(fixroff_findActive) "

!-------------------------------------------------------------------------------
! PURPOSE:
! o  For each destination grid cell, find the nearest active (unmasked) grid cell.
!    For destination grid points which are  active  (ie. mask_b(n) /= 0)
!    the nearest active (unmasked) grid cell is itself.
!    For destination grid points which are inactive (ie. mask_b(n) == 0)
!    the nearest active cell must be searched for.
!
! NOTES:
! o  The sMatrix "map", which maps from grid_a -> grid_b,
!    where the size of grid_b, shaped as a 2d array,  is (ni_b,nj_b), and
!    where the size of grid_b, shaped as a 1d vector, is (n_b)...
!
! o  The "newPt(:,:)" data array is a 2d array dimensioned newPt(ni_b,nj_b)
!    assign a 1d index n, between 1->n_b, for each point of grid_b.  
!    If mask_b(n) /= 0, the index is n
!    If mask_b(n) == 0, the index is that of the nearest neigbor m 
!                       for which mask_b(m)==1
! HISTORY:
!    2007-01-05 - B. Kauffman, code cleanup
!    2002-06-12 - M. Hecht, original version
!-------------------------------------------------------------------------------

   ni = map%ni_b
   nj = map%nj_b

   !--- nearest neighbors are known for all active cells ---
   do j=1,nj
   do i=1,ni
      n = (j-1)*ni + i ! corresponding 1d vector index
      if (map%mask_b(n) /= 0) then
         newpt(i,j) = n  ! nearest neighbor is itself
      else
         newpt(i,j) = 0  ! nearest neighbor is unknown
      endif
   enddo
   enddo

   !--- search for nearest neighbors for all inactive cells ---
   allocate(newpt_old(ni,nj))
   done = .false.
   do while ( .not. done )
      newpt_old(:,:) = newpt(:,:)

      nNotFound = 0
      nFound    = 0

      do j=1,nj
      do i=1,ni
         if (newpt(i,j) == 0) then ! nearest active neighbor not found
            found = .false.
 loop:      do n=1,4 ! check immediate neighbors
               i2=i
               j2=j
               if (n == 1) i2=mod(i     ,ni)+1 ! right neighbor
               if (n == 2) i2=mod(i-2+ni,ni)+1 ! left  neighbor
               if (n == 3) j2=min(j+1   ,nj)   ! neighbor above
               if (n == 4) j2=max(j-1   , 1)   ! neighbor below
               if (newpt_old(i2,j2) /= 0) then
                  found = .true.
                  newpt(i,j)=newpt_old(i2,j2)
                  exit loop
               endif
            enddo loop
            if (      found) nFound    = nFound    + 1
            if (.not. found) nNotFound = nNotFound + 1
         endif
      enddo
      enddo
      if (nNotFound == 0) done = .true.
      write(6,'(2a,2i8)') subName,"num of cells found, unknown = ",nFound,nNotFound
   enddo
   deallocate(newpt_old)

!  !--- write debugging info --- DELETE THIS VERSION
!  open(21,form="formatted")
!  do j=1,nj
!  do i=1,ni
!     n = (j-1)*map%ni_b+i
!     write(21,*)   map%mask_b(n),newpt(i,j)
!  enddo
!  enddo
!  close(21)
!  !---------------------------- DELETE THIS VERSION

   !--- write debugging info ---
   open(10,file="fixroff_findActive_info.txt",form="formatted")
   write(10,*) "cell index, mask value, nearest active neighbor index"
   do j=1,nj
   do i=1,ni
      n = (j-1)*ni+i
      write(10,*) n,map%mask_b(n),newpt(i,j)
   enddo
   enddo
   close(10)

END SUBROUTINE fixroff_findActive

!===============================================================================
!===============================================================================

END MODULE fixroff_mod

!===============================================================================
! SVN $Id: smooth_mod.F90 44128 2013-02-22 15:43:14Z mlevy@ucar.edu $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/smooth_mod.F90 $
!===============================================================================

MODULE smooth_mod

#define _NEW 1
#define _BREADTH 1
   use map_mod

   implicit none

!-------------------------------------------------------------------------------
!     module variables
!-------------------------------------------------------------------------------

! from map_mod:
!   real,parameter   :: rEarth   =  6.37122e6    ! radius of earth ~ m
!   real,parameter   :: DtoR     =  3.14159265358979323846/180.0  
   real(r8),parameter   :: DtoR = DEGtoRAD
   real(r8),allocatable :: garr(:,:,:)   ! dummy runoff (nx,ny,nbasin) in kg/s/m^2
   integer, parameter :: maxLinear = 120000

!===============================================================================
CONTAINS 
!===============================================================================

SUBROUTINE smooth_init(map_in, map_out)

   implicit none

   !--- arguments ---
   type(sMatrix),intent( in)   :: map_in   ! original unsmoothed, matrix
   type(sMatrix),intent(inout) :: map_out  ! smoothing matrix

   !--- local ---
   integer :: i,j,n ! indicies: row, col, sparse matrix 
   integer :: rcode ! return code
   integer :: ns    ! number of links
   integer :: nactive
   integer :: jmd_count

   integer,allocatable :: i_count(:)

   character(*),parameter :: subName = "(smooth_init) "

!-------------------------------------------------------------------------------
! PURPOSE:
! o Given map_in create map_out which maps from domain_b of
!   map_in to itself.  This is a template for the square smoothing 
!   map, which we assume is needed for domain_b of map_in.
! Notes:
! o Deallocation below copied from map_dup routine.  Depending on the context,
!   this routine might be given a map_out that has already been allocated, in
!   which case it has to be deallocated before being (re) allocated
! o the number of non-zero rows per column depends on the resolution of the
!   grid and the radius of smoothing (a nml parameter), so it's hard to guess
!   how big this smoothing matrix might be.  To date (March 2012), the goal at
!   NCAR has been to smooth each src cell over, say, 10-40 cells. A variety of
!   So a good guess might be, say, 40 x (the number of src cells).
!   But typically some cells, where the grid is finer, may get smooth over many
!   more, and the nml radius might be set much larger than typically desired.
!   Thus the current guess is close (2 ^ 31 ) - 1   
!   which is the maximum size that can be indexed with a 4-byte integer.
!-------------------------------------------------------------------------------

   !------------------------------------------------
   ! de-allocate space (if already allocated)
   !------------------------------------------------
   deallocate(map_out%  xc_a,STAT=rcode)
   deallocate(map_out%  yc_a,STAT=rcode)
   deallocate(map_out%  xv_a,STAT=rcode)
   deallocate(map_out%  yv_a,STAT=rcode)
   deallocate(map_out%mask_a,STAT=rcode)
   deallocate(map_out%area_a,STAT=rcode)

   deallocate(map_out%  xc_b,STAT=rcode)
   deallocate(map_out%  yc_b,STAT=rcode)
   deallocate(map_out%  xv_b,STAT=rcode)
   deallocate(map_out%  yv_b,STAT=rcode)
   deallocate(map_out%mask_b,STAT=rcode)
   deallocate(map_out%area_b,STAT=rcode)

   deallocate(map_out%frac_a,STAT=rcode)
   deallocate(map_out%frac_b,STAT=rcode)

   deallocate(map_out%s     ,STAT=rcode)
   deallocate(map_out%row   ,STAT=rcode)
   deallocate(map_out%col   ,STAT=rcode)
   deallocate(map_out%sn1   ,STAT=rcode)
   deallocate(map_out%sn2   ,STAT=rcode)

   !------------------------------------------------
   ! allocate space for smoothing matrix (must guess its size)
   !------------------------------------------------
   allocate(i_count(map_in%n_b))
   i_count = 0
   do n=1,map_in%n_s
      i = map_in%row(n)
      if (map_in%s(n) > 0.0) i_count(i) = i_count(i) + 1
   end do
   nactive = count(i_count > 0) ! number of ocn cells that might get mapped to
   deallocate(i_count)
!  nactive = count(map_in%mask_b > 0) ! number of active ocn cells
!  nactive = map_in%n_s               ! number of ocn cells receiving runoff (an upper bound)
!  ns = nactive*(map_in%n_b/(20*20)) ! (about 1000 miles/1000 miles smoothing) guess a sufficient size for smoothing matrix
!  ns = nactive*10000
!  ns = nactive*1000
   ns = 2147000000  ! max 4-byte int
   write(*,*) subName,' orig matrix a-domain n active: ',count(map_in%mask_a > 0)
   write(*,*) subName,' orig matrix b-domain n active: ',count(map_in%mask_b > 0)
   write(*,*) subName,' orig matrix a-domain size    : ',map_in%n_a
   write(*,*) subName,' orig matrix b-domain size    : ',map_in%n_b
   write(*,*) subName,' orig matrix            ns    : ',map_in%n_s
   write(*,*) subName,' smoothing matrix guess ns    : ',ns
   write(*,*) subName,' nactive                      = ',nactive
!  write(*,*) subName,' map_in%n_b                   = ',map_in%n_b

   allocate(map_out%  xc_a(  map_in%n_b) )
   allocate(map_out%  yc_a(  map_in%n_b) )
   allocate(map_out%  xv_a(4,map_in%n_b) )
   allocate(map_out%  yv_a(4,map_in%n_b) )
   allocate(map_out%mask_a(  map_in%n_b) )
   allocate(map_out%area_a(  map_in%n_b) )

   allocate(map_out%  xc_b(  map_in%n_b) )
   allocate(map_out%  yc_b(  map_in%n_b) )
   allocate(map_out%  xv_b(4,map_in%n_b) )
   allocate(map_out%  yv_b(4,map_in%n_b) )
   allocate(map_out%mask_b(  map_in%n_b) )
   allocate(map_out%area_b(  map_in%n_b) )

   allocate(map_out%frac_a(map_in%n_b) )
   allocate(map_out%frac_b(map_in%n_b) )

   allocate(map_out%s  (ns))
   allocate(map_out%row(ns))
   allocate(map_out%col(ns))
   allocate(map_out%sn1(map_in%n_b) )
   allocate(map_out%sn2(map_in%n_b) )

   !------------------------------------------------
   ! set values
   !------------------------------------------------
   map_out%   n_a = map_in%   n_b
   map_out%  ni_a = map_in%  ni_b
   map_out%  nj_a = map_in%  nj_b
   map_out%  xc_a = map_in%  xc_b
   map_out%  yc_a = map_in%  yc_b
   map_out%  xv_a = map_in%  xv_b
   map_out%  yv_a = map_in%  yv_b
!  map_out%mask_a = map_in%mask_b ! all active ocn cells
   map_out%area_a = map_in%area_b

   !--- compute minimal src domain mask for smoothing matrix ---
   jmd_count = 0
   map_out%mask_a = 0
   do n=1,map_in%n_s
      i = map_in%row(n)     ! this ocn cell could get runoff
      map_out%mask_a(i) = 1 ! this ocn cell's runoff get's smoothed
      if(map_in%s(n) > 0.0) then 
        jmd_count = jmd_count+1
      endif
   end do
   write(*,*) subName,'number of source points is =  ',jmd_count
   write(*,*) subName,'map_in%ns                  =  ',map_in%n_s

   map_out%   n_b = map_in%   n_b
   map_out%  ni_b = map_in%  ni_b
   map_out%  nj_b = map_in%  nj_b
   map_out%  xc_b = map_in%  xc_b
   map_out%  yc_b = map_in%  yc_b
   map_out%  xv_b = map_in%  xv_b
   map_out%  yv_b = map_in%  yv_b
   map_out%mask_b = map_in%mask_b
   map_out%area_b = map_in%area_b

!  map_out%frac_a = map_in%frac_b
!  map_out%frac_b = map_in%frac_b
   map_out%frac_a = 1.0
   map_out%frac_b = 1.0

   map_out%n_s    = ns
   map_out%s      = 1.0
   map_out%row    = 1
   map_out%col    = 1
   map_out%sn1    = map_in%sn1
   map_out%sn2    = map_in%sn2

   map_out%title      = "CCSM conservative smoothing map"
   map_out%normal     = map_in%normal
   map_out%method     = "created using SVN $Id: smooth_mod.F90 44128 2013-02-22 15:43:14Z mlevy@ucar.edu $"
   map_out%history    = map_in%history
   map_out%convention = map_in%convention
   map_out%domain_a   = map_in%domain_b
   map_out%domain_b   = map_in%domain_b

END SUBROUTINE smooth_init

!===============================================================================

SUBROUTINE smooth(map,efold,rmax)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       
   real(kind=r8), intent(in) :: efold                    ! efold scale (m)
   real(kind=r8), intent(in) :: rmax                     ! max smoothing distance (m)

   !--- local ---
   integer         :: n ! loop over matrix elements
   integer         :: i,j,i0,i1,j0,j1,ic,jc,itmp,jtmp,k
   integer         :: ii,jj,ip,np,ni,nj,n_s,ngood,nbox
   integer         :: itest,jtest,k1,k2,k3,k4,gdcnt,cnt
   integer         :: mingd,maxgd,avggd,mingdi,mingdj,maxgdi,maxgdj
   integer         :: minbx,maxbx,minbxi,minbxj,maxbxi,maxbxj
   integer         :: onegd,nactivea,nactiveb,ntot
   integer, allocatable :: iind(:),jind(:),imask(:,:)
   integer, allocatable :: imask_jmd(:,:)
   real(r8), allocatable :: rdist(:,:),areaa(:,:),wgt(:,:),wgt2(:,:)
   real(r8), allocatable :: diff(:,:)
   real(r8), allocatable :: s(:),row(:),col(:)
   real(r8) :: wgtsum
   real(r8), parameter :: rmiss = 1.e30

   integer :: length
   integer, allocatable :: i2ind(:),j2ind(:)
   integer, allocatable :: indxLinear(:,:)
   integer :: t00
   integer :: i2,j2

   integer,allocatable :: nDest(:)    ! diag: # of cells (size of smoothed footprint)
   integer :: minDest,maxDest,avgDest ! diag: min,max,avg # of cells (in smoothed footprint)
   integer :: nDest10, nDest100, nDest1000, nDest10000 ! for diag of size of footprint

   integer         :: nMod  ! for time-stamp progress report
   character( 8)   :: dstr  ! wall clock date
   character(10)   :: tstr  ! wall clock time

   !--- formats ---
   character(*),parameter :: F00 = "('(smooth) ',4a)"
   character(*),parameter :: F1  = "('(smooth) ',a,2i11)"
   character(*),parameter :: F2  = "('(smooth) ',a,2F11.6)"
   character(*),parameter :: F3  = "('(smooth) ',a,es18.7)"
   character(*),parameter :: F6  = "('(smooth) ',a,3i6,es18.7,i6)"
   character(*),parameter :: F9  = "('(smooth) ',a,i6,' @  (',i8,',',i8,')')"
   character(*),parameter :: F12 = "('(smooth) ',1x,a4,2('-',a2),2x,a2,2(':',a2),' j=',i9,', ',f7.3,'% complete')"

   character(*),parameter :: subName = "(smooth) "

   integer :: level
   integer :: strPtr
   integer :: kStart
!-------------------------------------------------------------------------------
! PURPOSE:
! o Given a square sMatrix, map, generate the links for local smoothing
!   of input fluxes with following properties:
!       -must be conservative
!       -must redistribute onto active points only 
!       -uses a 2D Gaussian defined by efold & rmax for weights
!       -weights are a function of shortest active distance, so that
!        weights are zero across land isthmuses
!
!             -------------------------------------------------
!             |               |               |               |
!             |               |               |               |
!             |               |               |               |
!             |   ip=2        |    ip=3       |    ip=4       |
!    j1       |               |               |       ^       |
!             |               |               |       |       |
!             |               |               |       |d2     |
!             |               |               |       |       |
!             ----------------------------------------|--------
!             |               |               |       |       |
!             |               |               |       |       |
!             |   ip=1        |   (ic,jc)     |    (ii,jj)    |
!             |               |               |d1     |       |  d3
!             |               |    source<------------x-------|------->
!             |               |    cell       |       |       |
!             |               |               |    ip=5       |
!             |               |               |       |       |
!             ----------------------------------------|--------
!             |               |               |       |d4     |
!             |               |               |       |       |
!             |   ip=8        |    ip=7       |    ip=6       |
!    j0       |               |               |       |       |
!             |               |               |       v       |
!             |               |               |               |
!             |               |               |               |
!             |               |               |               |
!             -------------------------------------------------
!
!                    i0                              i1
!
!-------------------------------------------------------------------------------

   ni = map%ni_a
   nj = map%nj_a
   allocate(iind(map%n_a))
   allocate(jind(map%n_a))
   allocate(wgt  (ni,nj))
   allocate(wgt2 (ni,nj))
   allocate(diff (ni,nj))
   allocate(rdist(ni,nj))
   allocate(areaa(ni,nj))
   allocate(imask(ni,nj))
   allocate(imask_JMD(ni,nj))
   do j=1,map%n_a
      iind(j) = mod(j-1,ni)+1
      jind(j) = int((j-1)/ni)+1
      imask(iind(j),jind(j)) = map%mask_b(j)
      areaa(iind(j),jind(j)) = map%area_a(j)
   enddo



   length = 0  
   allocate(i2ind(maxLinear))
   allocate(j2ind(maxLinear))
   allocate(indxLinear(ni,nj))
   i2ind=0;j2ind=0
#ifdef _NEW
   do i=1,map%n_b
       ii = iind(i)
       jj = jind(i)
       indxLinear(ii,jj) = i    
   end do
#endif


   itest = 70
   jtest = 87

   n_s = 0
   minbx = 1000
   maxbx = 0
   mingd = 1000
   maxgd = 0
   avggd = 0
   onegd = 0
   write(6,F1) 'ni = ',ni
   write(6,F1) 'nj = ',nj
   write(6,F1) 'n_a = ',map%n_a
   write(6,F1) 'n_b = ',map%n_b
   write(6,F1) 'n_s = ',map%n_s
   write(6,F2) 'range(xc_a) = ',minval(map%xc_a(1:map%n_a)), &
  &     maxval(map%xc_a(1:map%n_a))
   write(6,F2) 'range(yc_a) = ',minval(map%yc_a(1:map%n_a)), &
  &     maxval(map%yc_a(1:map%n_a))
   write(6,F2) 'using efold (km) of = ',efold/1000.
   write(6,F2) 'using max radius (km) of = ',rmax/1000.

   !----------------------------------------------------------------------------
   ! compute smoothing matrix
   !----------------------------------------------------------------------------
   call shr_timer_get  (t00,subName//"compute smoothing matrix")
   call shr_timer_start(t00)

   !--- set up progress report print interval ---
   nMod = 1
   do while ( map%n_a > 500*nMod) ! want between 50 & 500 print statements
      nMod = 10*nMod
   end do
!  write(*,*) subName,"nMod = ",nMod
   nMod = 1000

   do j=1,map%n_a ! loop over all source points

     !--- progress report ---
     if (mod(j-1,nMod)==0) then
        call date_and_time(dstr,tstr)
        write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8),tstr(1:2),tstr(3:4),tstr(5:6),j,100.0*float(j)/float(map%n_a)
     endif

     if (map%mask_a(j) /= 0) then ! only consider active source points
        !-------------------------------------------------------------
        ! find all cells within max radius of a given src cell j
        !-------------------------------------------------------------

        ic = iind(j)
        jc = jind(j)
        length = 1  
        j2ind=0;i2ind=0

        rdist = 0.0
        wgt = 0.0
        wgt2 = 0.0
        wgtsum = 0.0
        nbox = 0
        gdcnt = 0

#ifdef _BREADTH
        kStart = 2
        i2ind(1) = ic
        j2ind(1) = jc
        imask_JMD = -1000
        where(imask ==  1) imask_JMD = -1
        level = 1
        strPtr=1
        imask_JMD(ic,jc) = 0
        call breadth_setDist(ni,nj,level,map%xc_a,map%yc_a,imask_JMD, &
                rdist,rmax,i2ind,j2ind, strPtr, length)

#else
        kStart = 1
        !--- recursive function to find dest cells ---
      
        call depth_setDist(ic,jc,ni,nj,map%xc_a,map%yc_a,0.0,imask,rdist,rmax,i2ind,j2ind,length)
#endif

!        print *,'smooth: after _setDist: length is: ',length-kStart+1  
        if(length > maxLinear) then 
           print *,'Error need to increase maxLinear length is:', length-kStart+1 
        endif

#if _DBG
        print *,'source point: ',ic,jc
        do k=kStart,length
           i2 = i2ind(k) 
           j2 = j2ind(k) 
           print *,'neighbor points: (i,j): ',i2,j2,rdist(i2,j2)
        enddo
        stop 'smooth: After first call to _setDist'
#endif

#ifdef _NEW
       !-------------------------------------------------------------
       ! 1st pass computing smoothing matrix weights for column j
       !-------------------------------------------------------------
       wgtsum = 0.d0
       do k = kStart,length ! loop over destination points for input cell j
          ii = i2ind(k)  
          jj = j2ind(k)  
          wgt(ii,jj) = exp(-rdist(ii,jj)/efold)*areaa(ii,jj)
          wgtsum = wgtsum + wgt(ii,jj) 
       enddo

       !-------------------------------------------------------------
       ! final pass computing smoothing matrix weights for column j
       !-------------------------------------------------------------
       do k=kStart,length ! loop over destination points for input cell j
          ii = i2ind(k)
          jj = j2ind(k)
          i2 = indxLinear(ii,jj)
          n_s = n_s + 1
          if (n_s > map%n_s) then
              write(6,F1)  'ERROR: smoothing matrix n_s > ',map%n_s
              write(6,F00) 'ERROR: initial guess of matrix size is too small'
              stop 'subName'
          end if
!         write(6,F1) 'n_s = ',n_s
          map%s(n_s) = (map%area_a(j)/map%area_b(i2))*(wgt(ii,jj)/wgtsum)
          map%col(n_s) = j
          map%row(n_s) = i2
       end do
#else
       !-------------------------------------------------------------
       ! 1st pass computing smoothing matrix weights for column j
       !-------------------------------------------------------------
       where(rdist < 1.e10)
          wgt = exp(-rdist/efold)*areaa
       end where
       wgtsum = sum(wgt)

       !-------------------------------------------------------------
       ! final pass computing smoothing matrix weights for column j
       !-------------------------------------------------------------
       do i=1,map%n_b ! loop over all output domain cells
          ii = iind(i)
          jj = jind(i)
          if (wgt(ii,jj) > 0.0) then
             n_s = n_s + 1
!            write(6,F1) 'n_s = ',n_s
             map%s(n_s) = (map%area_a(j)/map%area_b(i))*(wgt(ii,jj)/wgtsum)
             map%col(n_s) = j
             map%row(n_s) = i
          endif
       end do
#endif
! 
!     else              
!        !---------------------------------------------------
!        ! if mask_a == 0 (is not considered for smoothing)
!        ! but mask_b != 0 (is an active ocn point)
!        ! then fill in 1.0 on diagonal 
!        !      just in case runoff appears where mask_a == 0
!        !---------------------------------------------------
!        ! BK: comment out this else-option...
!        ! don't put 1's on the diagonal -- rather assume that
!        ! if mask_a == 0 (is not considered for smoothing)
!        ! then no runoff will appear in this cell
!        !---------------------------------------------------
!        if(map%mask_b(j) /= 0) then
!           n_s = n_s + 1
!           ii = iind(j)
!           jj = jind(j)
!           map%s(n_s) = 1.0
!           map%col(n_s) = j
!           map%row(n_s) = j
!        endif
      endif                !  if mask_a /= 0
   enddo                !  loop over j=1,map%n_a
   call shr_timer_stop (t00)


   write(6,F3) "done.       "

   !----------------------------------------------------------------------------
   ! document the basic properties of the smoothing matrix
   !----------------------------------------------------------------------------
   allocate(nDest(map%n_a))
   nDest(:) = 0
   do n=1,n_s  ! loop over all non-zero matrix elements
      j = map%col(n)          ! corresponding src cell
      nDest(j) = nDest(j) + 1 ! count # dest cells for each src cell 
   end do 

   n = 0
   minDest = n_s
   maxDest = 0
   avgDest = 0
   nDest10    = 0
   nDest100   = 0
   nDest1000  = 0
   nDest10000 = 0
   do j=1,map%n_a  ! loop over all input grid cells
      if (nDest(j) > 0) then
         n = n + 1
         minDest = min(minDest,nDest(j))
         maxDest = max(maxDest,nDest(j))
         avgDest = avgDest +   nDest(j)
         if      (nDest(j) < 10 ) then
            nDest10    = nDest10    + 1
         else if (nDest(j) < 100 ) then
            nDest100   = nDest100   + 1
         else if (nDest(j) < 1000) then
            nDest1000  = nDest1000  + 1
         else 
            nDest10000 = nDest10000 + 1
         end if
      end if
   end do 
   deallocate(nDest)
   avgDest = nint(avgDest/float(n))
 ! avggd = int(avggd/count(map%mask_a == 1))

   write(6,F1) "map n_s   = ",n_s
   write(6,F3) "min wgt     ",minval(wgt)
   write(6,F3) "max wgt     ",maxval(wgt)
   write(6,F3) "wgtsum      ",wgtsum
   write(6,F3) "min S       ",minval(map%s  (1:n_s))
   write(6,F3) "max S       ",maxval(map%s  (1:n_s))
   write(6,F1) "min row     ",minval(map%row(1:n_s))
   write(6,F1) "max row     ",maxval(map%row(1:n_s))
   write(6,F1) "min col     ",minval(map%col(1:n_s))
   write(6,F1) "max col     ",maxval(map%col(1:n_s))
   write(6,*) subName,"min # dst cells per src cell = ",minDest
   write(6,*) subName,"max # dst cells per src cell = ",maxDest
   write(6,*) subName,"avg # dst cells per src cell = ",avgDest
   write(6,*) subName,"# src cells smoothed to   0-  9 cells = ",nDest10
   write(6,*) subName,"# src cells smoothed to  10- 99 cells = ",nDest100
   write(6,*) subName,"# src cells smoothed to 100-999 cells = ",nDest1000
   write(6,*) subName,"# src cells smoothed to   > 999 cells = ",nDest10000

!  write(6,F9) "min # dest pts : ",
!  write(6,F9) "min # dest pts : ",mingd,mingdi,mingdj
!  write(6,F9) "max # dest pts : ",maxgd,maxgdi,maxgdj
!  write(6,F6) "avg # dest pts : ",avggd
!  write(6,F6) "src # having only 1 dest  : ",onegd
!  write(6,F9) "min # boxes    : ",minbx,minbxi,minbxj
!  write(6,F9) "max # boxes    : ",maxbx,maxbxi,maxbxj
!  write(6,F1) 'now, cnt = ',cnt

   !----------------------------------------------------------------------------
   ! dealloc work arrays, resize the mapping, now that its size is known
   !----------------------------------------------------------------------------
   deallocate(wgt)
   deallocate(rdist)
   deallocate(iind)
   deallocate(jind)
   deallocate(i2ind,j2ind)

   allocate(s  (n_s))
   allocate(row(n_s))
   allocate(col(n_s))
   s   = map%s  (1:n_s)
   row = map%row(1:n_s)
   col = map%col(1:n_s)

   deallocate(map%s)
   deallocate(map%row)
   deallocate(map%col)
   map%n_s = n_s
   allocate(map%s  (n_s))
   allocate(map%row(n_s))
   allocate(map%col(n_s))

   map%s   = s
   map%row = row
   map%col = col
   deallocate(s)
   deallocate(row)
   deallocate(col)

   write(6,F00) 'exit subroutine.'

END SUBROUTINE smooth

!===============================================================================

integer FUNCTION iadd(i,di,ni)

   implicit none

   !--- arguments ---
   integer :: i, di, ni

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   if (di < 0) then
     iadd = mod(i+di-1+ni,ni)+1
   else
!    why was this coded like this??
!    iadd = mod(i,ni)+di
     iadd = mod(i+di,ni)
   endif

END FUNCTION iadd

!===============================================================================

integer FUNCTION jadd(j,dj,nj)

   implicit none

   !--- arguments ---
   integer :: j, dj, nj

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   if (dj < 0) then
     jadd = max(j+dj,1)
   else
     jadd = min(j+dj,nj)
   endif

END FUNCTION jadd

!===============================================================================

real(r8) FUNCTION distance(x0,y0,x1,y1)

   implicit none

   !--- arguments ---
   real(r8), intent(in) :: x0,y0,x1,y1

   !--- local ---
   real(r8) :: dph,dth,myx0,myx1

!-------------------------------------------------------------------------------
! PURPOSE:
!  o Return the distance in meters between two points on the
!    Earth with coordinates (x0,y0) and (x1,y1) in degrees.
!  o NOTE: does not take into account curvature of the grid...
!-------------------------------------------------------------------------------

   myx0 = x0
   myx1 = x1
   if (x1-x0>180.0) myx0 = x0 + 360.0
   if (x0-x1>180.0) myx1 = x1 + 360.0
   dph  = (myx1-myx0)*cos(DtoR*(y0+y1)/2.0)
   dth  = (y1-y0)
   distance = sqrt(dth**2 + dph**2)*DtoR*rEarth

END FUNCTION distance

!===============================================================================

real(r8) FUNCTION falloff(x1,y1,x2,y2,s)

   implicit none

   !--- arguments ---
   real(r8), intent(in) :: x1,y1,x2,y2,s
   real(r8) :: dr

!-------------------------------------------------------------------------------
! PURPOSE:
!  o Compute exponential fall-off factor given two lon/lat
!    oordinates (x1,y1) and (x2,y2) in degrees.
!  o NOTE: does not take into account curvature of the grid...
!  o Function is g(d) = exp(-d/s)
!                       for distance d, efold scale length s (m)
!-------------------------------------------------------------------------------

    dr = distance(x1,y1,x2,y2)
    falloff = exp(-dr/s)

end FUNCTION falloff

!===============================================================================

SUBROUTINE test_smooth(map,field,value,source)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(in) :: map     ! smoothing map     
   real(r8), intent(inout) :: field(:,:)    ! output flux field
   real(r8), intent(in) :: value            ! source flux value
   integer, intent(in) :: source(:,:)   ! source points

   !--- local ---
   integer :: i,n,isrc,jsrc,idst,jdst
   integer :: nsrc
   integer, allocatable :: mask(:,:)

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   nsrc = size(source,2)
   field = 0.0
   allocate(mask(map%ni_b,map%nj_b))
   mask = reshape(map%mask_b,(/map%ni_b,map%nj_b/))
   do n=1,map%n_s
       isrc = mod(map%col(n)-1,map%ni_a)+1
       jsrc = int((map%col(n)-1)/map%ni_a)+1
       idst = mod(map%row(n)-1,map%ni_b)+1
       jdst = int((map%row(n)-1)/map%ni_b)+1
       do i=1,nsrc
         if (isrc == source(1,i) .and. jsrc == source(2,i)) then
            field(idst,jdst) = field(idst,jdst)+map%s(n)*value
         endif
       enddo
   end do

   where(mask == 0) field = 1.e30

END SUBROUTINE test_smooth

!===============================================================================

SUBROUTINE smooth_field_write(map,field,filename)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(in) :: map       ! smoothing map
   real(r8), intent(in) :: field(:,:)         ! output flux field
   character(*) , intent(in) :: filename  ! name of data file

   !--- local ---
   integer :: i,m,n,isrc,jsrc,idst,jdst
   integer :: nsrc
   real(r8)    :: spv                         ! field missing value
   character(len= 8)     :: cdate   ! wall clock date
   character(len=10)     :: ctime   ! wall clock time
   character(len=240)     :: str     ! variable length char string
   character(len=240)     :: attstr  ! netCDF attribute name string
   integer                :: rcode   ! netCDF routine return code
   integer                :: fid     ! netCDF file      ID
   integer                :: vid     ! netCDF variable  ID
   integer                :: did     ! netCDF dimension ID
   integer                :: vdid(2) ! netCDF dimension ID

   !--- formats ---
   character(len=*),parameter :: F00 = "('(map_write) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o writes a field computed from smoothing "map" for viewing
! o assumes field grid is equivalent to b grid of "map"
!-------------------------------------------------------------------------------
   
   spv = maxval(field)

   !-----------------------------------------------------------------
   ! create a new nc file
   !-----------------------------------------------------------------
!  rcode = nf_create(trim(filename),NF_CLOBBER,fid)
   rcode = nf_create(trim(filename),IOR(NF_CLOBBER,NF_64BIT_OFFSET),fid)
   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)

   !-----------------------------------------------------------------
   ! global attributes
   !-----------------------------------------------------------------
    str  = map%title
   rcode = nf_put_att_text(fid,NF_GLOBAL,'title'      ,len_trim(str),str)
    str  = map%normal
   rcode = nf_put_att_text(fid,NF_GLOBAL,'normalization',len_trim(str),str)
    str  = map%method
   rcode = nf_put_att_text(fid,NF_GLOBAL,'map_method' ,len_trim(str),str)
    str  = map%history
   call date_and_time(cdate,ctime) ! f90 intrinsic
    str = 'File created: '//cdate(1:4)//'-'//cdate(5:6)//'-'//cdate(7:8) &
   &                 //' '//ctime(1:2)//':'//ctime(3:4)//':'//ctime(5:6)
   rcode = nf_put_att_text(fid,NF_GLOBAL,'history'    ,len_trim(str),str)
    str  = map%convention
   rcode = nf_put_att_text(fid,NF_GLOBAL,'conventions',len_trim(str),str)
    str  = map%domain_a
   rcode = nf_put_att_text(fid,NF_GLOBAL,'domain_a'   ,len_trim(str),str)
    str  = map%domain_b
   rcode = nf_put_att_text(fid,NF_GLOBAL,'domain_b'   ,len_trim(str),str)

   !-----------------------------------------------------------------
   ! dimension data
   !-----------------------------------------------------------------
   rcode = nf_def_dim(fid, 'ni_b', map%ni_b, did) ! # of points wrt i
   rcode = nf_def_dim(fid, 'nj_b', map%nj_b, did) ! # of points wrt j

   !-----------------------------------------------------------------
   ! define data 
   !-----------------------------------------------------------------

   rcode = nf_inq_dimid(fid,'ni_b',vdid(1))
   rcode = nf_inq_dimid(fid,'nj_b',vdid(2))
   rcode = nf_def_var  (fid,'field',NF_DOUBLE,2,vdid,vid)
   str   = 'output of call to test_smooth'
   rcode = nf_put_att_text(fid,vid,"description",len_trim(str),str)
   rcode = nf_put_att_double(fid,vid,"missing_value",NF_FLOAT,1,spv)

   !-----------------------------------------------------------------
   ! put data
   !-----------------------------------------------------------------
   rcode = nf_enddef(fid)

   rcode = nf_inq_varid     (fid,  'field',vid)
   rcode = nf_put_var_double(fid, vid, field) 

   rcode = nf_close(fid)

   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)

END SUBROUTINE smooth_field_write

!===============================================================================

SUBROUTINE dummyflux(imt,jmt,mask,xt,yt,at,runfile,efold)

!-------------------------------------------------------------------------------
!    Based on gconst of /home/dataproc/yeager/RUNOFF/fortran/garray.f
!    which was invoked as a shared object by the NCL routine
!    /home/dataproc/yeager/RUNOFF/construct_runoff_netcdf_dummy.ncl
!
! PURPOSE:
!  o Construct runoff mapping based on a 'runfile' data file which
!    partitions known river runoffs into a 19-basin scheme by Large. 
!  o runfile specifies rivers/coastal discharges (kg/s) for each basin along
!    with lon/lat boxes within which this discharge is to be distributed.
!    The distribution array is g(:,:,:) with units (kg/s/m^2).
!    This routine distributes 'coastal' runoff as:
!
!        g(i,j,thisbasin) = [total coastal discharge (kg/s)]/[total
!                               distribution area (m^2)]                
!
!    This routine distributes 'river' runoff as:
!
!        g(i,j,thisriver) = [exponential falloff factor]*[total river 
!                               discharge (kg/s)]/[total exponential-weighted
!                               distribution area (m^2)]     
!
!    Areas (from array at) are based on ocean grid TAREA.
!  
!-------------------------------------------------------------------------------

   !--- local ---
   integer :: imt,jmt,jm,jp,im,ip,nr,n,i,j
   real(r8)    :: rlat,rlon,xf
   integer, dimension(imt,jmt) :: mask  ! mask of grid (0 for land)
   real(r8), dimension(imt,jmt) :: xt,yt    ! lon,lat of grid
   real(r8), dimension(imt,jmt) :: at       ! area of grid (m^2)
   real(r8), dimension(imt,jmt) :: A        ! masked out area array
   real(r8), dimension(imt,jmt) :: fi       ! exponential factor
   real(r8), allocatable :: total(:)        ! total runoff by basin (kg/s)
   character*47 :: runfile
   character*27 :: rname
   integer, parameter :: nrmax=70       ! max number of rivers
   integer :: nb,nbo,ibasin,nrivers,msea
   real(r8) :: efold                        ! efold scale (m) for falloff
   real(r8) :: rarea                        ! sum of destination cell areas
   real(r8) :: firarea                      ! exponential-weighted sum of 
                                        ! destination cell areas
   real(r8) :: sumb,sumd,gmax
   real(r8), dimension(2,nrmax) :: blon,blat
   real(r8), dimension(nrmax) :: clon,clat,nref,discharge
   character*40, allocatable :: bname(:)        

!-------------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

   ! Check that received grid lon/lat arrays are reasonable
   if (minval(xt).lt.0.0 .or. maxval(xt).gt.360.0) then
      write(6,*) 'xt out of range'
      stop
   endif
   if (minval(yt).lt.-90.0 .or. maxval(yt).gt.90.0) then
      write(6,*) 'yt out of range'
      stop
   endif

   open(13,file=runfile,status='old',form='formatted')
   read(13,*)
   read(13,*) nbo
   nb = nbo+1           ! nbo seperate basins, plus global
   allocate(garr(imt,jmt,nb))
   allocate(total(nb))
   allocate(bname(nb))
   total = 0.0
   garr = 0.0

   bname(1) = '    Global'

   ! Process each of the basins
   do n=2,nb
     read(13,99) ibasin,nrivers,msea,clon(1),clat(1),bname(n)
     sumd = 0.0
     do nr=1,nrivers
       read (13,100) nref(nr),rname,discharge(nr),clon(nr),clat(nr), &
     &        blon(1,nr),blon(2,nr),blat(1,nr),blat(2,nr)
       sumd = sumd + discharge(nr)
     enddo
     total(n) = sumd    ! includes coastal runoff

     do nr=1,nrivers
       xf = discharge(nr) / sumd        
       rarea = 0.0
       firarea = 0.0
       do j=1,jmt
         do i=1,imt
!             m=(j-1) * (imt-2) + i - 1
           rlon = xt(i,j)
           rlat = yt(i,j)
           if (blon(1,nr).lt.0.0.and.xt(i,j).gt.180.) rlon = xt(i,j)-360.0

           ! If the grid point lies in the specified lon/lat box
           ! where the discarge is to be distributed...
           if ((blat(1,nr).le.rlat).and.(rlat.le.blat(2,nr)).and. &
     &         (mask(i,j).ne.0).and.(blon(1,nr).le.rlon).and. &
     &         (rlon.le.blon(2,nr))) then

              if (nref(nr).eq.0) then   ! for Coastal runoff
                                        ! check that destination cell
                                        ! is adjacent to land
                jm = jadd(j,-1,jmt)
                jp = jadd(j,1,jmt)
                im = iadd(i,-1,imt)
                ip = iadd(i,1,imt)
!       exception for (OLD) grids with wraparound points
        if ((imt.eq.102.or.imt.eq.152).and.i.eq.1) im = imt-1
        if ((imt.eq.102.or.imt.eq.152).and.i.eq.imt) ip = 2

                if ((mask(im,j).eq.0).or.(mask(im,jp).eq.0) &
     & .or.(mask(i,jp).eq.0).or.(mask(ip,jp).eq.0).or. &
     & (mask(ip,j).eq.0).or.(mask(ip,jm).eq.0).or. &
     & (mask(i,jm).eq.0).or.(mask(im,jm).eq.0)) then 
                  A(i,j) = at(i,j)
                  rarea = rarea + A(i,j)
                else
                  A(i,j) = 0.0
                endif
              else                      ! for River runoff
                 A(i,j)  = at(i,j)
                 rarea = rarea + A(i,j)     
                 fi(i,j) = falloff(rlon,rlat,clon(nr),clat(nr),efold)
                 firarea = firarea + fi(i,j)*A(i,j)     
              endif
           else
              A(i,j)  = 0.0
              fi(i,j)  = 0.0
           endif
         enddo
       enddo

       do j=1,jmt
         do i=1,imt
           !  for unitless 
           !  garr(i,j,n) = garr(i,j,n) + xf * A(i,j) / rarea
           !  for [kg/m^2/s]
           if (A(i,j) .gt. 0.) then
             if (nref(nr).eq.0) then
               garr(i,j,n) = garr(i,j,n) + discharge(nr)/rarea
             else
               garr(i,j,n) = garr(i,j,n) + fi(i,j)*discharge(nr) / firarea
             endif
           endif
         enddo
       enddo

     enddo     ! do nr=1,nrivers
   enddo       ! do n=2,nb

! Compute global total runoff
   do n=2,nb
     total(1) = total(1) + total(n)
   enddo
   do j=1,jmt
     do i=1,imt
       do n=2,nb
          garr(i,j,1) = garr(i,j,1) + garr(i,j,n)
       enddo
     enddo
   enddo

! Test runoff conservation and write summary table to runoff.doc
   write(6,*) 'Results of Data Runoff Distribution:'
   write(6,101) 'Basin','Global g*area (kg/s)','Data (kg/s)','Difference'
   do n=1,nb
     gmax = 0.0
     sumb = 0.0
     do j=1,jmt
       do i=1,imt
         sumb = sumb + garr(i,j,n)*at(i,j)
         if (garr(i,j,n).gt.gmax) gmax = garr(i,j,n)
       enddo
     enddo
     write(6,102) n,bname(n),sumb,total(n),(sumb - total(n))
   enddo

99     format(3i4,2f8.1,a30)
100    format(i4,2x,a27,f12.1,6f7.1)
101    format(a10,11x,a25,4x,a11,4x,a17)
102    format(i2,2x,a26,2x,f14.3,3x,f14.3,3x,f14.3)

END SUBROUTINE dummyflux

!===============================================================================

SUBROUTINE dummyweights(map,at)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map  ! scrip map template to be filled
   real(r8)         :: at(:,:)              ! ocn TAREA in m^2

   !--- local ---
   integer :: ni,nj,imt,jmt,i,j,m,n_s,nbasin
   real(r8)    :: sumb
   real(r8), allocatable  :: col(:,:),row(:,:),s(:,:),garr2d(:,:)
   real(r8), allocatable  :: col1d(:),row1d(:),s1d(:),cplratio(:),at1d(:)
   logical, allocatable  :: smask(:,:)
   real(r8), allocatable  :: total(:)

!-------------------------------------------------------------------------------
! PURPOSE:
! o Based on M. Hecht's /fs/cgd/home0/hecht/csm/runoff/transfer_matrix.ncl
! o Compute correct weights to map 19-element 'normalized' runoff flux vector 
!   (kg/s/m^2) onto the POP ocean grid.  
!
!       R(j)  = net runoff (kg/s) into basin j
!       dA(j) = fictitious area (m^2) associated with basin j (1/19 of globe)
!               from scrip
!       F(j)  = "flux" sent to cpl by dlnd = R(j)/dA(j) (kg/s/m^2)
!               (This flux is stored in the data_aroff netcdf file)
!       garr(i)  = flux which should go into ocean cell i, as determined by
!                routine dummyflux (sum over i is known to preserve R when
!                multiplied by ocean areas!)
!       dA_o(i) = area (m^2) associated with ocean cell i, from POP
!       dA_s(i) = area (m^2) associated with ocean cell i, from scrip
!
!   Then in order to preserve R(i), the mapping weights should be
!       s(i,j) = dA(j)*[garr(i)/R(j)]*[dA_o(i)/dA_s(i)]
!
!   The "flux" mapping, then will be:
!       Fo(i) = sum_over_j{s(i,j)*F(j)} 
!             = sum_over_j{dA(j)   garr(i)    dA_o(i)   R(j)  }
!                         {     * --------- * ------- * ----  }
!                         {        R(j)       dA_s(i)   dA(j) }
!             = garr(i) * dA_o(i)/dA_s(i)
!
!   Before sending to the ocean, the couple will multiply Fo(i) by
!   an area correction factor, so that
!       F*o(i) = runoff flux received by ocean model (kg/s/m^2)
!              = Fo(i) * dA_s(i)/dA_o(i)
!              = garr(i), by definition the correct flux into ocean cell i
!
!   Therefore, sum_over_i{F*o(i)*dAo(i)} = sum_over_j{R(j)}
!                
!-------------------------------------------------------------------------------

   imt = map%ni_b
   jmt = map%nj_b
   ni = map%ni_a
   nj = map%nj_a
   
   allocate(col(map%n_b,map%n_a))
   allocate(row(map%n_b,map%n_a))
   allocate(s(map%n_b,map%n_a))
   allocate(total(map%n_a))
   allocate(smask(map%n_b,map%n_a))
   nbasin = size(garr,3) 
   allocate(garr2d(map%n_b,nbasin-1))
   allocate(cplratio(map%n_b))
   allocate(at1d(map%n_b))

   ! This is the areafact ratio that cpl will multiply
   ! runoff flux with before sending to ocean
   cplratio = (map%area_b*(rEarth**2))/reshape(at,(/map%n_b/))
   
   garr2d = reshape(garr(:,:,2:nbasin),(/map%n_b,nbasin-1/))
   at1d = reshape(at,(/map%n_b/))

   !-----------------------------------------------------------------
   ! compute the 19-basin total runoffs (kg/s)
   !-----------------------------------------------------------------
   do j=1,map%n_a
     sumb = 0.0
     do i=1,map%n_b
       sumb = sumb + garr2d(i,j)*at1d(i)
     enddo
     total(j) = sumb
   enddo

   ! Using garr, fill in the mapping matrix
   do i=1,map%n_b
     do j=1,map%n_a
       col(i,j) = j
       row(i,j) = i
       s(i,j) = map%area_a(j)*(rEarth**2)*garr2d(i,j)/(total(j)*cplratio(i))
    !  s(i,j) = map%area_a(j)*(rEarth**2)*garr2d(i,j)/(total(j))
     enddo
   enddo

   !-----------------------------------------------
   ! resize the mapping, now that its size is known
   !-----------------------------------------------
   smask = .false.
   where(s.gt.0.0) smask=.true.
   n_s = count(smask)
   allocate(s1d(n_s))
   allocate(row1d(n_s))
   allocate(col1d(n_s))
   s1d = pack(s,smask)
   col1d = pack(col,smask)
   row1d = pack(row,smask)

   deallocate(map%s)
   deallocate(map%row)
   deallocate(map%col)
   map%n_s = n_s
   allocate(map%s(n_s))
   allocate(map%row(n_s))
   allocate(map%col(n_s))
   map%s = s1d
   map%row = row1d
   map%col = col1d

END SUBROUTINE dummyweights

!===============================================================================

SUBROUTINE dummy_aroff_write(map,srcfile,datafile,at)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(in) :: map       ! scrip map template
   character(*) , intent(in) :: srcfile   ! name of ascii river runoff file
   character(*) , intent(in) :: datafile  ! name of runoff data file
   real(r8) , intent(in) :: at(:,:)           ! ocean TAREA (m^2)

   !--- local ---
   integer :: ni,nj,imt,jmt,i,j,m,n
   real(r8)    :: sumb
   real(r8), allocatable     :: work(:,:),work2(:,:,:),basinroff(:,:)
   integer, allocatable  :: iwork(:,:)
   character(len= 8)     :: cdate   ! wall clock date
   character(len=10)     :: ctime   ! wall clock time
   character(len=240)     :: str     ! variable length char string
   character(len=240)     :: attstr  ! netCDF attribute name string
   integer                :: rcode   ! netCDF routine return code
   integer                :: fid     ! netCDF file      ID
   integer                :: vid     ! netCDF variable  ID
   integer                :: did     ! netCDF dimension ID
   integer                :: vdid(3) ! netCDF dimension ID

   !--- formats ---
   character(len=*),parameter :: F00 = "('(dummy_aroff_write) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o Once garr has been defined after a call to dummyflux, this routine
!   will output a data.runoff.nc file for 19-basin data runoff.  This
!   file is needed by dlnd6, and both "domain.runoff.nc" and "data.runoff.nc"
!   get softlinked to this file in the dlnd buildnml script.  The dlnd
!   namelist parameter data_aroff will get set to this file.  
!
! o The contents of the netcdf are fictitious 19-basin grid information (derived
!   from the r19.nc file through the sMatrix "map") and runoff values for each 
!   basin in kg/s/m^2.  These values are computed as the total runoff for each 
!   basin as specified in srcfile (kg/s) normalized by a fictitious area 
!   (1/19 of the globe) in m^2.
!-------------------------------------------------------------------------------
   
   imt = map%ni_b
   jmt = map%nj_b
   ni = map%ni_a
   nj = map%nj_a
   allocate(iwork(ni,nj))
   allocate(work(ni,nj))
   allocate(work2(ni,nj,4))
   allocate(basinroff(ni,nj))

   !-----------------------------------------------------------------
   ! compute the normalized 19-basin totals (kg/s/m^2)
   ! (This is total of each of 19 basins (kg/s) divided by bogus
   !  'basin area' = (area of Earth)/19 ).
   !-----------------------------------------------------------------
   do n=1,ni
     sumb = 0.0
     do j=1,jmt
       do i=1,imt
         sumb = sumb + garr(i,j,n+1)*at(i,j)
       enddo
     enddo
     basinroff(n,1) = sumb/(map%area_a(n)*rEarth*rEarth)
   enddo

   !-----------------------------------------------------------------
   ! create the 19-basin data_aroff netcdf used by dlnd6
   !-----------------------------------------------------------------
!  rcode = nf_create(trim(datafile),NF_CLOBBER,fid)
   rcode = nf_create(trim(datafile),IOR(NF_CLOBBER,NF_64BIT_OFFSET),fid)
   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)

   !-----------------------------------------------------------------
   ! global attributes
   !-----------------------------------------------------------------
    str  = 'runoff data, fictitious 19 basin domain'
   rcode = nf_put_att_text(fid,NF_GLOBAL,'title'      ,len_trim(str),str)
   call date_and_time(cdate,ctime) ! f90 intrinsic
    str = 'File created: '//cdate(1:4)//'-'//cdate(5:6)//'-'//cdate(7:8) &
   &                 //' '//ctime(1:2)//':'//ctime(3:4)//':'//ctime(5:6)
   rcode = nf_put_att_text(fid,NF_GLOBAL,'history'    ,len_trim(str),str)
    str  = 'created using dummy runoff tools in /cgd/oce/yeager/POP_tools/'// &
   &    'runoff/runoff_smooth_mod.F90'
   rcode = nf_put_att_text(fid,NF_GLOBAL,'creation',len_trim(str),str)
    str  = 'source data file was '//trim(srcfile)
   rcode = nf_put_att_text(fid,NF_GLOBAL,'data'   ,len_trim(str),str)

   !-----------------------------------------------------------------
   ! dimensions
   !-----------------------------------------------------------------
   rcode = nf_def_dim(fid, 'ni', ni, did) ! # of points wrt i
   rcode = nf_def_dim(fid, 'nj', nj, did)  ! # of points wrt j
   rcode = nf_def_dim(fid, 'nv', 4, did)  ! # of points wrt j

   !-----------------------------------------------------------------
   ! variables
   !-----------------------------------------------------------------
   rcode = nf_inq_dimid(fid,'nv',vdid(1))
   rcode = nf_inq_dimid(fid,'ni',vdid(2))
   rcode = nf_inq_dimid(fid,'nj',vdid(3))
   rcode = nf_def_var(fid,'xc',NF_DOUBLE,2,vdid(2:3),vid)
   str   = 'degrees'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'longitude of runoff grid cell center'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_def_var(fid,'yc',NF_DOUBLE,2,vdid(2:3),vid)
   str   = 'degrees'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'latitude of runoff grid cell center'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_def_var(fid,'xv',NF_DOUBLE,3,vdid,vid)
   str   = 'degrees'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'longitudes of runoff grid cell vertices'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_def_var(fid,'yv',NF_DOUBLE,3,vdid,vid)
   str   = 'degrees'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'latitudes of runoff grid cell vertices'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_def_var(fid,'mask',NF_SHORT,2,vdid(2:3),vid)
   str   = 'unitless'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'runoff grid domain mask'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_def_var(fid,'area',NF_DOUBLE,2,vdid(2:3),vid)
   str   = 'square radians'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'area of runoff grid cell'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_def_var(fid,'runoff',NF_DOUBLE,2,vdid(2:3),vid)
   str   = 'kg/s/m^2'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'Basin total runoff normalized by 1/19 of Globe'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)
   rcode = nf_put_att_double(fid,vid,"_FillValue",NF_DOUBLE,1,-9999.)
   rcode = nf_def_var(fid,'rEarth',NF_DOUBLE,0,vdid,vid)
   str   = 'meters'
   rcode = nf_put_att_text(fid,vid,'units',len_trim(str),str)
   str   = 'Radius of the Earth'
   rcode = nf_put_att_text(fid,vid,'long_name',len_trim(str),str)

   !-----------------------------------------------------------------
   ! finish writing it
   !-----------------------------------------------------------------
   rcode = nf_enddef(fid)
   rcode = nf_inq_varid(fid,'xc',vid)
   work = reshape(map%xc_a,(/ni,nj/))
   rcode = nf_put_var_double(fid, vid, work) 
   rcode = nf_inq_varid(fid,'yc',vid)
   work = reshape(map%yc_a,(/ni,nj/))
   rcode = nf_put_var_double(fid, vid, work) 
   rcode = nf_inq_varid(fid,'xv',vid)
   work2 = reshape(map%xv_a,(/ni,nj,4/))
   rcode = nf_put_var_double(fid, vid, work2) 
   rcode = nf_inq_varid(fid,'yv',vid)
   work2 = reshape(map%yv_a,(/ni,nj,4/))
   rcode = nf_put_var_double(fid, vid, work2) 
   rcode = nf_inq_varid(fid,'mask',vid)
   iwork = reshape(map%mask_a,(/ni,nj/))
   rcode = nf_put_var_int(fid, vid, iwork) 
   rcode = nf_inq_varid(fid,'area',vid)
   work = reshape(map%area_a,(/ni,nj/))
   rcode = nf_put_var_double(fid, vid, work)
   rcode = nf_inq_varid(fid,'rEarth',vid)
   rcode = nf_put_var_double(fid, vid, rEarth)
   rcode = nf_inq_varid(fid,'runoff',vid)
   rcode = nf_put_var_double(fid, vid, basinroff)
   rcode = nf_close(fid)
   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)

END SUBROUTINE dummy_aroff_write

!===============================================================================

SUBROUTINE POP_TAREA_compute(filename,nx,ny,area)

   implicit none

   !--- arguments ---
   character(*) , intent(in)    :: filename  ! name of ocn grid binary
   integer      :: nx,ny
   real(r8) , allocatable, intent(out)   :: area(:,:)

   !--- local ---
   real(r8) , allocatable   :: work(:,:),htn(:,:),hte(:,:),dxt(:,:),dyt(:,:)

   !--- formats ---
   character(len=*),parameter :: F00 = "('(POP_TAREA_compute) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o Compute POP TAREA array from grid.ieeer8 binary, as it is done
!   in the POP code.
!-------------------------------------------------------------------------------

   allocate(work(nx,ny))
   allocate(htn(nx,ny))
   allocate(hte(nx,ny))
   allocate(dxt(nx,ny))
   allocate(dyt(nx,ny))
   allocate(area(nx,ny))

   open(10,file=filename,form='unformatted',access='direct', &
  &     recl=nx*ny*8)
   read(10,rec=1) work
   read(10,rec=2) work
   read(10,rec=3) htn
   read(10,rec=4) hte
   close(10)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  Below code fragment is from POP grid.F
!  slightly modified
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      !***
      !*** construct T-grid cell widths
      !***
      work = cshift(htn,-1,2)
      dxt = 0.5*(htn + work)
      dxt(:,1) = dxt(:,2)       ! reasonable kluge

      work = cshift(hte,-1,1)
      dyt = 0.5*(hte + work)

      where (dxt == 0.0) dxt=1.0
      where (dyt == 0.0) dyt=1.0

      area = dxt*dyt
 
END SUBROUTINE POP_TAREA_compute

!===============================================================================

SUBROUTINE POP_2D_read(filename,varname,data)

   !--- modules ---

   implicit none

   !--- includes ---
#include <netcdf.inc>

   !--- arguments ---
   character(*) , intent(in)    :: filename  ! name of data file
   character(*) , intent(in)    :: varname  ! name of data file
   real(r8) , intent(inout)         :: data(:,:)

   !--- local ---
   integer         :: nxin,nyin,nx,ny,ndims,itype     ! generic indicies
   integer         :: fid,vid,did,rcode
   integer, dimension(2)  :: dimid

   !--- formats ---
   character(len=*),parameter :: F00 = "('(POP_2D_read) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o reads map matrix information from netCDF data file
!
! NOTE:
!-------------------------------------------------------------------------------

   nxin = size(data,1)
   nyin = size(data,2)

   !-----------------------------------------------
   ! read in the variable
   !-----------------------------------------------
   rcode = nf_open(filename,NF_NOWRITE,fid)
   rcode = nf_inq_varid(fid,varname,vid)
   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)
   rcode = nf_inq_varndims(fid,vid,ndims)
   if (ndims.ne.2) then 
        write(*,F00) 'variable did not have dim 2'
        stop
   endif
   rcode = nf_inq_vardimid(fid,vid,dimid)
   rcode = nf_inq_dimlen(fid, dimid(1)   , nx  )
   rcode = nf_inq_dimlen(fid, dimid(2)   , ny  )
   if (nx.ne.nxin.or.ny.ne.nyin) then 
        write(*,F00) 'variable does not have correct size',nx,ny
        stop
   endif
   rcode = nf_inq_vartype(fid,vid,itype)

   select case (itype)
   case (NF_FLOAT)
      rcode = nf_get_var_real(fid,vid,data)
   case default
      write(*,F00) 'can only handle float'
      stop
   end select

   rcode = nf_close(fid)

END SUBROUTINE POP_2D_read

!===============================================================================
recursive SUBROUTINE breadth_setDist(ni,nj,level,x,y,mask, rdist,rmax,i2ind,j2ind,strptr,length)

!-----------------------------------------------------------------------
!  Recursively sets a distance from a seed point (i0,j0)
!-----------------------------------------------------------------------

   integer :: i0,j0
   integer :: ni, nj
   integer :: kk
   integer :: ie,je,iw,jw,in,jn,is,js,k,j
   integer :: ine,jne,inw,jnw,ise,jse,isw,jsw
   integer :: level
   integer, dimension(ni,nj) :: mask
   real(r8), intent(inout),dimension(ni,nj) :: rdist
   real(kind=r8) :: rmax
   real(r8) :: d
   real(r8) :: ds,dn,de,dw
   real(r8) :: dne, dnw, dse, dsw
   real(r8), dimension(ni*nj) :: x,y
   integer, dimension(:) :: i2ind,j2ind
   integer :: strptr,strPtr2
   integer :: length,length2
   logical, parameter :: Debug = .false.

   if(Debug) print *,'breadth search: level is: ',level,'length is: ',length
   if(Debug) print *,'breadth_setDist:', rmax

   strPtr2=length
   length2=length
   do kk=strPtr,length2
      i0 = i2ind(kk)
      j0 = j2ind(kk) 
      ! ------------------------------------------
      ! only perform the search if patch length 
      ! is below cutoff threshold
      ! ------------------------------------------
      if(rdist(i0,j0) < rmax) then 
      if(Debug) print *,'rdist(i0,j0) rmax: ',rdist(i0,j0),rmax
      
      j = (j0-1)*ni+i0

      !-----------------
      ! West neighbor 
      !-----------------
      iw = iadd(i0,-1,ni)
      jw = j0
      if(mask(iw,jw) == -1) then 
          k = (j0-1)*ni+iw
          dw = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(iw,jw) = level
          rdist(iw,jw) = dw
          length = length + 1
          i2ind(length) = iw
          j2ind(length) = jw
          if(Debug) print *,'distance to west point: ',dw
      endif

      !-----------------
      ! East neighbor
      !-----------------
      ie = iadd(i0,1,ni)
      je = j0
      if(mask(ie,je) == -1) then 
         k = (j0-1)*ni+ie
          de = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(ie,je) = level
          rdist(ie,je) = de
          length = length + 1
          i2ind(length) = ie
          j2ind(length) = je
          if(Debug) print *,'distance to east point: ',de
      endif

      !----------------
      ! North Neighbor
      !----------------
      jn = jadd(j0,1,nj)
      in = i0
      if(mask(in,jn) == -1) then 
          k = (jn-1)*ni+i0
          dn = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(in,jn) = level
          rdist(in,jn) = dn
          length = length + 1
          i2ind(length) = in
          j2ind(length) = jn
          if(Debug) print *,'distance to north point: ',dn
      endif

      !----------------
      ! South Neighbor
      !----------------
      js = jadd(j0,-1,nj)
      is = i0
      if(mask(is,js) == -1) then 
         k = (js-1)*ni+i0
         ds = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
         mask(is,js) = level
         rdist(is,js) = ds
         length = length + 1
         i2ind(length) = is
         j2ind(length) = js
         if(Debug) print *,'distance to south point: ',ds
      endif
    endif

#if 0
! Note: this was meant to add diagonal search to smoother, but
!       it doesn't work so it is not run at this time
      !-----------------
      ! North West neighbor 
      !-----------------
      inw = iadd(i0,-1,ni)
      jnw = jadd(j0,1,nj)
      if(mask(inw,jnw) == -1) then 
          k = (jnw-1)*ni+inw
          dnw = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(inw,jnw) = level
          rdist(inw,jnw) = dnw
          length = length + 1
          i2ind(length) = inw
          j2ind(length) = jnw
          if(Debug) print *,'distance to northwest point: ',dnw
      endif

      !-----------------
      ! North East neighbor 
      !-----------------
      ine = iadd(i0,1,ni)
      jne = jadd(j0,1,nj)
      if(mask(ine,jne) == -1) then 
          k = (jne-1)*ni+ine
          dne = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(ine,jne) = level
          rdist(ine,jne) = dne
          length = length + 1
          i2ind(length) = ine
          j2ind(length) = jne
          if(Debug) print *,'distance to northwest point: ',dne
      endif

      !-----------------
      ! South East neighbor 
      !-----------------
      ise = iadd(i0,1,ni)
      jse = jadd(j0,-1,nj)
      if(mask(ise,jse) == -1) then 
          k = (jse-1)*ni+ise
          dse = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(ise,jse) = level
          rdist(ise,jse) = dse
          length = length + 1
          i2ind(length) = ise
          j2ind(length) = jse
          if(Debug) print *,'distance to northwest point: ',dse
      endif

      !-----------------
      ! South West neighbor 
      !-----------------
      isw = iadd(i0,-1,ni)
      jsw = jadd(j0,-1,nj)
      if(mask(isw,jsw) == -1) then 
          k = (jsw-1)*ni+isw
          dsw = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
          mask(isw,jsw) = level
          rdist(isw,jsw) = dsw
          length = length + 1
          i2ind(length) = isw
          j2ind(length) = jsw
          if(Debug) print *,'distance to northwest point: ',dsw
      endif
#endif

  enddo
  level = level + 1
  if(length > strptr2) then 
      call breadth_setDist(ni,nj,level,x,y,mask, rdist,rmax,i2ind,j2ind,strptr2,length)
  endif
 
END SUBROUTINE breadth_setDist

recursive SUBROUTINE depth_setDist(i0,j0,ni,nj,x,y,value,mask,rdist,rmax,i2ind,j2ind,length)

!-----------------------------------------------------------------------
!  Recursively sets a distance from a seed point (i0,j0)
!-----------------------------------------------------------------------

   integer :: i0, j0, ni, nj
   integer :: ie,iw,jn,js,k,j
   integer, dimension(ni,nj) :: mask
   real(r8), dimension(ni,nj) :: rdist
   real(r8) :: rmax,d,value
   real(r8), dimension(ni*nj) :: x,y
   integer, dimension(:) :: i2ind,j2ind
   integer :: length  
   
   if (mask(i0,j0) /= 0 .and. value < rmax .and. value < rdist(i0,j0)) then
      j = (j0-1)*ni+i0
      if(rdist(i0,j0) > 1.e10) then 
         ! first visit to point 
         length = length + 1
         i2ind(length) = i0
         j2ind(length) = j0
      endif  
      rdist(i0,j0)=value
      mask(i0,j0)=1

      iw = iadd(i0,-1,ni)
      k = (j0-1)*ni+iw
      d = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
      call depth_setDist(iw,j0,ni,nj,x,y,d,mask,rdist,rmax,i2ind,j2ind,length)

      ie = iadd(i0,1,ni)
      k = (j0-1)*ni+ie
      d = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
      call depth_setDist(ie,j0,ni,nj,x,y,d,mask,rdist,rmax,i2ind,j2ind,length)

      jn = jadd(j0,1,nj)
      k = (jn-1)*ni+i0
      d = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
      call depth_setDist(i0,jn,ni,nj,x,y,d,mask,rdist,rmax,i2ind,j2ind,length)

      js = jadd(j0,-1,nj)
      k = (js-1)*ni+i0
      d = distance(x(k),y(k),x(j),y(j))+rdist(i0,j0)
      call depth_setDist(i0,js,ni,nj,x,y,d,mask,rdist,rmax,i2ind,j2ind,length)

   endif

END SUBROUTINE depth_setDist

!===============================================================================
END MODULE smooth_mod
!===============================================================================

!===============================================================================
! SVN $Id: shr_timer_mod.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/shr_timer_mod.F90 $
!===============================================================================

module shr_timer_mod

   !----------------------------------------------------------------------------
   !
   ! routines that support multiple CPU timers via F90 intrinsics
   !
   ! Note: 
   ! o if   an operation is requested on an invalid timer number n
   !   then nothing is done in a routine
   ! o if   more than max_timers are requested, 
   !   then timer n=max_timers is "overloaded" and becomes invalid/undefined
   !
   ! * cpp if-defs were introduced in 2005 to work-around a bug in the ORNL Cray
   !   X1 F90 intrinsic system_clock() function -- ideally this Cray bug would be
   !   fixed and cpp if-defs would be unnecessary and removed.
   !
   ! !REVISION HISTORY:
   !    2005-??-?? - added workaround for Cray F90 bug, mods by Cray/ORNL
   !    2000-??-?? - 1st version by B. Kauffman
   !----------------------------------------------------------------------------

   use shr_kind_mod

   implicit none

   private  ! restricted access

   public  :: shr_timer_init , shr_timer_get      
   public  :: shr_timer_start, shr_timer_stop     
   public  :: shr_timer_print, shr_timer_print_all
   public  :: shr_timer_check, shr_timer_check_all
   public  :: shr_timer_zero , shr_timer_zero_all 
   public  :: shr_timer_free , shr_timer_free_all 
   public  :: shr_timer_sleep

   integer(SHR_KIND_IN),parameter :: stat_free    = 0  ! timer status constants
   integer(SHR_KIND_IN),parameter :: stat_inuse   = 1
   integer(SHR_KIND_IN),parameter :: stat_started = 2
   integer(SHR_KIND_IN),parameter :: stat_stopped = 3
   integer(SHR_KIND_IN),parameter :: max_timers   = 200 ! max number of timers

   integer(SHR_KIND_IN) :: status (max_timers) ! status of each timer
   !----------------------------------------------------------------------------
   ! the following ifdef circumvents a bug in the X1 system_clock function
   !----------------------------------------------------------------------------
#if (defined UNICOSMP)
   integer(kind=8)      :: cycles1(max_timers) ! cycle number at timer start 
   integer(kind=8)      :: cycles2(max_timers) ! cycle number at timer stop  
#else
   integer(SHR_KIND_IN) :: cycles1(max_timers) ! cycle number at timer start 
   integer(SHR_KIND_IN) :: cycles2(max_timers) ! cycle number at timer stop  
#endif
   integer(SHR_KIND_IN) :: cycles_max = -1     ! max cycles before wrapping
   character   (len=80) :: name   (max_timers) ! name assigned to each timer
   real   (SHR_KIND_R8) :: dt     (max_timers) ! accumulated time
   integer(SHR_KIND_IN) :: calls  (max_timers) ! # of samples in accumulation
   real   (SHR_KIND_R8) :: clock_rate          ! clock_rate: seconds per cycle

   save

!===============================================================================
   contains
!===============================================================================

subroutine shr_timer_init

   !----- local -----
   integer(SHR_KIND_IN) :: cycles ! count rate return by system clock
#if (defined UNICOSMP)
   integer(kind=8) :: irtc_rate
#endif

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_init) ',a,i5)"

!-------------------------------------------------------------------------------
! This routine initializes:
! 1) values in all timer array locations
! 2) machine parameters necessary for computing cpu time from F90 intrinsics.
!    F90 intrinsic: system_clock(count_rate=cycles, count_max=cycles_max)
!-------------------------------------------------------------------------------

   call shr_timer_free_all

#if (defined UNICOSMP)
   cycles = irtc_rate()
#else
   call system_clock(count_rate=cycles, count_max=cycles_max)
#endif

   if (cycles /= 0) then
     clock_rate = 1.0_SHR_KIND_R8/real(cycles,SHR_KIND_R8)
   else
     clock_rate = 0._SHR_KIND_R8
     write(6,F00) 'ERROR: no system clock available' 
   endif

end subroutine shr_timer_init

!===============================================================================

subroutine shr_timer_get(n, str)

   !----- arguments -----
   integer(SHR_KIND_IN),intent(out) :: n    ! timer number 
   character (*)       ,intent( in) :: str  ! text string with timer name

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_get) ',a,i5)"

!-----------------------------------------------------------------------
!  search for next free timer
!-----------------------------------------------------------------------

   do n=1,max_timers
     if (status(n) == stat_free) then
       status(n) = stat_inuse
       name  (n) = str
       calls (n) = 0
       return
     endif
   end do

   n=max_timers
   name  (n) = "<invalid - undefined - overloaded>"
   write(6,F00) 'ERROR: exceeded maximum number of timers'

end subroutine shr_timer_get

!===============================================================================

subroutine shr_timer_start(n)

   !----- arguments -----
   integer(SHR_KIND_IN), intent(in) :: n      ! timer number

   !----- local -----
#if (defined UNICOSMP)
   integer(kind=8) :: irtc
#endif

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_start) ',a,i5)"

!-----------------------------------------------------------------------
!  This routine starts a given timer.
!-----------------------------------------------------------------------

   if ( n>0 .and. n<=max_timers) then
     if (status(n) == stat_started) call shr_timer_stop(n)

     status(n) = stat_started
#if (defined UNICOSMP)
     cycles1(n) = irtc()
#else
     call system_clock(count=cycles1(n))
#endif
   else
     write(6,F00) 'ERROR: invalid timer number: ',n
   end if

end subroutine shr_timer_start
 
!===============================================================================

subroutine shr_timer_stop(n)

   !----- arguments -----
   integer(SHR_KIND_IN), intent(in) :: n  ! timer number

   !----- local -----
   real (SHR_KIND_R8) :: elapse      ! elapsed time returned by system counter
#if (defined UNICOSMP)
   integer(kind=8) :: irtc
#endif

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_stop) ',a,i5)"

!-------------------------------------------------------------------------------
!  This routine stops a given timer, checks for cycle wrapping, computes the 
!  elapsed time, and accumulates the elapsed time in the dt(n) array
!-------------------------------------------------------------------------------

   if ( n>0 .and. n<=max_timers) then
     if ( status(n) == stat_started) then
#if (defined UNICOSMP)
       cycles2(n) = irtc()
#else
       call system_clock(count=cycles2(n))
#endif
       if (cycles2(n) >= cycles1(n)) then
         dt(n) = dt(n) + clock_rate*(cycles2(n) - cycles1(n))
       else
         dt(n) = dt(n) + clock_rate*(cycles_max + cycles2(n) - cycles1(n))
       endif
       calls (n) = calls(n) + 1
       status(n) = stat_stopped
     end if
   else
     write(6,F00) 'ERROR: invalid timer number: ',n
   end if

end subroutine shr_timer_stop
 
!===============================================================================

subroutine shr_timer_print(n)

   !----- arguments -----
   integer(SHR_KIND_IN), intent(in) :: n     ! timer number

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_print) ',a,i5)"
   character(len=*),parameter :: F01 = "('(shr_timer_print) timer',i3,&
   &                                     ':',i8,' calls,',f10.3,'s, id: ',a)"
!-------------------------------------------------------------------------------
!  prints the accumulated time for a given timer
!-------------------------------------------------------------------------------

   if ( n>0 .and. n<=max_timers) then
     if (status(n) == stat_started) then
       call shr_timer_stop(n)
       write (6,F01) n,calls(n),dt(n),trim(name(n))
       call shr_timer_start(n)
     else
       write (6,F01) n,calls(n),dt(n),trim(name(n))
     endif
   else
     write(6,F00) 'ERROR: invalid timer number: ',n
   end if

end subroutine shr_timer_print

!===============================================================================

subroutine shr_timer_print_all

   !----- local -----
   integer(SHR_KIND_IN) :: n

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_print_all) ',a,i5)"

!-------------------------------------------------------------------------------
!  prints accumulated time for all timers in use
!-------------------------------------------------------------------------------

   write(6,F00) 'print all timing info:'

   do n=1,max_timers
     if (status(n) /= stat_free) call shr_timer_print(n)
   end do

end subroutine shr_timer_print_all

!===============================================================================

subroutine shr_timer_zero(n)

   !----- arguments -----
   integer(SHR_KIND_IN), intent(in) :: n       ! timer number
   
   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_zero) ',a,i5)"

!-------------------------------------------------------------------------------
!  This routine resets a given timer.
!-------------------------------------------------------------------------------

   if ( n>0 .and. n<=max_timers) then
     dt(n) = 0.0_SHR_KIND_R8
     calls(n) = 0
   else
     write(6,F00) 'ERROR: invalid timer number: ',n
   end if

end subroutine shr_timer_zero

!===============================================================================

subroutine shr_timer_zero_all

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_zero_all) ',a,i5)"

!-------------------------------------------------------------------------------
!  This routine resets all timers.
!-------------------------------------------------------------------------------

   dt = 0.0_SHR_KIND_R8
   calls = 0

end subroutine shr_timer_zero_all

!===============================================================================

subroutine shr_timer_check(n)

   !----- arguments -----
   integer(SHR_KIND_IN), intent(in) ::  n   ! timer number

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_check) ',a,i5)"

!-------------------------------------------------------------------------------
!  This routine checks a given timer.  This is primarily used to
!  periodically accumulate time in the timer to prevent timer cycles
!  from wrapping around max_cycles.
!-------------------------------------------------------------------------------

   if ( n>0 .and. n<=max_timers) then
     if (status(n) == stat_started) then
       call shr_timer_stop (n)
       call shr_timer_start(n)
     endif
   else
     write(6,F00) 'ERROR: invalid timer number: ',n
   end if

end subroutine shr_timer_check

!===============================================================================

subroutine shr_timer_check_all

   !----- local -----
   integer(SHR_KIND_IN) :: n

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_check_all) ',a,i5)"

!-------------------------------------------------------------------------------
!  Call shr_timer_check for all timers in use
!-------------------------------------------------------------------------------

   do n=1,max_timers
     if (status(n) == stat_started) then
       call shr_timer_stop (n)
       call shr_timer_start(n)
     endif
   end do

end subroutine shr_timer_check_all

!===============================================================================

subroutine shr_timer_free(n)

   !----- arguments -----
   integer(SHR_KIND_IN),intent(in) :: n    ! timer number 

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_free) ',a,i5)"

!-----------------------------------------------------------------------
!  initialize/free all timer array values
!-----------------------------------------------------------------------

   if ( n>0 .and. n<=max_timers) then
     status (n) = stat_free
     name   (n) = "<invalid - undefined>"
     dt     (n) = 0.0_SHR_KIND_R8
     cycles1(n) = 0
     cycles2(n) = 0
   else
     write(6,F00) 'ERROR: invalid timer number: ',n
   end if

end subroutine shr_timer_free

!===============================================================================

subroutine shr_timer_free_all

   !----- local -----
   integer(SHR_KIND_IN) :: n

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_timer_free_all) ',a,i5)"

!-------------------------------------------------------------------------------
!  initialize/free all timer array values
!-------------------------------------------------------------------------------

   do n=1,max_timers
     call shr_timer_free(n)
   end do

end subroutine shr_timer_free_all

!===============================================================================

subroutine shr_timer_sleep(sec)

   use shr_sys_mod     ! share system calls (namely, shr_sys_sleep)

   !----- local -----
   real   (SHR_KIND_R8),intent(in) :: sec  ! number of seconds to sleep

!-------------------------------------------------------------------------------
! Sleep for approximately sec seconds
!
! Note: sleep is typically a system call, hence it is implemented in 
!       shr_sys_mod, although it probably would only be used in a timing 
!       context, which is why there is a shr_timer_* wrapper provided here.
!-------------------------------------------------------------------------------

   call shr_sys_sleep(sec)

end subroutine shr_timer_sleep

!===============================================================================
end module shr_timer_mod
!===============================================================================

!===============================================================================
! SVN $Id: map_mod.F90 44128 2013-02-22 15:43:14Z mlevy@ucar.edu $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/map_mod.F90 $
!===============================================================================

MODULE map_mod

   use shr_sys_mod
   use shr_timer_mod
   use kind_mod

   implicit none

#include <netcdf.inc>

   integer,parameter :: strLen = 240
   integer,parameter :: nv     = 4

   real(r8)   ,parameter :: pi =  3.14159265358979323846_r8
   real(r8)   ,parameter :: rEarth     =  6.37122e+6         ! radius of earth (m)
   real(r8)   ,parameter :: DEGtoRAD = pi/180.0_r8  ! degrees to radians
   real(r8)   ,parameter :: RADtoDEG = 180.0_r8/pi  ! radians to degrees

   integer,parameter :: nibx = 360          ! size of sort bin boxes
   integer,parameter :: njbx = nibx/2
   integer,parameter :: vcells_req = 20     ! number of valid cells required per bin

   !----------------------------------------------------------------------------
   ! sparse matrix data type
   !----------------------------------------------------------------------------
   TYPE sMatrix

     !--- global text attributes ---
     character(strLen) :: title
     character(strLen) :: normal
     character(strLen) :: method
     character(strLen) :: history
     character(strLen) :: convention
     character(strLen) :: domain_a
     character(strLen) :: domain_b

     !--- domain a ---
     integer         ::    n_a      ! number of non-zero matrix elements
     integer         ::   ni_a      ! number of 2d array i indicies
     integer         ::   nj_a      ! number of 2d array j indicies
     real(r8)   ,pointer ::   xc_a(:)   ! x-coords of centers   ~ deg east
     real(r8)   ,pointer ::   yc_a(:)   ! y-coords of centers   ~ deg north
     real(r8)   ,pointer ::   xv_a(:,:) ! x-coords of verticies ~ deg east, (nv,n)
     real(r8)   ,pointer ::   yv_a(:,:) ! y-coords of verticies ~ deg north (nv,n)
     integer,pointer :: mask_a(:)   ! mask: 0 <=> out-of-domain (invalid data)
     real(r8)   ,pointer :: area_a(:)   ! area of grid cell ~ radians squared

     !--- domain b ---
     integer         ::    n_b      ! number of non-zero matrix elements
     integer         ::   ni_b      ! number of 2d array i indicies
     integer         ::   nj_b      ! number of 2d array j indicies
     real(r8)   ,pointer ::   xc_b(:)   ! x-coords of centers   ~ deg east
     real(r8)   ,pointer ::   yc_b(:)   ! y-coords of centers   ~ deg north
     real(r8)   ,pointer ::   xv_b(:,:) ! x-coords of verticies ~ deg east, (nv,n)
     real(r8)   ,pointer ::   yv_b(:,:) ! y-coords of verticies ~ deg north (nv,n)
     integer,pointer :: mask_b(:)   ! mask: 0 <=> out-of-domain (invalid data)
     real(r8)   ,pointer :: area_b(:)   ! area of grid cell ~ radians squared

     !--- fraction of cell mapped to domain b or from domain a ---
     real(r8)   ,pointer :: frac_a(:)   ! area of grid cell ~ radians squared
     real(r8)   ,pointer :: frac_b(:)   ! area of grid cell ~ radians squared

     !--- map: a->b ---
     integer         :: n_s         ! number of non-zero matrix elements
     real(kind=r8)   ,pointer :: s  (:)      ! the non-zero matrix elements
     integer,pointer :: row(:)      ! matrix row corresponding to each element
     integer,pointer :: col(:)      ! matrix col corresponding to each element

     !--- used for OMP/threading in mat-mult ---
     integer,pointer :: sn1(:)      ! # links in a given row
     integer,pointer :: sn2(:)      ! # links previous to a given row

     !--- required for computing NN maps ---
     integer :: imin_b(nibx,njbx)   ! xc_b least index for lat 0:360
     integer :: imax_b(nibx,njbx)   ! xc_b max index for lat 0:360
     integer :: jmin_b(nibx,njbx)   ! yc_b least index for lat 0:90
     integer :: jmax_b(nibx,njbx)   ! yc_b max index for lat 0:90

   END TYPE sMatrix

   SAVE

!===============================================================================
CONTAINS 
!===============================================================================

SUBROUTINE map_read(map, filename)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       ! sMatrix info to be read in
   character(*) , intent(in)    :: filename  ! name of data file

   !--- local ---
   integer         :: i,n,m         ! generic indicies

   character(strLen)     :: str     ! variable length char string
   character(strLen)     :: attstr  ! netCDF attribute name string
   integer               :: rcode   ! netCDF routine return code
   integer               :: fid     ! netCDF file      ID
   integer               :: vid     ! netCDF variable  ID
   integer               :: did     ! netCDF dimension ID

   !--- formats ---
   character(len=*),parameter :: F00 = "('(map_read) ',3a)"
   character(len=*),parameter :: F02 = "('(map_read) ',a11,a3,60(a1))"

!-------------------------------------------------------------------------------
! PURPOSE:
! o reads map matrix information from netCDF data file
! 
! NOTE:
!-------------------------------------------------------------------------------

   !-----------------------------------------------
   ! get global attributes
   !-----------------------------------------------
   write(6,F00) 'data file',' = ',trim(filename)
   rcode = nf_open(filename,NF_NOWRITE,fid)
   if (rcode.ne.NF_NOERR) then
      write(6,F00) ' ERROR in filename ',trim(filename)
      call shr_sys_abort()
   endif
   do i=1,7
     if (i == 1) attstr = 'title'      
     if (i == 2) attstr = 'normalization'
     if (i == 3) attstr = 'map_method'
     if (i == 4) attstr = 'conventions'
     if (i == 5) attstr = 'history'
     if (i == 6) attstr = 'domain_a'
     if (i == 7) attstr = 'domain_b'

     rcode = nf_inq_attlen  (fid, NF_GLOBAL, trim(attstr), n)
     rcode = nf_get_att_text(fid, NF_GLOBAL, trim(attstr), str)
     write(6,F00) trim(attstr),' = ',str(1:n)

     if (i == 1) map%title      = str(1:n)
     if (i == 2) map%normal     = str(1:n)
     if (i == 3) map%method     = str(1:n)
     if (i == 4) map%convention = str(1:n)
     if (i == 5) map%history    = str(1:n)
     if (i == 6) map%domain_a   = str(1:n)
     if (i == 7) map%domain_b   = str(1:n)

   end do

   !-----------------------------------------------
   ! get "a" domain info 
   !-----------------------------------------------
   rcode = nf_inq_dimid (fid, 'n_a' , did)
   rcode = nf_inq_dimlen(fid, did   , map%n_a  )
   rcode = nf_inq_dimid (fid, 'ni_a', did)
   rcode = nf_inq_dimlen(fid, did   , map%ni_a )
   rcode = nf_inq_dimid (fid, 'nj_a', did)
   rcode = nf_inq_dimlen(fid, did   , map%nj_a )

   allocate(map%  xc_a(   map%n_a)) ! x-coordinates of center
   allocate(map%  yc_a(   map%n_a)) ! y-coordinates of center
   allocate(map%  xv_a(nv,map%n_a)) ! x-coordinates of verticies
   allocate(map%  yv_a(nv,map%n_a)) ! y-coordinates of verticies
   allocate(map%mask_a(   map%n_a)) ! domain mask
   allocate(map%area_a(   map%n_a)) ! grid cell area
   allocate(map%frac_a(   map%n_a)) ! grid cell area

   rcode = nf_inq_varid     (fid,'xc_a'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%xc_a )
   rcode = nf_inq_varid     (fid,'yc_a'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%yc_a )
   rcode = nf_inq_varid     (fid,'xv_a'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%xv_a )
   rcode = nf_inq_varid     (fid,'yv_a'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%yv_a )
   rcode = nf_inq_varid     (fid,'mask_a',vid )
   rcode = nf_get_var_int   (fid,vid     ,map%mask_a)
   rcode = nf_inq_varid     (fid,'area_a',vid )
   rcode = nf_get_var_double(fid,vid     ,map%area_a)
   rcode = nf_inq_varid     (fid,'frac_a',vid )
   rcode = nf_get_var_double(fid,vid     ,map%frac_a)

   !-----------------------------------------------
   ! get "b" domain info 
   !-----------------------------------------------
   rcode = nf_inq_dimid (fid, 'n_b' , did)
   rcode = nf_inq_dimlen(fid, did   , map%n_b  )
   rcode = nf_inq_dimid (fid, 'ni_b', did)
   rcode = nf_inq_dimlen(fid, did   , map%ni_b )
   rcode = nf_inq_dimid (fid, 'nj_b', did)
   rcode = nf_inq_dimlen(fid, did   , map%nj_b )

   allocate(map%  xc_b(   map%n_b)) ! x-coordinates of center
   allocate(map%  yc_b(   map%n_b)) ! y-coordinates of center
   allocate(map%  xv_b(nv,map%n_b)) ! x-coordinates of verticies
   allocate(map%  yv_b(nv,map%n_b)) ! y-coordinates of verticies
   allocate(map%mask_b(   map%n_b)) ! domain mask
   allocate(map%area_b(   map%n_b)) ! grid cell area
   allocate(map%frac_b(   map%n_b)) ! grid cell area

   rcode = nf_inq_varid     (fid,'xc_b'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%xc_b )
   rcode = nf_inq_varid     (fid,'yc_b'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%yc_b )
   rcode = nf_inq_varid     (fid,'xv_b'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%xv_b )
   rcode = nf_inq_varid     (fid,'yv_b'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%yv_b )
   rcode = nf_inq_varid     (fid,'mask_b',vid )
   rcode = nf_get_var_int   (fid,vid     ,map%mask_b)
   rcode = nf_inq_varid     (fid,'area_b',vid )
   rcode = nf_get_var_double(fid,vid     ,map%area_b)
   rcode = nf_inq_varid     (fid,'frac_b',vid )
   rcode = nf_get_var_double(fid,vid     ,map%frac_b)

   !-----------------------------------------------
   ! get matrix info 
   !-----------------------------------------------
   rcode = nf_inq_dimid (fid, 'n_s', did)  ! size of sparse matrix
   rcode = nf_inq_dimlen(fid, did  , map%n_s)
   allocate(map%s  (map%n_s))
   allocate(map%row(map%n_s))
   allocate(map%col(map%n_s))
   allocate(map%sn1(map%n_b))
   allocate(map%sn2(map%n_b))
   rcode = nf_inq_varid     (fid,'S'  ,vid)
   rcode = nf_get_var_double(fid,vid  ,map%s  )
   rcode = nf_inq_varid     (fid,'row',vid)
   rcode = nf_get_var_int   (fid,vid  ,map%row)
   rcode = nf_inq_varid     (fid,'col',vid)
   rcode = nf_get_var_int   (fid,vid  ,map%col)

   rcode = nf_close(fid)

END SUBROUTINE map_read

!===============================================================================
!===============================================================================

SUBROUTINE map_gridRead(map, rfilename, ofilename, gridtype)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       ! sMatrix info to be read in
   character(*) , intent(in)    :: rfilename ! name of rtm rdirc file
   character(*) , intent(in)    :: ofilename ! name of ocn scrip grid file
   character(*) , intent(in)    :: gridtype  ! type of roff grid data 

   !--- local ---
   integer         :: i,j,n,m         ! generic indicies

   character(strLen)     :: str     ! variable length char string
   character(strLen)     :: attstr  ! netCDF attribute name string
   integer               :: rcode   ! netCDF routine return code
   integer               :: fid     ! netCDF file      ID
   integer               :: vid     ! netCDF variable  ID
   integer               :: did     ! netCDF dimension ID
   integer               :: grid_rank
   integer               :: grid_dims(2)
   real(r8)              :: lat,lon,rdirc
   integer               :: ilat,ilon
   integer               :: nm,np,cnt,ibx,jbx,ibxj,jbxj,ni,nj,nij
   integer               :: im,ip,jp,jmax,jmin,imin,imax,jm,ibxi,jbxi,ibxij,jbxij
   integer               :: ispval,ihold,i1,j1,i2,j2,cnt2,i3,j3
   integer               :: vcells
   integer,allocatable   :: timin(:,:),timax(:,:),tjmin(:,:),tjmax(:,:)
   logical               :: lxv_a, lyv_a, lmask_a, larea_a

   !--- formats ---
   character(*),parameter :: subName = "(map_gridRead) "
   character(*),parameter :: F00 = "('(map_gridRead) ',3a)"
   character(*),parameter :: F01 = "('(map_gridRead) ',a,2i8)"
   character(*),parameter :: F02 = "('(map_gridRead) ',a11,a3,60(a1))"

!-------------------------------------------------------------------------------
! PURPOSE:
! o reads map matrix information from netCDF data file
! 
! NOTE:
!-------------------------------------------------------------------------------

   !-----------------------------------------------
   ! set global attributesa
   !-----------------------------------------------

   map%title      = 'gen_runoff mapping generation'
   map%normal     = 'conservative'
   map%method     = 'nearest neighbor smoothing'
   map%convention = 'NCAR-CCSM'
   map%history    = 'history'
   map%domain_a   = trim(rfilename)
   map%domain_b   = trim(ofilename)

   if (trim(gridtype) == "rtm") then
      !-------------------------------------------------------------------------
      write(*,F00) "read source domain info -- hardwired for 1/2 degree clm/rtm rdirc ascii file"
      !-------------------------------------------------------------------------

      map%ni_a = 720
      map%nj_a = 360
      map%n_a  = map%ni_a * map%nj_a

      allocate(map%  xc_a(   map%n_a)) ! x-coordinates of center
      allocate(map%  yc_a(   map%n_a)) ! y-coordinates of center
      allocate(map%  xv_a(nv,map%n_a)) ! x-coordinates of verticies
      allocate(map%  yv_a(nv,map%n_a)) ! y-coordinates of verticies
      allocate(map%mask_a(   map%n_a)) ! domain mask
      allocate(map%area_a(   map%n_a)) ! grid cell area
      allocate(map%frac_a(   map%n_a)) ! grid cell area

      fid = 22
      open(fid,file=trim(rfilename))

      do n = 1,map%n_a
         read(fid,*) lat,lon,rdirc
         map%xc_a(  n) = lon
         map%yc_a(  n) = lat

         map%xv_a(1,n) = lon - 0.25
         map%xv_a(2,n) = lon + 0.25
         map%xv_a(3,n) = lon + 0.25
         map%xv_a(4,n) = lon - 0.25

         map%yv_a(1,n) = lat - 0.25
         map%yv_a(2,n) = lat - 0.25
         map%yv_a(3,n) = lat + 0.25
         map%yv_a(4,n) = lat + 0.25

         map%area_a(n) = 0.5 * 0.5 * cos(lat*DEGtoRAD) * DEGtoRAD * DEGtoRAD

         if (abs(rdirc) < 0.5) then
            map%mask_a(n) = 1
            map%frac_a(n) = 1.0_r8
         else
            map%mask_a(n) = 0
            map%frac_a(n) = 0.0_r8
         endif
      enddo

      close(fid)
   else if (trim(gridtype) == "obs") then
      !-------------------------------------------------------------------------
      write(*,F00) "read source domain info -- Dai/Trenberth observed runoff"
      !-------------------------------------------------------------------------
      write(6,F00) 'runoff data file',' = ',trim(rfilename)
      rcode = nf_open(rfilename,NF_NOWRITE,fid)

      rcode = nf_inq_dimid (fid, 'ni' , did)
      if (rcode.ne.NF_NOERR) then
        write(6,F00) ' ERROR in filename ',trim(rfilename),': can not find dim ni'
        call shr_sys_abort()
      endif
      rcode = nf_inq_dimlen(fid, did  , ni )

      rcode = nf_inq_dimid (fid, 'nj' , did)
      if (rcode.ne.NF_NOERR) then
        write(6,F00) ' ERROR in filename ',trim(rfilename),': can not find dim nj'
        call shr_sys_abort()
      endif
      rcode = nf_inq_dimlen(fid, did  , nj )

      write(6,F01) 'dimensions ni,nj = ',ni,nj

      map%ni_a = ni
      map%nj_a = nj
      map%n_a  = ni*nj

      allocate(map%  xc_a(   map%n_a)) ! x-coordinates of center
      allocate(map%  yc_a(   map%n_a)) ! y-coordinates of center
      allocate(map%  xv_a(nv,map%n_a)) ! x-coordinates of verticies
      allocate(map%  yv_a(nv,map%n_a)) ! y-coordinates of verticies
      allocate(map%mask_a(   map%n_a)) ! domain mask
      allocate(map%area_a(   map%n_a)) ! grid cell area
      allocate(map%frac_a(   map%n_a)) ! frac of cell mapped to dest

      rcode = nf_inq_varid     (fid,'xc'  ,vid)
      if (rcode.ne.NF_NOERR) then
        write(6,*) "ERROR: could not find variable xc in input file!"
        call shr_sys_abort()
      endif
      rcode = nf_get_var_double(fid,vid   ,map%xc_a )

      rcode = nf_inq_varid     (fid,'yc'  ,vid)
      if (rcode.ne.NF_NOERR) then
        write(6,*) "ERROR: could not find variable yc in input file!"
        call shr_sys_abort()
      endif
      rcode = nf_get_var_double(fid,vid   ,map%yc_a )

      rcode = nf_inq_varid     (fid,'xv'  ,vid)
      if (rcode.eq.0) then
        lxv_a = .true.
        rcode = nf_get_var_double(fid,vid   ,map%xv_a )
      else
        lxv_a = .false.
        write(6,*) "WARNING: could not find variable xv in input file!"
      endif

      rcode = nf_inq_varid     (fid,'yv'  ,vid)
      if (rcode.eq.0) then
        lyv_a = .true.
        rcode = nf_get_var_double(fid,vid   ,map%yv_a )
      else
        lyv_a = .false.
        write(6,*) "WARNING: could not find variable yv in input file!"
      endif

      rcode = nf_inq_varid     (fid,'mask',vid )
      if (rcode.eq.0) then
        lmask_a = .true.
        rcode = nf_get_var_int   (fid,vid   ,map%mask_a)
      else
        lmask_a = .false.
        write(6,*) "WARNING: could not find variable mask in input file!"
      endif

      rcode = nf_inq_varid     (fid,'area',vid )
      if (rcode.eq.0) then
        larea_a = .true.
        rcode = nf_get_var_double(fid,vid   ,map%area_a)
      else
        larea_a = .false.
        write(6,*) "WARNING: could not find variable area in input file!"
      endif


      rcode = nf_close(fid)

      do n = 1,map%n_a
         lon = map%xc_a(n)
         lat = map%yc_a(n)

         if (.not.lxv_a) then
           ! Hardcoded for r0.5
           map%xv_a(1,n) = lon - 0.25_r8
           map%xv_a(2,n) = lon + 0.25_r8
           map%xv_a(3,n) = lon + 0.25_r8
           map%xv_a(4,n) = lon - 0.25_r8
         end if

         if (.not.lyv_a) then
           ! Hardcoded for r0.5
           map%yv_a(1,n) = lat - 0.25_r8
           map%yv_a(2,n) = lat - 0.25_r8
           map%yv_a(3,n) = lat + 0.25_r8
           map%yv_a(4,n) = lat + 0.25_r8
         end if

         if (.not.larea_a) then
           ! Hardcoded for r0.5
           map%area_a(n) = 0.5*0.5*cos(lat*DEGtoRAD)*DEGtoRAD*DEGtoRAD
         end if

         if (.not.lmask_a) then
           map%mask_a(n) = 1
         end if

         if (map%mask_a(n) .ne. 0) then
            map%mask_a(n) = 1
            map%frac_a(n) = 1.0_r8
         else
            map%mask_a(n) = 0
            map%frac_a(n) = 0.0_r8
         endif
      enddo

!     !--- safe to assume units are already degrees? ---
!     if (units == radians)
!     map%xc_b = map%xc_b * RADtoDEG 
!     map%yc_b = map%yc_b * RADtoDEG
!     map%xv_b = map%xv_b * RADtoDEG
!     map%yv_b = map%yv_b * RADtoDEG

   else
      !-------------------------------------------------------------------------
      ! no other valid choices
      !-------------------------------------------------------------------------
      write(6,F00) 'ERROR: no implementation for gridtype = ',trim(gridtype)
      stop
   end if
 
   !----------------------------------------------------------------------------
   write(*,F00) "read destination domain info -- pop grid"
   !----------------------------------------------------------------------------
   write(6,F00) 'ocn data file',' = ',trim(ofilename)
   rcode = nf_open(ofilename,NF_NOWRITE,fid)

   rcode = nf_inq_dimid (fid, 'grid_size' , did)
   rcode = nf_inq_dimlen(fid, did   , map%n_b  )
   rcode = nf_inq_dimid (fid, 'grid_rank', did)
   rcode = nf_inq_dimlen(fid, did   , grid_rank)
   if (grid_rank /= 2) then
      write(6,*) 'ERROR: grid_rank is ',grid_rank,' in ',trim(ofilename)
      call shr_sys_abort(subName//"ERROR: ofilename grid_rank")
   endif
   rcode = nf_inq_varid  (fid, 'grid_dims', vid)
   rcode = nf_get_var_int(fid, vid   , grid_dims)
   map%ni_b = grid_dims(1)
   map%nj_b = grid_dims(2)

   allocate(map%  xc_b(   map%n_b)) ! x-coordinates of center
   allocate(map%  yc_b(   map%n_b)) ! y-coordinates of center
   allocate(map%  xv_b(nv,map%n_b)) ! x-coordinates of verticies
   allocate(map%  yv_b(nv,map%n_b)) ! y-coordinates of verticies
   allocate(map%mask_b(   map%n_b)) ! domain mask
   allocate(map%area_b(   map%n_b)) ! grid cell area
   allocate(map%frac_b(   map%n_b)) ! grid cell area
   allocate(map%sn1      (map%n_b))
   allocate(map%sn2      (map%n_b))

   rcode = nf_inq_varid     (fid,'grid_center_lon'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%xc_b )
   rcode = nf_inq_varid     (fid,'grid_center_lat'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%yc_b )
   rcode = nf_inq_varid     (fid,'grid_corner_lon'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%xv_b )
   rcode = nf_inq_varid     (fid,'grid_corner_lat'  ,vid)
   rcode = nf_get_var_double(fid,vid     ,map%yv_b )
   rcode = nf_inq_varid     (fid,'grid_imask',vid )
   rcode = nf_get_var_int   (fid,vid     ,map%mask_b)
   rcode = nf_inq_varid     (fid,'grid_area',vid )
   rcode = nf_get_var_double(fid,vid     ,map%area_b)

   map%xc_b = map%xc_b * RADtoDEG
   map%yc_b = map%yc_b * RADtoDEG
   map%xv_b = map%xv_b * RADtoDEG
   map%yv_b = map%yv_b * RADtoDEG
   map%frac_b = map%mask_b * 1.0_r8

   rcode = nf_close(fid)

   !----------------------------------------------------------------------------
   write(*,F00) "derive info required to compute NN map"
   !----------------------------------------------------------------------------

   ispval = -999
   map%imin_b = 5*map%ni_b
   map%imax_b = ispval
   map%jmin_b = 5*map%nj_b
   map%jmax_b = ispval

   do j = 1,map%nj_b-1
   do i = 1,map%ni_b
      jm = j
      jp = j+1
      im = i
      ip = mod(i,map%ni_b) + 1

      n   = (jm-1)*map%ni_b + im
      nj  = (jp-1)*map%ni_b + im
      ni  = (jm-1)*map%ni_b + ip
      nij = (jp-1)*map%ni_b + ip

      call map_bxindex(map%xc_b(n  ),map%yc_b(n  ),ibx  ,jbx  )
      call map_bxindex(map%xc_b(nj ),map%yc_b(nj ),ibxj ,jbxj )
      call map_bxindex(map%xc_b(ni ),map%yc_b(ni ),ibxi ,jbxi )
      call map_bxindex(map%xc_b(nij),map%yc_b(nij),ibxij,jbxij)

      imin = min(ibx,ibxi,ibxj,ibxij)
      imax = max(ibx,ibxi,ibxj,ibxij)
      jmin = min(jbx,jbxi,jbxj,jbxij)
      jmax = max(jbx,jbxi,jbxj,jbxij)

      ! --- if wraparound in bx, swap index order
      if (imax - imin > nibx/2) then
         ihold = imin
         imin  = imax
         imax  = ihold
      endif

      ip = mod(ip-1,map%ni_b) + 1

      if (imax < imin) then
         do j1 = jmin,jmax
         do i1 = 1,imax
            map%jmin_b(i1,j1) =  min(map%jmin_b(i1,j1),jm)
            map%jmax_b(i1,j1) =  max(map%jmax_b(i1,j1),jp)
            if (map%imax_b(i1,j1) == ispval) then
               map%imin_b(i1,j1) = im
               map%imax_b(i1,j1) = ip
            else
               if (abs(map%imin_b(i1,j1) - im) > nibx/2) then
                  map%imin_b(i1,j1) = max(map%imin_b(i1,j1),im)
               else
                  map%imin_b(i1,j1) = min(map%imin_b(i1,j1),im)
               endif
               if (abs(map%imax_b(i1,j1) - ip) > nibx/2) then
                  map%imax_b(i1,j1) = min(map%imax_b(i1,j1),ip)
               else
                  map%imax_b(i1,j1) = max(map%imax_b(i1,j1),ip)
               endif
            endif
         enddo
         do i1 = imin,nibx
            map%jmin_b(i1,j1) =  min(map%jmin_b(i1,j1),jm)
            map%jmax_b(i1,j1) =  max(map%jmax_b(i1,j1),jp)
            if (map%imax_b(i1,j1) == ispval) then
               map%imin_b(i1,j1) = im
               map%imax_b(i1,j1) = ip
            else
               if (abs(map%imin_b(i1,j1) - im) > nibx/2) then
                  map%imin_b(i1,j1) = max(map%imin_b(i1,j1),im)
               else
                  map%imin_b(i1,j1) = min(map%imin_b(i1,j1),im)
               endif
               if (abs(map%imax_b(i1,j1) - ip) > nibx/2) then
                  map%imax_b(i1,j1) = min(map%imax_b(i1,j1),ip)
               else
                  map%imax_b(i1,j1) = max(map%imax_b(i1,j1),ip)
               endif
            endif
         enddo
         enddo
      else
         do j1 = jmin,jmax
         do i1 = imin,imax
            map%jmin_b(i1,j1) =  min(map%jmin_b(i1,j1),jm)
            map%jmax_b(i1,j1) =  max(map%jmax_b(i1,j1),jp)
            if (map%imax_b(i1,j1) == ispval) then
               map%imin_b(i1,j1) = im
               map%imax_b(i1,j1) = ip
            else
               if (abs(map%imin_b(i1,j1) - im) > nibx/2) then
                  map%imin_b(i1,j1) = max(map%imin_b(i1,j1),im)
               else
                  map%imin_b(i1,j1) = min(map%imin_b(i1,j1),im)
               endif
               if (abs(map%imax_b(i1,j1) - ip) > nibx/2) then
                  map%imax_b(i1,j1) = min(map%imax_b(i1,j1),ip)
               else
                  map%imax_b(i1,j1) = max(map%imax_b(i1,j1),ip)
               endif
            endif
         enddo
         enddo

      endif

   enddo
   enddo

   !----------------------------------------------------------------------------
   write(*,F00) "fill in missing boxes and"
   write(*,F00) "make sure there are at least vcells_req valid cells per bin"
   !----------------------------------------------------------------------------

   allocate(timin(nibx,njbx),timax(nibx,njbx),tjmin(nibx,njbx),tjmax(nibx,njbx))

   cnt = 1
   cnt2 = 0
   do while (cnt > 0 .and. cnt2 < nibx)
      cnt2 = cnt2 + 1
      cnt = 0
      timin = map%imin_b
      timax = map%imax_b
      tjmin = map%jmin_b
      tjmax = map%jmax_b
      do j = 1,njbx
      do i = 1,nibx
         vcells = 0
         if (min(timin(i,j),timax(i,j),tjmin(i,j),tjmax(i,j)) > 0) then
            i1 = timin(i,j)
            i2 = timax(i,j)
            j1 = tjmin(i,j)
            j2 = tjmax(i,j)
            if (i2 > i1) then
               do j3 = j1,j2
               do i3 = i1,i2
                  n = (j3-1) * map%ni_b + i3
                  if (map%mask_b(n) > 0) vcells = vcells + 1
               enddo
               enddo
            else
               do j3 = j1,j2
               do i3 = i1,map%ni_b
                  n = (j3-1) * map%ni_b + i3
                  if (map%mask_b(n) > 0) vcells = vcells + 1
               enddo
               do i3 = 1,i2
                  n = (j3-1) * map%ni_b + i3
                  if (map%mask_b(n) > 0) vcells = vcells + 1
               enddo
               enddo
            endif
         endif
         if (vcells < vcells_req) then
            cnt = cnt + 1
            do j1 = -1,1
            do i1 = -1,1
               j2 = max(min(j+j1,njbx),1)
               i2 = mod(i+i1-1+nibx,nibx) + 1
               if (min(map%imin_b(i2,j2),map%imax_b(i2,j2),map%jmin_b(i2,j2),map%jmax_b(i2,j2)) > 0) then
                  if (min(timin(i,j),timax(i,j),tjmin(i,j),tjmax(i,j)) < 0) then
                     tjmin(i,j) = map%jmin_b(i2,j2)
                     tjmax(i,j) = map%jmax_b(i2,j2)
                     timin(i,j) = map%imin_b(i2,j2)
                     timax(i,j) = map%imax_b(i2,j2)
                  else
                     tjmin(i,j) = min(tjmin(i,j),map%jmin_b(i2,j2))
                     tjmax(i,j) = max(tjmax(i,j),map%jmax_b(i2,j2))
                     if (abs(timin(i,j)-map%imin_b(i2,j2)) > map%ni_b/2) then
                        timin(i,j) = max(timin(i,j),map%imin_b(i2,j2))
                     else
                        timin(i,j) = min(timin(i,j),map%imin_b(i2,j2))
                     endif
                     if (abs(timax(i,j)-map%imax_b(i2,j2)) > map%ni_b/2) then
                        timax(i,j) = min(timax(i,j),map%imax_b(i2,j2))
                     else
                        timax(i,j) = max(timax(i,j),map%imax_b(i2,j2))
                     endif
                  endif
               endif
            enddo
            enddo
         else

         endif

      enddo
      enddo
      map%imin_b = timin
      map%imax_b = timax
      map%jmin_b = tjmin
      map%jmax_b = tjmax
      write(6,*) subname,' fill pass number',cnt2,' count = ',cnt
   enddo

   deallocate(timin,timax,tjmin,tjmax)

!   do j = 1,njbx
!   do i = 1,nibx
!      write(6,*) 'i,j ',i,j,map%imin_b(i,j),map%imax_b(i,j),map%jmin_b(i,j),map%jmax_b(i,j)
!   enddo
!   enddo

   !----------------------------------------------------------------------------
   ! allocate matrix s,row,col, initial guess of size, will be updated
   !----------------------------------------------------------------------------

   map%n_s = map%n_a
   allocate(map%s  (map%n_s))
   allocate(map%row(map%n_s))
   allocate(map%col(map%n_s))

   do n = 1,map%n_s
      map%row(n) = n
      map%col(n) = -99
      map%S(n) = 1.0_r8
   enddo

END SUBROUTINE map_gridRead

!===============================================================================

SUBROUTINE map_gennn0(map)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       ! sMatrix info to be read in

   !--- local ---
   integer         :: i,j,n,m   ! generic indicies
   integer         :: na,nb,ns  ! index into a,b,s vectors (src,dest,matrix)
   real(r8)        :: dist      ! distance
#ifdef  _OPENMP
   integer, allocatable, dimension(:) :: nb_nn_ar ! index of nn in b (dest) vector
   real(r8), allocatable, dimension(:)    :: dmin_ar  ! minimum distance
   integer :: omp_get_thread_num, omp_get_max_threads
#endif
   integer         :: nb_nn     ! index of nn in b (dest) vector
   real(r8)            :: dmin      ! minimum distance

   integer         :: t0        ! share timer id
   character( 8)   :: cdate     ! wall clock date
   character(10)   :: ctime     ! wall clock time
   character(80)   :: str       ! 

   !--- formats ---
   character(*),parameter :: subName = "(map_gennn0) "
   character(*),parameter ::   F00 = "('(map_gennn0) ',3a)"
   character(*),parameter ::   F02 = "('(map_gennn0) ',a11,a3,60(a1))"

!-------------------------------------------------------------------------------
! NOTES:
! - create a nearest neighbor map using a "brute force" search technique
! - for every unmasked src cell there is exactly one non-zero S matrix value
!-------------------------------------------------------------------------------


   !--- allocate S: number of elements is number of unmasked src cells ---------
   map%n_s = 0
   do n = 1,map%n_a
      if (map%mask_a(n) .ne. 0) map%n_s = map%n_s + 1
   enddo
   write(6,*) ' '
   write(6,*) subname,map%n_s,' unmasked src cells out of ',map%n_a,' cells total'

   deallocate(map%s         , map%row         , map%col         )
   allocate  (map%s(map%n_s), map%row(map%n_s), map%col(map%n_s))


   !--- find nearest neighbor for each src cell --------------------------------
   call shr_timer_get  (t0,subName//"construct nearest neighbor map")
   call shr_timer_start(t0)
   ns = 0

#ifdef _OPENMP
   allocate(nb_nn_ar(omp_get_max_threads()))
   allocate(dmin_ar(omp_get_max_threads()))
#endif

   do na = 1,map%n_a
      if (mod(ns,map%n_s/50) == 0) then
         call date_and_time(cdate,ctime) ! f90 intrinsic
         str =   cdate(1:4)//'-'//cdate(5:6)//'-'//cdate(7:8)//' ' &
         &     //ctime(1:2)//':'//ctime(3:4)//':'//ctime(5:6)
         write(6,*) subname,trim(str)," done ",ns," of ",map%n_s," cells ",100*ns/map%n_s,"%"
      end if

      !--- brute force search for nearest neighbor cell ---
      dmin = 1.0e36
      nb_nn = 0
#ifdef _OPENMP
      dmin_ar(:)  = dmin
      nb_nn_ar(:) = nb_nn
#endif
      if (map%mask_a(na) .ne. 0) then ! non-zero <=> an active cell
         ns = ns + 1
         !$OMP PARALLEL DO DEFAULT(SHARED) &
         !$OMP PRIVATE(nb, dist)
         do nb = 1,map%n_b
            if (map%mask_b(nb) .ne. 0) then
               dist = map_distance(map%xc_a(na),map%yc_a(na),map%xc_b(nb),map%yc_b(nb))
#ifdef _OPENMP
               if (dist < dmin_ar(omp_get_thread_num())) then
                  dmin_ar(omp_get_thread_num())  = dist
                  nb_nn_ar(omp_get_thread_num()) = nb
               endif
#else
               if (dist < dmin) then
                  dmin = dist
                  nb_nn = nb
               endif
#endif
            endif
         enddo ! nb
         !$OMP END PARALLEL DO

#ifdef _OPENMP
         dmin = minval(dmin_ar)
         do nb=omp_get_max_threads(),1,-1
            if (dmin_ar(nb).eq.dmin) then
              nb_nn = nb_nn_ar(nb)
            end if
         end do
#endif

         if (nb_nn > 0) then
            map%col(ns) = na
            map%row(ns) = nb_nn
            map%S  (ns) = map%area_a(na)/map%area_b(nb_nn)
         else
            write(6,*) subname,'ERROR: found no nearest neighbor for src cell ',na
            call shr_sys_abort()
         endif
      endif
   end do ! na

   call shr_timer_stop (t0)
   call shr_timer_print(t0)

   if (ns /= map%n_s) then
      write(6,*) subname,' ERROR in ns ',ns,map%n_s
      call shr_sys_abort()
   endif

end subroutine map_gennn0

!===============================================================================
!===============================================================================

SUBROUTINE map_gennn(map)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       ! sMatrix info to be read in

   !--- local ---
   integer         :: i,j,n,m         ! generic indicies
   integer         :: istart,iend,jstart,jend
   integer         :: ns,cnt,ifound
   real(r8)        :: dist,dmin
   real(r8)        :: sum1,sum2

   !--- formats ---
   character(*),parameter :: subName = "(map_gennn) "
   character(*),parameter ::   F00 = "('(map_gennn) ',3a)"
   character(*),parameter ::   F02 = "('(map_gennn) ',a11,a3,60(a1))"

!-------------------------------------------------------------------------------
! NOTES:
! - needs debugging: may fail or generate nn maps with errors -kauff, 2009 Mar
!-------------------------------------------------------------------------------

   write(6,*) subname,'WARNING: this routine needs debugging.'
   call shr_sys_abort()

   deallocate(map%s  )
   deallocate(map%row)
   deallocate(map%col)

   map%n_s = 0
   do n = 1,map%n_a
      if (map%mask_a(n) > 0) map%n_s = map%n_s + 1
   enddo

   write(6,*) ' '
   write(6,*) subname,' found ',map%n_s,' points out of ',map%n_a,' points total'

   allocate(map%s  (map%n_s))
   allocate(map%row(map%n_s))
   allocate(map%col(map%n_s))

   cnt = 0
   sum1 = 0.0_r8
   sum2 = 0.0_r8
   do n = 1,map%n_a
      dmin = 1.0e36
      ifound = 0
      if (map%mask_a(n) > 0) then
         cnt = cnt + 1
         if (mod(cnt,map%n_s/50) == 1) write(6,*) subname,' doing nn ',cnt,' of ',map%n_s
         ! --- find bounding box, use +- 2 lons and lats
         call map_boundpta(map,n,istart,iend,jstart,jend)
         if (iend > istart) then
            do j = jstart,jend
            do i = istart,iend
               sum1 = sum1 + 1.0_r8
               ns = (j-1)*map%ni_b + i
               if (map%mask_b(ns) > 0) then
                  sum2 = sum2 + 1.0_r8
                  dist = map_distance(map%xc_a(n),map%yc_a(n),map%xc_b(ns),map%yc_b(ns))
                  if (dist < dmin) then
                     dmin = dist
                     ifound = ns
                  endif
               endif
            enddo
            enddo
         else
            do j = jstart,jend
            do i = 1,iend
               sum1 = sum1 + 1.0_r8
               ns = (j-1)*map%ni_b + i
               if (map%mask_b(ns) > 0) then
                  sum2 = sum2 + 1.0_r8
                  dist = map_distance(map%xc_a(n),map%yc_a(n),map%xc_b(ns),map%yc_b(ns))
                  if (dist < dmin) then
                     dmin = dist
                     ifound = ns
                  endif
               endif
            enddo
            do i = istart,map%ni_b
               sum1 = sum1 + 1.0_r8
               ns = (j-1)*map%ni_b + i
               if (map%mask_b(ns) > 0) then
                  sum2 = sum2 + 1.0_r8
                  dist = map_distance(map%xc_a(n),map%yc_a(n),map%xc_b(ns),map%yc_b(ns))
                  if (dist < dmin) then
                     dmin = dist
                     ifound = ns
                  endif
               endif
            enddo
            enddo
         endif
         if (ifound > 0) then
            map%col(cnt) = n
            map%row(cnt) = ifound
!            map%S(cnt) = map%area_b(ifound)/map%area_a(n)
            map%S(cnt) = map%area_a(n)/map%area_b(ifound)
         else
            write(6,*) subname,' ERROR in min dist search ',ifound,n,cnt
            call shr_sys_abort()
         endif
      endif
   enddo

   write(6,*) ' '
   write(6,*) subname,' avg ndst srch cells per src cell  = ',sum1/(map%n_s)
   write(6,*) subname,' percent of nonmask dst cells = ',sum2/(sum1)
   write(6,*) ' '

   if (cnt /= map%n_s) then
      write(6,*) subname,' ERROR in cnt ',cnt,map%n_s
      call shr_sys_abort()
   endif

end subroutine map_gennn

!===============================================================================

subroutine map_boundpta(map,na,istart,iend,jstart,jend)
   implicit none

   type(sMatrix),intent(in)  :: map       ! sMatrix info to write out
   integer      ,intent(in)  :: na
   integer      ,intent(out) :: istart,iend,jstart,jend

   integer :: n,im,ip,jm,jp
   integer :: nbound,ilon,ilat
   integer :: i,j,k
   integer :: nmin,dmax,num
   
   character(len=*),parameter :: subname = '(map_boundpta) '

   call map_bxindex(map%xc_a(na),map%yc_a(na),ilon,ilat)

   istart = map%imin_b(ilon,ilat)
   iend   = map%imax_b(ilon,ilat)
   jstart = map%jmin_b(ilon,ilat)
   jend   = map%jmax_b(ilon,ilat)

   if (istart < 1 .or. iend < 1 .or. istart > map%ni_b .or. iend > map%ni_b .or. &
       jstart < 1 .or. jend < 1 .or. jstart > map%nj_b .or. jend > map%nj_b) then
      write(6,*) subname,' ERROR in indices ',na,ilon,ilat,istart,iend,jstart,jend
      call shr_sys_abort()
   endif

end subroutine map_boundpta

!===============================================================================

SUBROUTINE map_print(map)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(in)      :: map       ! sMatrix info to write out

   !--- local ---
   integer               :: i,j,n,m   ! generic indicies

   !--- formats ---
   character(len=*),parameter :: subname = '(map_print) '
   character(len=*),parameter :: F00 = "('(map_print) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o writes map information into CSM format sparse matrix data file (netCDF file)
! 
! NOTE:
!-------------------------------------------------------------------------------

   !-----------------------------------------------------------------
   ! global attributes
   !-----------------------------------------------------------------
   write(6,*) subname,' title = ',trim(map%title)
   write(6,*) subname,' normal = ',trim(map%normal)
   write(6,*) subname,' method = ',trim(map%method)
   write(6,*) subname,' history = ',trim(map%history)
   write(6,*) subname,' convention = ',trim(map%convention)
   write(6,*) subname,' domain_a = ',trim(map%domain_a)
   write(6,*) subname,' domain_b = ',trim(map%domain_b)
   write(6,*) ' '
   write(6,*) subname,' n_a  = ',map%n_a
   write(6,*) subname,' ni_a = ',map%ni_a
   write(6,*) subname,' nj_a = ',map%nj_a
   write(6,*) subname,' xc_a = ',minval(map%xc_a),maxval(map%xc_a)
   write(6,*) subname,' yc_a = ',minval(map%yc_a),maxval(map%yc_a)
   write(6,*) subname,' xv_a = ',minval(map%xv_a),maxval(map%xv_a)
   write(6,*) subname,' yv_a = ',minval(map%yv_a),maxval(map%yv_a)
   write(6,*) subname,' mask_a = ',minval(map%mask_a),maxval(map%mask_a),sum(map%mask_a)
   write(6,*) subname,' frac_a = ',minval(map%frac_a),maxval(map%frac_a),sum(map%frac_a)
   write(6,*) subname,' area_a = ',minval(map%area_a),maxval(map%area_a),sum(map%area_a)
   write(6,*) ' '
   write(6,*) subname,' n_b  = ',map%n_b
   write(6,*) subname,' ni_b = ',map%ni_b
   write(6,*) subname,' nj_b = ',map%nj_b
   write(6,*) subname,' xc_b = ',minval(map%xc_b),maxval(map%xc_b)
   write(6,*) subname,' yc_b = ',minval(map%yc_b),maxval(map%yc_b)
   write(6,*) subname,' xv_b = ',minval(map%xv_b),maxval(map%xv_b)
   write(6,*) subname,' yv_b = ',minval(map%yv_b),maxval(map%yv_b)
   write(6,*) subname,' mask_b = ',minval(map%mask_b),maxval(map%mask_b),sum(map%mask_b)
   write(6,*) subname,' frac_b = ',minval(map%frac_b),maxval(map%frac_b),sum(map%frac_b)
   write(6,*) subname,' area_b = ',minval(map%area_b),maxval(map%area_b),sum(map%area_b)
   write(6,*) ' '
   write(6,*) subname,' n_s    = ',map%n_s
   write(6,*) subname,' size S = ',size(map%S),size(map%row),size(map%col)
   write(6,*) subname,' S      = ',minval(map%S),maxval(map%S)
   write(6,*) subname,' ROW    = ',minval(map%ROW),maxval(map%ROW)
   write(6,*) subname,' COL    = ',minval(map%COL),maxval(map%COL)
   write(6,*) ' '

   write(6,*) ' '
   write(6,*) subname,' Sample bin output, box number nibx,njbx = ',nibx,njbx
   do j = 1,njbx,njbx/5
   do i = 1,nibx,nibx/5
      write(6,'(a,a,2i7,a,2i7,a,2i7)') subname,' imin,imax,jmin,jmax = ',i,j,':',map%imin_b(i,j),map%imax_b(i,j),':',map%jmin_b(i,j),map%jmax_b(i,j)
   enddo
   enddo
   write(6,*) ' '

END SUBROUTINE map_print

!===============================================================================
SUBROUTINE map_write(map, filename)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(in)      :: map       ! sMatrix info to write out
   character(*) , intent(in)      :: filename  ! name of data file

   !--- local ---
   integer               :: i,n,m   ! generic indicies
   character(len= 8)     :: cdate   ! wall clock date
   character(len=10)     :: ctime   ! wall clock time


 ! character,allocatable :: str(:)  ! variable length char string
   character(strLen)     :: str     ! variable length char string
   character(strLen)     :: attstr  ! netCDF attribute name string
   integer               :: rcode   ! netCDF routine return code
   integer               :: fid     ! netCDF file      ID
   integer               :: vid     ! netCDF variable  ID
   integer               :: did     ! netCDF dimension ID
   integer               :: vdid(2) ! vector of nc dimension ID

   !--- formats ---
   character(len=*),parameter :: F00 = "('(map_write) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o writes map information into CSM format sparse matrix data file (netCDF file)
! 
! NOTE:
!-------------------------------------------------------------------------------

   !-----------------------------------------------------------------
   ! create a new nc file
   !-----------------------------------------------------------------
!  rcode = nf_create(trim(filename),NF_CLOBBER,fid)
   rcode = nf_create(trim(filename),IOR(NF_CLOBBER,NF_64BIT_OFFSET),fid)
   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)

   !-----------------------------------------------------------------
   ! global attributes
   !-----------------------------------------------------------------
    str  = map%title
   rcode = nf_put_att_text(fid,NF_GLOBAL,'title'      ,len_trim(str),str)
    str  = map%normal
   rcode = nf_put_att_text(fid,NF_GLOBAL,'normalization',len_trim(str),str)
    str  = map%method
   rcode = nf_put_att_text(fid,NF_GLOBAL,'map_method' ,len_trim(str),str)
    str  = "$SVN"
   rcode = nf_put_att_text(fid,NF_GLOBAL,'SVN URL'     ,len_trim(str),str)
    str  = "$Id"
   rcode = nf_put_att_text(fid,NF_GLOBAL,'SVN Id'      ,len_trim(str),str)
    str  = map%history
   call date_and_time(cdate,ctime) ! f90 intrinsic
    str = 'File created: '//cdate(1:4)//'-'//cdate(5:6)//'-'//cdate(7:8) &
   &                 //' '//ctime(1:2)//':'//ctime(3:4)//':'//ctime(5:6)
   rcode = nf_put_att_text(fid,NF_GLOBAL,'history'    ,len_trim(str),str)
    str  = map%convention
   rcode = nf_put_att_text(fid,NF_GLOBAL,'conventions',len_trim(str),str)
    str  = map%domain_a
   rcode = nf_put_att_text(fid,NF_GLOBAL,'domain_a'   ,len_trim(str),str)
    str  = map%domain_b
   rcode = nf_put_att_text(fid,NF_GLOBAL,'domain_b'   ,len_trim(str),str)

   !-----------------------------------------------------------------
   ! dimension data
   !-----------------------------------------------------------------
   rcode = nf_def_dim(fid, 'n_a' , map%n_a , did) ! # of points total
   rcode = nf_def_dim(fid, 'ni_a', map%ni_a, did) ! # of points wrt i
   rcode = nf_def_dim(fid, 'nj_a', map%nj_a, did) ! # of points wrt j
   rcode = nf_def_dim(fid, 'nv_a',  4      , did) ! # of verticies per cell

   rcode = nf_def_dim(fid, 'n_b' , map%n_b , did) ! # of points total
   rcode = nf_def_dim(fid, 'ni_b', map%ni_b, did) ! # of points wrt i
   rcode = nf_def_dim(fid, 'nj_b', map%nj_b, did) ! # of points wrt j
   rcode = nf_def_dim(fid, 'nv_b',  4      , did) ! # of verticies per cell

   rcode = nf_def_dim(fid, 'n_s' , map%n_s , did) ! size of sparse matrix

   !-----------------------------------------------------------------
   ! define data -- coordinates, input grid
   !-----------------------------------------------------------------

   rcode = nf_inq_dimid(fid,'n_a' , did   )

   rcode = nf_def_var  (fid,'xc_a',NF_DOUBLE,1,did,vid)
   str   = 'longitude of grid cell center (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees east'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)

   rcode = nf_def_var  (fid,'yc_a',NF_DOUBLE,1,did,vid)
   str   = 'latitude of grid cell center (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees north'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)

   rcode = nf_inq_dimid(fid,'nv_a'     ,vdid(1))
   rcode = nf_inq_dimid(fid,'n_a'      ,vdid(2))

   rcode = nf_def_var  (fid,'xv_a',NF_DOUBLE,2,vdid,vid)
   str   = 'longitude of grid cell verticies (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees east'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)

   rcode = nf_def_var  (fid,'yv_a',NF_DOUBLE,2,vdid,vid)
   str   = 'latitude of grid cell verticies (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees north'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)


   rcode = nf_def_var  (fid,'mask_a',NF_INT ,1,did,vid)
   str   = 'domain mask (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   rcode = nf_def_var  (fid,'area_a',NF_DOUBLE ,1,did,vid)
   str   = 'area of cell (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   rcode = nf_def_var  (fid,'frac_a',NF_DOUBLE ,1,did,vid)
   str   = 'fraction of domain intersection (input)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   !-----------------------------------------------------------------
   ! define data -- coordinates, output grid
   !-----------------------------------------------------------------

   rcode = nf_inq_dimid(fid,'n_b'      ,did)
   if (rcode.ne.NF_NOERR) write(*,F00)  'n_b 1',nf_strerror(rcode)

   rcode = nf_def_var  (fid,'xc_b',NF_DOUBLE,1,did,vid)
   str   = 'longitude of grid cell center (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees east'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)

   rcode = nf_def_var  (fid,'yc_b',NF_DOUBLE,1,did,vid)
   str   = 'latitude of grid cell center (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees north'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)

   rcode = nf_inq_dimid(fid,'nv_b'     ,vdid(1))
   rcode = nf_inq_dimid(fid,'n_b'      ,vdid(2))

   rcode = nf_def_var  (fid,'xv_b',NF_DOUBLE,2,vdid,vid)
   str   = 'longitude of grid cell verticies (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees east'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)

   rcode = nf_def_var  (fid,'yv_b',NF_DOUBLE,2,vdid,vid)
   str   = 'latitude of grid cell verticies (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)
   str   = 'degrees north'
   rcode = nf_put_att_text(fid,vid,"units"    ,len_trim(str),str)


   rcode = nf_def_var  (fid,'mask_b',NF_INT ,1,did,vid)
   str   = 'domain mask (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   rcode = nf_def_var  (fid,'area_b',NF_DOUBLE ,1,did,vid)
   str   = 'area of cell (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   rcode = nf_def_var  (fid,'frac_b',NF_DOUBLE ,1,did,vid)
   str   = 'fraction of domain intersection (output)'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   !-----------------------------------------------------------------
   ! define data -- matrix elements
   !-----------------------------------------------------------------

   !code = nf_inq_dimid(fid,'n_wgts',vdid(1)) ! no gradients!
   rcode = nf_inq_dimid(fid,'n_s'   , did   )
   rcode = nf_def_var  (fid,'S',NF_DOUBLE,1,did,vid)
   str   = 'sparse matrix for mapping S:a->b'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   rcode = nf_inq_dimid(fid,'n_s'   ,did)

   rcode = nf_def_var  (fid,'col',NF_INT ,1,did,vid)
   str   = 'column corresponding to matrix elements'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   rcode = nf_def_var  (fid,'row',NF_INT ,1,did,vid)
   str   = 'row corresponding to matrix elements'
   rcode = nf_put_att_text(fid,vid,"long_name",len_trim(str),str)

   !-----------------------------------------------------------------
   ! put data
   !-----------------------------------------------------------------
   rcode = nf_enddef(fid)

   rcode = nf_inq_varid     (fid,'xc_a', vid)
   rcode = nf_put_var_double(fid,  vid ,map%xc_a)
   rcode = nf_inq_varid     (fid,'yc_a', vid)
   rcode = nf_put_var_double(fid,  vid ,map%yc_a)
   rcode = nf_inq_varid     (fid,'xv_a', vid)
   rcode = nf_put_var_double(fid,  vid ,map%xv_a)
   rcode = nf_inq_varid     (fid,'yv_a', vid)
   rcode = nf_put_var_double(fid,  vid ,map%yv_a)
   rcode = nf_inq_varid     (fid,'mask_a',vid)
   rcode = nf_put_var_int   (fid,    vid , map%mask_a)
   rcode = nf_inq_varid     (fid,'area_a', vid)
   rcode = nf_put_var_double(fid,  vid ,map%area_a)
   rcode = nf_inq_varid     (fid,'frac_a', vid)
   rcode = nf_put_var_double(fid,  vid ,map%frac_a)

   rcode = nf_inq_varid     (fid,'xc_b', vid)
   rcode = nf_put_var_double(fid,  vid ,map%xc_b)
   rcode = nf_inq_varid     (fid,'yc_b', vid)
   rcode = nf_put_var_double(fid,  vid ,map%yc_b)
   rcode = nf_inq_varid     (fid,'xv_b', vid)
   rcode = nf_put_var_double(fid,  vid ,map%xv_b)
   rcode = nf_inq_varid     (fid,'yv_b', vid)
   rcode = nf_put_var_double(fid,  vid ,map%yv_b)
   rcode = nf_inq_varid     (fid,'mask_b',vid)
   rcode = nf_put_var_int   (fid,    vid , map%mask_b)
   rcode = nf_inq_varid     (fid,'area_b', vid)
   rcode = nf_put_var_double(fid,  vid ,map%area_b)
   rcode = nf_inq_varid     (fid,'frac_b', vid)
   rcode = nf_put_var_double(fid,  vid ,map%frac_b)

   rcode = nf_inq_varid     (fid,  'S',vid)
   rcode = nf_put_var_double(fid, vid, map%s) ! no gradients!
   rcode = nf_inq_varid     (fid,'row',vid)
   rcode = nf_put_var_int   (fid, vid, map%row)
   rcode = nf_inq_varid     (fid,'col',vid)
   rcode = nf_put_var_int   (fid, vid, map%col)

   rcode = nf_close(fid)

   if (rcode.ne.NF_NOERR) write(*,F00) nf_strerror(rcode)


END SUBROUTINE map_write

!===============================================================================

SUBROUTINE map_Sn1(map)

   implicit none

   !--- arguments ---
   type(sMatrix),intent(inout) :: map

   !--- local ---
   integer :: i,n

!-------------------------------------------------------------------------------
! PURPOSE:
! X compute sn1(i) = least n st row(n)=i 
!                  = least link number specifying a mapping
!                    to the ith destination point (ith row number).
! o compute sn1(i) = # of links for this row
! o compute sn2(i) = total # of links for row < i
!-------------------------------------------------------------------------------

!  i=0 ! last row for which sn1(i) was calculated
!  do n=1,map%n_s
!    if (map%row(n) /= i) then
!      map%sn1(i+1:map%row(n)) = n
!      i=map%row(n)
!    endif
!  enddo
!  map%sn1(i+1:map%n_b+1)=map%n_s+1

   map%sn1 = 0
   map%sn2 = 0
   do n=1,map%n_s
     map%sn1(map%row(n)) = map%sn1(map%row(n))+1
   enddo
   do n=2,map%n_b
     map%sn2(n) = map%sn2(n-1) + map%sn1(n-1)
   enddo

END SUBROUTINE map_Sn1

!===============================================================================

SUBROUTINE map_dup(map_in,map_out)

   implicit none

   !--- arguments ---
   type(sMatrix),intent( in)   :: map_in
   type(sMatrix),intent(inout) :: map_out

   !--- local ---
   integer :: rcode ! return code

!-------------------------------------------------------------------------------
! PURPOSE:
! o create a duplicate copy a sparse_matrix (cannot deallocate existing data)
!
! NOTES
! o the return code allows the deallocate to fail without stopping program 
!   exectution.  This would happen, eg, if the pointer had never been 
!   allocated to begin with (dealloc doesn't like undefined pointers). 
!   F90 has no way (?) of testing an undefined pointer (eg. never allocated).
!   See Fortran 90/95 Explained, Melcaf, 1998, p 124, 175
!-------------------------------------------------------------------------------

   !------------------------------------------------
   ! de-allocate space
   !------------------------------------------------
   deallocate(map_out%  xc_a,STAT=rcode) 
   deallocate(map_out%  yc_a,STAT=rcode) 
   deallocate(map_out%  xv_a,STAT=rcode) 
   deallocate(map_out%  yv_a,STAT=rcode) 
   deallocate(map_out%mask_a,STAT=rcode) 
   deallocate(map_out%area_a,STAT=rcode) 

   deallocate(map_out%  xc_b,STAT=rcode) 
   deallocate(map_out%  yc_b,STAT=rcode) 
   deallocate(map_out%  xv_b,STAT=rcode) 
   deallocate(map_out%  yv_b,STAT=rcode) 
   deallocate(map_out%mask_b,STAT=rcode) 
   deallocate(map_out%area_b,STAT=rcode) 

   deallocate(map_out%frac_a,STAT=rcode) 
   deallocate(map_out%frac_b,STAT=rcode) 

   deallocate(map_out%s     ,STAT=rcode) 
   deallocate(map_out%row   ,STAT=rcode) 
   deallocate(map_out%col   ,STAT=rcode) 
   deallocate(map_out%sn1   ,STAT=rcode) 
   deallocate(map_out%sn2   ,STAT=rcode) 

   !------------------------------------------------
   ! allocate space
   !------------------------------------------------
   allocate(map_out%  xc_a(  map_in%n_a) )
   allocate(map_out%  yc_a(  map_in%n_a) )
   allocate(map_out%  xv_a(4,map_in%n_a) )
   allocate(map_out%  yv_a(4,map_in%n_a) )
   allocate(map_out%mask_a(  map_in%n_a) )
   allocate(map_out%area_a(  map_in%n_a) )

   allocate(map_out%  xc_b(  map_in%n_b) )
   allocate(map_out%  yc_b(  map_in%n_b) )
   allocate(map_out%  xv_b(4,map_in%n_b) )
   allocate(map_out%  yv_b(4,map_in%n_b) )
   allocate(map_out%mask_b(  map_in%n_b) )
   allocate(map_out%area_b(  map_in%n_b) )

   allocate(map_out%frac_a(map_in%n_a) )
   allocate(map_out%frac_b(map_in%n_b) )  

   allocate(map_out%s     (map_in%n_s) )  
   allocate(map_out%row   (map_in%n_s) )  
   allocate(map_out%col   (map_in%n_s) )  
   allocate(map_out%sn1   (map_in%n_b) )  
   allocate(map_out%sn2   (map_in%n_b) )  

   !------------------------------------------------
   ! set values
   !------------------------------------------------
   map_out%   n_a = map_in%   n_a
   map_out%  ni_a = map_in%  ni_a
   map_out%  nj_a = map_in%  nj_a
   map_out%  xc_a = map_in%  xc_a
   map_out%  yc_a = map_in%  yc_a
   map_out%  xv_a = map_in%  xv_a
   map_out%  yv_a = map_in%  yv_a
   map_out%mask_a = map_in%mask_a
   map_out%area_a = map_in%area_a

   map_out%   n_b = map_in%   n_b
   map_out%  ni_b = map_in%  ni_b
   map_out%  nj_b = map_in%  nj_b
   map_out%  xc_b = map_in%  xc_b
   map_out%  yc_b = map_in%  yc_b
   map_out%  xv_b = map_in%  xv_b
   map_out%  yv_b = map_in%  yv_b
   map_out%mask_b = map_in%mask_b
   map_out%area_b = map_in%area_b

   map_out%frac_a = map_in%frac_a
   map_out%frac_b = map_in%frac_b

   map_out%n_s    = map_in%n_s
   map_out%s      = map_in%s
   map_out%row    = map_in%row
   map_out%col    = map_in%col
   map_out%sn1    = map_in%sn1
   map_out%sn2    = map_in%sn2

   map_out%title      = map_in%title
   map_out%normal     = map_in%normal
   map_out%method     = map_in%method
   map_out%history    = map_in%history
   map_out%convention = map_in%convention
   map_out%domain_a   = map_in%domain_a
   map_out%domain_b   = map_in%domain_b

END SUBROUTINE map_dup

!===============================================================================

SUBROUTINE map_free(map)

   !--- modules ---

   implicit none

   !--- includes ---

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       ! sMatrix to be deallocated

   !--- local ---
   integer :: rcode ! return code

   !--- formats ---
   character(len=*),parameter :: F00 = "('(map_free) ',3a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o deallocate a map matrix data type
! 
! NOTES
! o the return code allows the deallocate to fail without stopping program 
!   exectution.  This would happen, eg, if the pointer had never been 
!   allocated to begin with (dealloc doesn't like undefined pointers). 
!   F90 has no way (?) of testing an undefined pointer (eg. never allocated).
!   See Fortran 90/95 Explained, Melcaf, 1998, p 124, 175
!-------------------------------------------------------------------------------

   !-----------------------------------------------
   ! unset global attributes
   !-----------------------------------------------
   map%title      = "null-free"
   map%normal     = "null-free"
   map%method     = "null-free"
   map%convention = "null-free"
   map%history    = "null-free"
   map%domain_a   = "null-free"
   map%domain_b   = "null-free"

   !-----------------------------------------------
   ! free "a" domain info 
   !-----------------------------------------------

   deallocate(map%  xc_a,STAT=rcode)
   deallocate(map%  yc_a,STAT=rcode)
   deallocate(map%  xv_a,STAT=rcode)
   deallocate(map%  yv_a,STAT=rcode)
   deallocate(map%mask_a,STAT=rcode)
   deallocate(map%area_a,STAT=rcode)
   deallocate(map%frac_a,STAT=rcode)

   !-----------------------------------------------
   ! free "b" domain info 
   !-----------------------------------------------

   deallocate(map%  xc_b,STAT=rcode)
   deallocate(map%  yc_b,STAT=rcode)
   deallocate(map%  xv_b,STAT=rcode)
   deallocate(map%  yv_b,STAT=rcode)
   deallocate(map%mask_b,STAT=rcode)
   deallocate(map%area_b,STAT=rcode)
   deallocate(map%frac_b,STAT=rcode)

   !-----------------------------------------------
   ! free matrix info 
   !-----------------------------------------------
   deallocate(map%s  ,STAT=rcode)
   deallocate(map%row,STAT=rcode)
   deallocate(map%col,STAT=rcode)
   deallocate(map%sn1,STAT=rcode)
   deallocate(map%sn2,STAT=rcode)

END SUBROUTINE map_free

!===============================================================================

subroutine map_bxindex(lon,lat,ibx,jbx)

   implicit none

   !--- arguments ---
   real(r8)   , intent(in) :: lon,lat
   integer, intent(out) :: ibx,jbx

   !--- local ---
   real(r8) :: llon,llat
   character(*),parameter :: subName = "(map_bxindex) "
   real(r8),parameter :: lonmin =  0.0_r8
   real(r8),parameter :: lonmax =  360.0_r8
   real(r8),parameter :: latmin = -90.0_r8
   real(r8),parameter :: latmax =  90.0_r8


!-------------------------------------------------------------------------------
! PURPOSE:
!   derives the bx index for a given lon, lat.
!-------------------------------------------------------------------------------

   llat = lat
   llon = mod(lon+720.0_r8,360.0_r8)

   if (llat < latmin .or. llat > latmax) then
      write(6,*) subname,' ERROR in lat ',llat
      call shr_sys_abort()
   endif

   if (llon < lonmin .or. llon > lonmax) then
      write(6,*) subname,' ERROR in lon ',llon
      call shr_sys_abort()
   endif

   if (llon == lonmax) then
      ibx = nibx
   else
      ibx = ((llon - lonmin) / (lonmax -lonmin)) * (nibx * 1.0_r8) + 1
   endif
   if (llat == latmax) then
      jbx = njbx
   else
      jbx = ((llat - latmin) / (latmax -latmin)) * (njbx * 1.0_r8) + 1
   endif

   if (ibx < 1 .or. ibx > nibx .or. jbx < 1 .or. jbx > njbx) then
      write(6,*) subname,' ERROR in ibx,jbx ',ibx,jbx,nibx,njbx
   endif
   

end subroutine map_bxindex

!===============================================================================
!===============================================================================

integer FUNCTION nSij(smat,i,j)

   implicit none

   !--- arguments ---
   type(sMatrix),intent(in ) :: smat ! sparse matrix data type
   integer      ,intent(in ) :: i,j  ! index into A(i,j)

   !--- local ---
   integer    :: n                   ! generic index 

!-------------------------------------------------------------------------------
! PURPOSE:
!   find n st (i,j) = (row(n),col(n))
!   else return 0
!-------------------------------------------------------------------------------

!  nSij=0
!  do n=smat%sn1(i),smat%sn1(i+1)-1
!    if ( smat%col(n) == j ) exit
!  end do
!  if ( smat%row(n)/=i   .or.  smat%col(n)/=j ) then
!     nSij = 0
!  else
!     nSij = n
!  end if

   nSij=0
   if (smat%sn1(i) > 0) then
      do n=smat%sn2(i)+1,smat%sn2(i)+smat%sn1(i)
        if (smat%col(n) == j) exit
      enddo
      if ( smat%row(n)/=i   .or.  smat%col(n)/=j ) then
         nSij = 0
      else
         nSij = n
      end if
   endif

END FUNCTION nSij

!===============================================================================

SUBROUTINE map_matMatMult(A,B,S)

   implicit none

   !--- arguments ---
   type(sMatrix),intent(in )   :: A  ! sparse matrix data type: B=SA
   type(sMatrix),intent(in )   :: S  ! sparse matrix data type: B=SA
   type(sMatrix),intent(inout) :: B  ! sparse matrix data type: B=SA

   !--- local ---
   integer    :: ib,jb             ! index wrt B(j,i)
   integer    :: ia,ja             ! index wrt A(j,i)
   integer    :: is,js             ! index wrt S(i,j)
   integer    :: i,j,k             ! index wrt A(j,k),S(i,j),B(j,k)
   integer    :: ns                ! index wrt S(n) 
   integer    :: m                 ! index wrt b(i,m),a(j,m)
   integer    :: n                 ! index wrt S%S(n)
   integer    :: na                ! index wrt A%S(n)
   integer    :: nb                ! index wrt B%S(n)
   integer    :: nbMax             ! max size of B%S(n)
   real(r8)   :: sum               ! register variable for b(i,m)
   integer    :: t1 = 0            ! system-clock-timer number
   integer    :: t0 = 0            ! system-clock-timer number
   integer    :: nMod              ! for periodic timer output
   integer    :: ni
   integer,pointer :: itemp(:)
   real(r8)   ,pointer :: temp(:)
   integer    :: esize

#ifdef  _OPENMP
   integer  :: omp_get_max_threads !  $OMP function call
#endif

   !--- formats ---
   character(len=*),parameter :: F00 = "('<map_matMatMult> ',a,50(f6.2 ))"
   character(len=*),parameter :: F01 = "('<map_matMatMult> ',a,50(i3,3x))"
   character(len=*),parameter :: F02 = "('<map_matMatMult> ',    f7.3 )"
   character(len=*),parameter :: F03 = "('<map_matMatMult> ',a,i5,a,i2)"
   character(len=*),parameter :: F04 = "('<map_matMatMult> ',a,2i10)"

   character(8)   :: dstr       ! F90 wall clock date string yyyymmdd
   character(10)  :: tstr       ! F90 wall clock time string hhmmss.sss
   character(*),parameter :: F10 = "('(map_matMatMult) ',a,i7,' date & time:',1x, &
                                 &   a4,2('-',a2),2x,a2,2(':',a2))"
   character(*),parameter :: subName = "(map_matMatMult) "

!-------------------------------------------------------------------------------
! PURPOSE:
!   does a sparse-matrix-multiply: B = S*A 
! ASSUMPTION:
!   o matricies are st for S(n) ~ S(i,j), 
!     * i(n) is monotonically increasing
!     * if i(n) = constant for n = n0,..n1 
!       then j(n) is monotonically increasing for n = n0,...n1
!   o B%s(:) is sufficiently large to store incoming data
!-------------------------------------------------------------------------------


   if (t0 == 0) then
      call shr_timer_get  (t0,subName//"matrix multiply - all")
      call shr_timer_get  (t1,subName//"matrix multiply - 100k rows")
      nMod = 100000 ! "100k" referred to by timer
#ifdef  _OPENMP
     n = omp_get_max_threads()
     write(6,F03) 'FYI: this routine is threaded, omp_get_max_threads() = ',n
#else
     write(6,F03) 'FYI: this routine is not threaded'
#endif
   end if

   if (B%n_a /= A%n_a) then
     write(6,*) 'ERROR dim 2 of A & B not the same'
     stop
   end if
   if (B%n_b /= S%n_b) then
     write(6,*) 'ERROR dim 1 of B & S not the same'
     stop
   end if
   if (S%n_a /= A%n_b) then
     write(6,*) 'ERROR dim 2 of S & dim 1 A not the same'
     stop
   end if

   !-----------------------------------------------------------------
   ! matrix multiply 
   !-----------------------------------------------------------------

   write(6,F04) 'matrix-matrix multiply: B = S*A'
   write(6,F04) 'do i=1 to number rows in matrix S:',S%n_b
   write(6,F04) 'do i=k to number cols in matrix A:',A%n_a
   call shr_timer_start(t0)

   !--- array size estimate ---
   esize = (S%n_s/min(S%n_b,A%n_s)) * A%n_s * 2
   esize = int(float(esize) * 1.2)  ! this was necessary for some paleo mapping file - kauff

   deallocate( B%s  )
   deallocate( B%row)
   deallocate( B%col)
   allocate(B%s  (esize))
   allocate(B%row(esize))
   allocate(B%col(esize))
   B%n_s = 0

#if (1 == 0)
   !--- assume A has 1 value per column -- implementation one (slow)

   n = 0
   do i = 1,S%n_b
      do k = 1,A%n_s
         do ni=S%sn2(i)+1,S%sn2(i)+S%sn1(i)
            if (A%row(k) == S%col(ni)) then
               n = n + 1
               if (n > esize) then
                  write(6,*) subname,' ERROR esize too small',esize,n
                  call shr_sys_abort()
               endif
               B%row(n) = S%row(ni)
               B%col(n) = A%col(k)
               B%S(n) = A%S(k) * S%S(ni)
            endif
         enddo
      enddo
      if (mod(i,S%n_b/50) == 0) write(6,*) subname,' done ',i,' of ',S%n_b,'....',100*i/S%n_b,' percent, nwgts = ',n
      if (mod(n,1000000) == 0) write(6,*) subname,' done ',i,' of ',S%n_b,'....',100*i/S%n_b,' percent, nwgts = ',n
   enddo
   B%n_s = n

#endif

#if (1 == 1)
   !--- assume A has 1 value per column -- implementation two

   n = 0
   do i = 1,S%n_b
      do ni=S%sn2(i)+1,S%sn2(i)+S%sn1(i)
         j = S%col(ni)
!         if (S%row(ni) /= i) then
!            write(6,*) subname,' ERROR in s%row(ni),i,ni = ',s%row(ni),i,ni
!            call shr_sys_abort()
!         endif
         do k = A%sn2(j)+1,A%sn2(j)+A%sn1(j)
            n = n + 1
            if (n > esize) then
               write(6,*) subname,' ERROR esize too small',esize,n
               call shr_sys_abort()
            endif
            B%row(n) = S%row(ni)
            B%col(n) = A%col(k)
            B%S(n) = S%S(ni) * A%S(k)
         enddo
      enddo
      if (mod(i,S%n_b/50) == 0) write(6,*) subname,' done ',i,' of ',S%n_b,'....',100*i/S%n_b,' percent'
   enddo
   B%n_s = n

#endif

#if (1 == 0)
   !--- original implementation for general matrix, now hangs with NN maps?

   nbMax = size(B%s)
   nb=0 ! number of non-zero elements in B
!  MP PARALLEL DO PRIVATE(i,j,k,n,na,sum)
   do i=1,S%n_b    !--- i loops over rows of S & B ---
      !------------------------------------------------------
      ! progress report
      !------------------------------------------------------
      if (mod(i-1,nMod)==0) then
         if (i > 1) then
            call shr_timer_stop (t1)
            call shr_timer_print(t1)
            call shr_sys_flush(6)
         end if
         call shr_timer_zero (t1)
         call shr_timer_start(t1)
       ! if (mod(i-1,10000)==0) then
            call date_and_time(dstr,tstr) ! F90 intrinsic routine
            write(6,F10) 'i=',i-1,dstr(1:4),dstr(5:6),dstr(7:8),tstr(1:2),tstr(3:4),tstr(5:6)
       ! end if
      end if
!$OMP PARALLEL DO PRIVATE(j,k,n,na,sum)
      do k=1,A%n_a  !--- k loops over cols of A & B ---
         !------------------------------------------------------
         ! compute B(i,k)
         !------------------------------------------------------
         sum = 0.0
         do n=S%sn2(i)+1,S%sn2(i)+S%sn1(i)  !--- j loops over S cols & A rows ---
!            write(6,*) 'tcx matmult1 ',i,n,s%sn2(i)+1,s%sn2(i)+S%sn1(i)
            j  = S%col(n)          !--- need  S(i,j)*A(j,k) for j=...
            na = nSij(A,j,k)       !--- A(na) = A(j,k)
!            write(6,*) 'tcx matmult2 ',n,j,k,na,S%S(n),A%S(na)
            if (na>0) sum = sum + S%S(n)*A%S(na)
         end do
         !------------------------------------------------------
         ! if B(i,k) > 0, add element to sparse matrix data
         !------------------------------------------------------
         if (sum /= 0.0) then 
!$OMP CRITICAL
            nb    = nb+1
            B%n_s = nb
            n     = nb
!$OMP END CRITICAL
            if (n > nbMax ) then
               write(6,*) 'ERROR: nb > nbMax (fatal)'
               call shr_sys_abort(subName//"ERROR: nb > nbMax")
            !  stop ! OMP has a problem with this
            end if
            B%S  (n) = sum
            B%row(n) = i
            B%col(n) = k
         end if
         !------------------------------------------------------
      end do
!$OMP BARRIER
   end do

#endif

   write(6,*) ' '
   write(6,*) subname,' computed ',B%n_s,' weights, size is ',size(B%s)
   write(6,*) ' '
                 
   n = B%n_s 
   allocate(itemp(n))

   itemp(1:n) = B%row(1:n)
   deallocate(B%row)
   allocate(B%row(n))
   B%row(1:n)  = itemp(1:n)

   itemp(1:n) = B%col(1:n)
   deallocate(B%col)
   allocate(B%col(n))
   B%col(1:n)  = itemp(1:n)

   deallocate(itemp)
   allocate(temp(n))

   temp(1:n) = B%S(1:n)
   deallocate(B%S)
   allocate(B%S(n))
   B%S(1:n)  = temp(1:n)

   deallocate(temp)

   call shr_timer_stop (t0)
   call shr_timer_print(t0)

END SUBROUTINE map_matMatMult

!===============================================================================

SUBROUTINE map_check(sMat)

   implicit none

   !--- arguments ---
   type(sMatrix),intent(in )   :: sMat    ! sparse matrix data type: B=SA

   !--- local ---
   integer        :: i,j,k,m,n,p          ! generic index
   integer        :: n0,n1,n2,n3,n4,n5,n6 ! generic counters
   integer        :: n7,n8,n9             ! generic counters
   integer        :: oldrow               ! generic counter
   integer        :: thisrow, thiscol     ! generic counter
   real(r8)       :: sum,maxsum,minsum    ! generic summations
   real(r8)       :: maxerr,avgerr
   real(r8)       :: f                    ! temporary float variable
   real(r8)       :: dist,maxdist         ! distance, max distance
   real(r8)       :: dph,dth              ! dphi,dtheta wrt cell distances
   real(r8)       :: x0,x1,y0,y1,dx,dy    ! 
   real(r8)       :: mn,mx                ! min & max
   integer        :: ncol,mincol,maxcol   ! # of cols per row
   real(r8),parameter :: eps = 1.0e-1         ! epsilon wrt X =? 0.0
   real(r8),allocatable :: colsum(:)          ! column sum w/o  dest area fractions
   real(r8),allocatable :: colfsum(:)         ! column sum with dest area fractions
   integer,allocatable :: colnsum(:)      ! column sum with dest area fractions

   !--- formats ---
   character(len=*),parameter :: F00 = "('(map_check) ',a,5i11)"
   !----------------------------------------------------------------------------
   character(len=*),parameter :: F01 = "('(map_check) row sum    ', &
   &  '     < 0        ~ 0      (0,1)        ~ 1        > 1     epsilon')"
   character(len=*),parameter :: F02 = "('(map_check) row sum    ', &
   &  '---------- ---------- ---------- ---------- ---------- ----------')"
   character(len=*),parameter :: F03 = "('(map_check) row sum # ',5i11,es11.3)"
   character(len=*),parameter :: F04 = "('(map_check) row sum % ',5F11.6)"
   character(len=*),parameter :: F05 = "('(map_check) row sum min/max',2es11.3)"
   character(len=*),parameter :: F06 = "('(map_check) row sum ',&
   & 'min/max cols per row ',2i6)"
   !----------------------------------------------------------------------------
   character(len=*),parameter :: f08 = "('(map_check) col(:) min/max',2i11)"
   character(len=*),parameter :: F08a = "('(map_check) frac_a(:) min/max',2f15.10)"
   character(len=*),parameter :: F09 = "('(map_check) row(:) min/max',2i11)"
   character(len=*),parameter :: F09a = "('(map_check) frac_b(:) min/max',2f15.10)"
   character(len=*),parameter :: F10 = "('(map_check) S(:)   min/max',2es11.3)"
   !----------------------------------------------------------------------------
   character(len=*),parameter :: F11 = "('(map_check) ',a,i11,2a)"
   !----------------------------------------------------------------------------
   character(len=*),parameter :: F12 ="('(map_check) ',a,f15.12,'  basis case')"
   character(len=*),parameter :: f13 = "('(map_check) ',a,f15.12,f13.6,'%')"
   !----------------------------------------------------------------------------
   character(len=*),parameter :: F20 = "('(map_check) ',5a)"
   character(len=*),parameter :: F21 = "('(map_check) ',a,i11,f13.6,'%')"
   character(len=*),parameter :: F22 = "('(map_check) ',a,2i11)"
   character(len=*),parameter :: F23 = "('(map_check) ',a,2f13.6)"

!-------------------------------------------------------------------------------
! PURPOSE:
!   perform a standard battery of tests on a matrix file
!-------------------------------------------------------------------------------

   allocate(colsum (sMat%n_a))
   allocate(colfsum(sMat%n_a))
   allocate(colnsum(sMat%n_a))

   write(6,F20) '=============================================================='
   write(6,F20) 'matrix title: ',trim(sMat%title)
   write(6,F00) 'n_s,n_a,n_b=',sMat%n_s,sMat%n_a,sMat%n_b


if (.true.) then
   write(6,F20) '--------------------------------------------------------------'
   write(6,F00) 'check for correct row/column sorting                          '
   write(6,F20) '--------------------------------------------------------------'
   i=0
   do n=2,sMat%n_s
     if (sMat%row(n-1) > sMat%row(n) ) i=i+1
   enddo
   if (i==0) then
      write(6,F00)    "OK: row(:) is monotonically increasing"
   else
      write(6,F00) "ERROR: row(:) is not monotonically increasing"
   end if

   j=0
   do i=1,sMat%n_s-1
      if (sMat%col(i).gt.sMat%col(i+1).and.sMat%row(i+1).eq.sMat%row(i)) then
         j=j+1
      endif
   enddo
   if (j==0) then
      write(6,F00)    "OK: for row=i, col(:) is monotonically increasing"
   else
      write(6,F00) "WARNING! for row=i, col(:) is not monotonically increasing"
   end if

   !----------------------------------------------------------------------------
   write(6,F00) 'Do S,row,col contain reasonable values?                       '
   !----------------------------------------------------------------------------

   write(6,F08) minval(sMat%col(1:sMat%n_s)),maxval(sMat%col(1:sMat%n_s))
   write(6,F08a) minval(sMat%frac_a(1:sMat%n_a)),maxval(sMat%frac_a(1:sMat%n_a))
   write(6,F09) minval(sMat%row(1:sMat%n_s)),maxval(sMat%row(1:sMat%n_s))
   write(6,F09a) minval(sMat%frac_b(1:sMat%n_b)),maxval(sMat%frac_b(1:sMat%n_b))
!  write(6,F10) minval(sMat%s  (1:sMat%n_s)),maxval(sMat%s  (1:sMat%n_s))
!  too big for Blackforest stack size???
   mn =  1.0e30
   mx = -1.0e30
   do n=1,sMat%n_s
     mn = min(mn,sMat%s(n))
     mx = max(mx,sMat%s(n))
   end do
   write(6,F10) mn,mx

   !----------------------------------------------------------------------------
   write(6,F00) 'Are col->row links unique? (assumes mapping is sorted)    '
   !----------------------------------------------------------------------------

   thisrow = 0
   n1 = 0
   do n=1,sMat%n_s
     if (sMat%row(n) /= thisrow) then
       thisrow = sMat%row(n)
       do m=0,sMat%sn1(thisrow)-2
         if (sMat%col(n+m) == sMat%col(n+m+1)) n1 = n1 + 1
         if (sMat%row(n+m) /= sMat%row(n+m+1)) then
!        write(6,F22) " ERROR:  ",thisrow,sMat%sn1(thisrow)
         endif
       enddo
     endif
   enddo
   if (n1 > 0) then 
     write(6,F11) "WARNING!  found nonunique links between col->row  ",n1
   else
     write(6,F11) "OK, this matrix has unique col->row links"
   endif

   write(6,F20) '--------------------------------------------------------------'
   write(6,F00) 'Definitive conservation check                                 '
   write(6,F20) '--------------------------------------------------------------'

   colsum =0.0
   colnsum=0
   do n=1,sMat%n_s
       i = sMat%row(n)
       j = sMat%col(n)
        colsum(j) =  colsum(j) + sMat%s(n)*sMat%area_b(i)
       colnsum(j) = colnsum(j) + 1
   enddo
   n0=0
   n1=0
   n2=0
   n3=0
   n4=0
   n5=0
   n6=0
   n7=0
   n8=0
   n9=0
   maxerr = 0.0
   avgerr = 0.0
   do j=1,sMat%n_a
     if ( sMat%mask_a(j) /= 0) then
       n0 = n0 + 1
       if ( colnsum(j)==0 ) n5 = n5+1
       if ( sMat%frac_a(j) == 0.0 ) n8 = n8+1
       if ( sMat%frac_a(j) > 0.0 .and. sMat%frac_a(j) < 1.0 ) n9 = n9+1
   !!! if ( abs( colsum(j)-sMat%area_a(j) )/sMat%area_a(j)  < .0001) then
   !   if ( abs( colsum(j)-sMat%area_a(j) )/sMat%area_a(j)  < .001 ) then
   !   if ( abs( colsum(j)-sMat%area_a(j) )/sMat%area_a(j)  < .01 ) then
       if ( abs( colsum(j)-sMat%area_a(j)*sMat%frac_a(j) )/ &
  &               sMat%area_a(j)*sMat%frac_a(j)  < .0000001 ) then
          n1=n1+1
       else
          n2=n2+1
          avgerr = avgerr + abs( colsum(j)-sMat%area_a(j) )/sMat%area_a(j)
          if ( abs( colsum(j)-sMat%area_a(j) )/sMat%area_a(j) > maxerr) then
            maxerr = abs( colsum(j)-sMat%area_a(j) )/sMat%area_a(j)
          end if 
       end if
     else
       if ( colnsum(j) == 0.0) then
          n3=n3+1
       else
          n4=n4+1
       end if
     end if
   enddo
   oldrow = 0
   do j=1,sMat%n_s
     if (sMat%row(j) /= oldrow) then
       if ( sMat%mask_b(sMat%row(j)) /= 0) then
         n6 = n6 + 1
       else
         n7 = n7+1
       end if
       oldrow = sMat%row(j)
     end if
   enddo
   write(6,F22) ' "correct column sum" means' 
   write(6,F22) '  sum over i of S(i,j)*area_b(i) = area_a(j)'
   write(6,F22) "  number of columns                              ",sMat%n_a
   write(6,F22) "  number of active columns                       ",n0
   write(6,F22) "  number of active columns with correct sum      ",n1
   write(6,F22) "  number of active columns with incorrect sum    ",n2
   write(6,F23) "  avg % error of incorrect sum                   ",avgerr/(max(n2,1)*1.0_r8)
   write(6,F23) "  max % error of incorrect sum                   ",maxerr
   write(6,F22) "  number of active columns with no links         ",n5
   write(6,F22) "  number of active columns with frac_a = 0.0     ",n8
   write(6,F22) "  number of active columns with 0.0<frac_a<1.0   ",n9
   write(6,F22) "  number of inactive columns                     ",sMat%n_a-n0
   write(6,F22) "  number of inactive columns with no links       ",n3
   write(6,F22) "  number of inactive columns with some links     ",n4
   write(6,F22) "  number of rows                                 ",sMat%n_b
   write(6,F22) "  number of inactive rows with some links        ",n7
end if

if (.false.) then
   !----------------------------------------------------------------------------
   write(6,F00) 'mapping distance...'
   !----------------------------------------------------------------------------
   maxdist=0.0
   sum    =0.0
   dx = 0.0 ! max dx distance
   dy = 0.0 ! max dy distance
   
   do n=1,sMat%n_s
       i = sMat%row(n)
       j = sMat%col(n)

       x0 = sMat%xc_a(j)
       x1 = sMat%xc_b(i)
       y0 = sMat%yc_a(j)
       y1 = sMat%yc_b(i)

       if (y1<95.0 .and. y0<95.0) then

         if (x1-x0>180.0) x0 = x0 + 360.0
         if (x0-x1>180.0) x1 = x1 + 360.0

         dx = max(dx,abs(x1-x0)*cos(0.5*(y0+y1)*DEGtoRAD))
         dy = max(dy,abs(y1-y0))

!        dph  = (   x0           -     x1)*DEGtoRAD
!        dth  = sin(y0*DEGtoRAD) - sin(y1*DEGtoRAD)
!        dist = sqrt(dth**2 + dph**2)*rEarth
         dph  = (x1-x0)*cos(DEGtoRAD*(y0+y1)/2.0)
         dth  = (y1-y0)
         dist = sqrt(dth**2 + dph**2)*DEGtoRAD*rEarth
         sum = sum+dist
         maxdist = max(maxdist,dist)

       endif

   enddo
   sum = sum/sMat%n_s
   write(6,'(a,f16.3,a)') 'radius of earth at equator           :',2*pi*rEarth,'m'
   write(6,'(a,f16.3,a)') 'max distance between src & dest cells:',maxdist,'m'
   write(6,'(a,f16.3,a)') 'avg distance between src & dest cells:', sum   ,'m'
   write(6,'(a,f16.3,a)') 'max distance/radius of earth at equator:',maxdist/(2*pi*rEarth)
   write(6,'(a,f16.3,a)') 'avg distance/radius of earth at equator:',  sum  /(2*pi*rEarth)
   write(6,*) 'max dx,dy: ',dx,dy

end if

   write(6,F20) '=============================================================='

   deallocate(colsum)
   deallocate(colfsum)
   deallocate(colnsum)

END SUBROUTINE map_check

!===============================================================================

real(r8) FUNCTION map_distance(x0,y0,x1,y1)

   implicit none

   !--- arguments ---
   real(r8), intent(in) :: x0,y0,x1,y1

   !--- local ---
   real(r8) :: dph,dth,myx0,myx1

!-------------------------------------------------------------------------------
! PURPOSE:
!  o Return the distance in meters between two points on the
!    Earth with coordinates (x0,y0) and (x1,y1) in degrees.
!  o NOTE: does not take into account curvature of the grid...
!-------------------------------------------------------------------------------

   myx0 = x0
   myx1 = x1
   if (x1-x0>180.0) myx0 = x0 + 360.0
   if (x0-x1>180.0) myx1 = x1 + 360.0
   dph  = (myx1-myx0)*cos(DEGtoRAD*(y0+y1)/2.0)
   dth  = (y1-y0)
   map_distance = sqrt(dth**2 + dph**2)*DEGtoRAD*rEarth

END FUNCTION map_distance

!===============================================================================
!===============================================================================
END MODULE map_mod
!===============================================================================

!===============================================================================
! SVN $Id: kind_mod.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/kind_mod.F90 $
!===============================================================================

MODULE kind_mod

   use shr_kind_mod
   !----------------------------------------------------------------------------
   ! precision/kind constants add data public
   !----------------------------------------------------------------------------
   public
   integer,parameter :: R8 = SHR_KIND_R8  ! 8 byte real
   integer,parameter :: R4 = SHR_KIND_R4  ! 4 byte real
   integer,parameter :: RN = SHR_KIND_RN  ! native real
   integer,parameter :: I8 = SHR_KIND_I8  ! 8 byte integer
   integer,parameter :: I4 = SHR_KIND_I4  ! 4 byte integer
   integer,parameter :: IN = SHR_KIND_IN  ! native integer
   integer,parameter :: CL = SHR_KIND_CL  ! long char
   integer,parameter :: CS = SHR_KIND_CS  ! short char

END MODULE kind_mod

!===============================================================================
! SVN $Id: shr_kind_mod.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/shr_kind_mod.F90 $
!===============================================================================

MODULE shr_kind_mod

   !----------------------------------------------------------------------------
   ! precision/kind constants add data public
   !----------------------------------------------------------------------------
   public
   integer,parameter :: SHR_KIND_R8 = selected_real_kind(12) ! 8 byte real
   integer,parameter :: SHR_KIND_R4 = selected_real_kind( 6) ! 4 byte real
   integer,parameter :: SHR_KIND_RN = kind(1.0)              ! native real
   integer,parameter :: SHR_KIND_I8 = selected_int_kind (13) ! 8 byte integer
   integer,parameter :: SHR_KIND_I4 = selected_int_kind ( 6) ! 4 byte integer
   integer,parameter :: SHR_KIND_IN = kind(1)                ! native integer
   integer,parameter :: SHR_KIND_CL = 256                    ! long char
   integer,parameter :: SHR_KIND_CS = 80                     ! short char

END MODULE shr_kind_mod

!===============================================================================
! SVN $Id: shr_sys_mod.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/shr_sys_mod.F90 $
!===============================================================================

MODULE shr_sys_mod

   use shr_kind_mod  ! defines real & integer kinds
!  use shr_mpi_mod   ! wraps MPI layer

   implicit none

! PUBLIC: Public interfaces

   private

   public :: shr_sys_system  ! make a system call
   public :: shr_sys_chdir   ! change current working dir
   public :: shr_sys_getenv  ! get an environment variable
   public :: shr_sys_abort   ! abort a program
   public :: shr_sys_irtc    ! returns real-time clock tick
   public :: shr_sys_sleep   ! have program sleep for a while
   public :: shr_sys_flush   ! flush an i/o buffer
   public :: shr_sys_ioUnit  ! returns an unused fortran i/o unit number

!===============================================================================
CONTAINS
!===============================================================================

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_system(str,rcode)

   IMPLICIT none

   !----- arguments ---
   character(len=*)    ,intent(in)  :: str    ! system/shell command string
   integer(SHR_KIND_IN),intent(out) :: rcode  ! function return error code

#if (defined CRAY) || (defined UNICOSMP)
   !----- functions -----
   integer(SHR_KIND_IN),external    :: ishell ! function to envoke shell command
#endif
#if (defined OSF1 || defined SUNOS || (defined LINUX && !defined G95))
   !----- functions -----
   integer(SHR_KIND_IN),external    :: system ! function to envoke shell command
#endif

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

#if (defined CRAY) || (defined UNICOSMP)
   rcode=ishell(str)
#endif

#if (defined IRIX64 || defined NEC_SX)
   rcode = 0
   call system(str)
#endif

#if (defined AIX)
   call system(str,rcode)
#endif

#if (defined OSF1 || defined SUNOS || defined LINUX)
   rcode = system(str)
#endif

#if (!defined CRAY && !defined IRIX64 && !defined AIX && !defined OSF1 && !defined SUNOS && !defined LINUX && !defined NEC_SX && !defined UNICOSMP)
   write(*,*) '(shr_sys_system) ERROR: no implementation for this architecture'
   call shr_sys_abort('no system routine on this machine')
#endif

END SUBROUTINE shr_sys_system

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_chdir(path, rcode)

   IMPLICIT none

   !----- arguments -----
   character(len=*)    ,intent(in)  :: path    ! chdir to this dir
   integer(SHR_KIND_IN),intent(out) :: rcode   ! return code

   !----- local -----
   integer(SHR_KIND_IN)             :: lenpath ! length of path
#if (defined AIX || defined OSF1 || defined SUNOS || (defined LINUX && !defined G95) || defined NEC_SX)
   integer(SHR_KIND_IN),external    :: chdir   ! AIX system call
#endif

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

   lenpath=len_trim(path)

#if (defined IRIX64 || defined CRAY || defined UNICOSMP)
   call pxfchdir(path, lenpath, rcode)
#endif

#if (defined AIX)
   rcode=chdir(%ref(path(1:lenpath)//'\0'))
#endif

#if (defined OSF1 || defined SUNOS || defined LINUX || defined NEC_SX)
   rcode=chdir(path(1:lenpath))
#endif

#if (!defined CRAY && !defined IRIX64 && !defined AIX && !defined OSF1 && !defined SUNOS && !defined LINUX && !defined NEC_SX && !defined UNICOSMP)
   write(*,*) '(shr_sys_chdir) ERROR: no implementation for this architecture'
   call shr_sys_abort('no implementation of chdir for this machine')
#endif

END SUBROUTINE shr_sys_chdir

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_getenv(name, val, rcode)

   IMPLICIT none

   !----- arguments -----
   character(len=*)    ,intent(in)  :: name    ! env var name
   character(len=*)    ,intent(out) :: val     ! env var value
   integer(SHR_KIND_IN),intent(out) :: rcode   ! return code

   !----- local -----
   integer(SHR_KIND_IN)             :: lenname ! length of env var name
   integer(SHR_KIND_IN)             :: lenval  ! length of env var value
   character(len=512)               :: tmpval  ! temporary env var value

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

   lenname=len_trim(name)

#if (defined IRIX64 || defined CRAY || defined UNICOSMP)
   call pxfgetenv(name, lenname, val, lenval, rcode)
#endif

#if (defined AIX || defined OSF1 || defined SUNOS || defined LINUX || defined NEC_SX)
   call getenv(trim(name),tmpval)
   val=trim(tmpval)
   rcode = 0
   if (len_trim(val) ==  0 ) rcode = 1
   if (len_trim(val) > 512 ) rcode = 2
#endif

#if (!defined CRAY && !defined IRIX64 && !defined AIX && !defined OSF1 && !defined SUNOS && !defined LINUX && !defined NEC_SX && !defined UNICOSMP)
   write(*,*) '(shr_sys_getenv) ERROR: no implementation for this architecture'
   call shr_sys_abort('no implementation of getenv for this machine')
#endif

END SUBROUTINE shr_sys_getenv

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_abort(string,rcode)

   IMPLICIT none

   character*(*),optional :: string    ! error message string
   integer(SHR_KIND_IN),optional :: rcode   ! error code

   !----- local -----
   integer(SHR_KIND_IN) :: ierr
   logical              :: flag

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('(shr_sys_abort) ',a)"

!-------------------------------------------------------------------------------
! PURPOSE: consistent stopping mechanism
!-------------------------------------------------------------------------------

   call shr_sys_flush(6)
   if (len_trim(string) > 0) write(6,F00) 'ERROR: '//trim(string)
!  write(6,F00) 'WARNING: calling shr_mpi_abort() and stopping'
   write(6,F00) 'WARNING:                 abort() and stopping'
   call shr_sys_flush(6)
!  call shr_mpi_initialized(flag)
!  if (flag) then
!    if (present(string).and.present(rcode)) then
!      call shr_mpi_abort(trim(string),rcode)
!    elseif (present(string)) then
!      call shr_mpi_abort(trim(string))
!    elseif (present(rcode)) then
!      call shr_mpi_abort(rcode=rcode)
!    else
!      call shr_mpi_abort()
!    endif
!  endif
   call shr_sys_flush(6)
   call abort()
   stop

END SUBROUTINE shr_sys_abort

!===============================================================================
!===============================================================================

integer(SHR_KIND_I8) FUNCTION shr_sys_irtc( rate )

   IMPLICIT none
   !----- optional output argument -----
   integer(SHR_KIND_I8), optional :: rate

   !----- local -----
   integer(SHR_KIND_IN)          :: count
   integer(SHR_KIND_IN)          :: count_rate
   integer(SHR_KIND_IN)          :: count_max

   integer(SHR_KIND_IN),save :: last_count = -1
   integer(SHR_KIND_I8),save :: count_offset = 0

!-------------------------------------------------------------------------------
! emulates Cray/SGI irtc function (returns clock tick since last reboot)
!-------------------------------------------------------------------------------
   call system_clock(count=count,count_rate=count_rate, count_max=count_max)
   if ( present(rate) ) rate = count_rate
   shr_sys_irtc = count
!
! System clock is a 24-hour clock, so must check each time pass over midnight
!
   if ( last_count /= -1 )then
     if ( count < last_count ) count_offset = count_offset + count_max
   end if
   shr_sys_irtc = shr_sys_irtc + count_offset
   last_count = count

END FUNCTION shr_sys_irtc

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_sleep(sec)

   IMPLICIT none

   !----- input -----
   real   (shr_kind_r8),intent(in) :: sec  ! number of seconds to sleep

   !----- local -----
   integer(shr_kind_in) :: isec   ! integer number of seconds
   integer(shr_kind_in) :: rcode  ! return code
   character(len=90) :: sleep_var

   !----- i/o formats -----
   character(len=*),parameter :: F00 = "('sleep ',i8 )"

   save

!-------------------------------------------------------------------------------
! PURPOSE: Sleep for approximately sec seconds
!-------------------------------------------------------------------------------

   isec = nint(sec)

   if (isec < 0) then
      write(6,*) 'ERROR: seconds must be > 0, sec=',sec
   else if (isec == 0) then
!     Don't consider this an error and don't call system sleep
   else
      write(sleep_var,FMT=F00) isec
      call shr_sys_system( sleep_var, rcode )
   endif

END SUBROUTINE shr_sys_sleep

!===============================================================================
!===============================================================================

SUBROUTINE shr_sys_flush(unit)

   IMPLICIT none

   !----- arguments -----
   integer(SHR_KIND_IN) :: unit  ! flush output buffer for this unit

!-------------------------------------------------------------------------------
! PURPOSE: an architecture independant system call
!-------------------------------------------------------------------------------

#if (defined IRIX64 || defined CRAY || defined OSF1 || defined SUNOS || defined LINUX || defined NEC_SX || defined UNICOSMP)
   call flush(unit)
#endif
#if (defined AIX)
   call flush_(unit)
#endif

#if (!defined CRAY && !defined IRIX64 && !defined AIX && !defined OSF1 && !defined SUNOS && !defined LINUX && !defined NEC_SX && !defined UNICOSMP)
   write(*,*) '(shr_sys_flush) WARNING: no implementation for this architecture'
#endif

END SUBROUTINE shr_sys_flush

!===============================================================================
!BOP ===========================================================================
!
! !IROUTINE: shr_sys_iounit -- returns an unused fortran i/o unit number
!
! !DESCRIPTION:
!    Returns an unused fortran i/o unit number.
!
! !REVISION HISTORY:
!     2005-Nov-21 -- B. Kauffman - first version
!
! !INTERFACE: ------------------------------------------------------------------

integer(SHR_KIND_IN) function shr_sys_ioUnit()

   implicit none

! !INPUT/OUTPUT PARAMETERS:

   !-- no input, output via function value

!EOP

   !--- local ---
   integer(SHR_KIND_IN)   :: nUnit       ! a file unit number
   logical                :: open        ! true if file unit is open

   !--- formats ---
   character(*),parameter :: subName =  "('shr_sys_ioUnit') "
   character(*),parameter :: F00     = "('(shr_sys_ioUnit) ',16a) "

!-------------------------------------------------------------------------------
! find an unused unit number
!-------------------------------------------------------------------------------

   do nUnit=10,99
      inquire(nUnit,opened=open)
      if (.not. open) then
         shr_sys_ioUnit = nUnit
         exit
      end if
   end do

   if (open) then
      write(6,F00) "ERROR: couldn't find an unused fortran unit number"
      call shr_sys_abort(subName//": all units open?")
   end if

end function shr_sys_ioUnit

!===============================================================================

END MODULE shr_sys_mod

!===============================================================================
! SVN $Id: mapsort_mod.F90 35698 2012-03-22 23:59:57Z kauff $
! SVN $URL: https://svn-ccsm-models.cgd.ucar.edu/tools/mapping/trunk_tags/mapping_130426a/gen_mapping_files/runoff_to_ocn/src/mapsort_mod.F90 $
!===============================================================================

MODULE mapsort_mod

   use shr_sys_mod
   use shr_timer_mod
   use kind_mod
   use map_mod

   implicit none

   private ! default private

   public :: mapsort_checkSort  ! checks if map matrix is properly sorted
   public :: mapsort_sort       ! sort the map

   interface mapsort_sort; module procedure mapsort_byrow; end interface

   integer(IN),parameter :: debug = 1

!===============================================================================
CONTAINS 
!===============================================================================

SUBROUTINE mapsort_checkSort(map,rowOK,colOK)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       
   logical,optional,intent(out) :: rowOK,colOK

   !--- local ---
   integer(IN) :: n
   logical     :: sorted

   !--- formats ---
   character(*),parameter :: subName = "(mapsort_checkSort) "
   character(*),parameter :: F00 =   "('(mapsort_checkSort) ',8a)"

!-------------------------------------------------------------------------------
! PURPOSE:
! o checks whether elements of an sMatrix are properly sorted
!-------------------------------------------------------------------------------

   !--- are rows monotonically increasing? ---
   sorted = .true.
   do n=1,map%n_s-1
     if (map%row(n) > map%row(n+1) ) sorted = .false.
   enddo
   if (      sorted ) write(6,F00) "VERIFIED: rows are monotonically increasing"
   if (.not. sorted ) write(6,F00) "WARNING : rows are not monotonically increasing"
   if (present(rowOK)) rowOK = sorted

   !--- for a given row, are cols monotonically increasing? ---
   sorted = .true.
   do n=1,map%n_s-1
      if ((map%row(n) == map%row(n+1)) .and. (map%col(n) > map%col(n+1))) sorted = .false.
   enddo
   if (      sorted ) write(6,F00) "VERIFIED: cols are monotonically increasing"
   if (.not. sorted ) write(6,F00) "WARNING : cols are not monotonically increasing"
   if (present(colOK)) colOK = sorted

END SUBROUTINE mapsort_checkSort

!===============================================================================
!===============================================================================

SUBROUTINE mapsort_byrow(map)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       

   !--- local ---
   integer(IN)             :: i,j          ! index into 2d matrix S(i,j)
   integer(IN)             :: n            ! index into 1d vector S(n)
   integer(IN)             :: k            ! index into tempS(i,k) = S(i,j) where j = tempCol(n,k)
   integer(IN)             :: na,nb        ! size of uncompressed matrix nb*na
   integer(IN)             :: ns           ! size of compressed matrix

   real   (R8),allocatable :: tempS  (:,:) ! matrix elements in temp non-standard format
   integer(IN),allocatable :: tempCol(:,:) ! matrix columns  in temp non-standard format
   integer(IN),allocatable :: nCols  (  :) ! number of active cols in each row of tempS(i,k)
   integer(IN)             :: kMax         ! size of k dim allocated/available in tempS(i,k)
   integer(IN)             :: count        ! counts occurances of things for debugging

   logical                 :: noSwap       ! flags col swapping when col sorting
   integer(IN)             :: nMin ,nMax   !
   integer(IN)             :: nMin2,nMax2  !
   integer(IN)             :: nMin0        !
   integer(IN),parameter   :: nMod=100000  ! for debug info
   integer(IN)             :: iTmp         ! temp var for col sorting
   real   (R8)             :: rTmp         ! temp var for col sorting
   logical                 :: done         ! col sorting is complete

   integer(IN)             :: nNew         ! new S(n) index wrt combining duplicate i/j

   character( 8)           :: dstr         ! wall clock date
   character(10)           :: tstr         ! wall clock time

#ifdef  _OPENMP
   integer(IN)              :: omp_get_max_threads !  $OMP function call
#endif

   !--- formats ---
   character(*),parameter :: subName = '(mapsort_byrow) '
   character(*),parameter :: F00   = "('(mapsort_byrow) ',8a)"
   character(*),parameter :: F01   = "('(mapsort_byrow) ',a,4i11)"
   character(*),parameter :: F12   = "('(mapsort_byrow) date & time:',1x,a4,2('-',a2),2x,a2,2(':',a2))"

!-------------------------------------------------------------------------------
! PURPOSE:
!   sort all elements of S so that row(n) <= row(n+1)
!   and if  row(n) == row(n+1), then col(n) <= col(n+1)
!-------------------------------------------------------------------------------

   ns = map%n_s
   na = map%n_a
   nb = map%n_b

   write(6,F01) "na, nb, ns = ",map%n_a,map%n_b,map%n_s
   write(6,F01) "min/max row = ",minval(map%row),maxval(map%row)
   write(6,F01) "min/max col = ",minval(map%col),maxval(map%col)

   !----------------------------------------------------------------------------
   write(6,F00) "fill a temp matrix (non-standard format) with row-sorted data"
   !----------------------------------------------------------------------------

   call date_and_time(dstr,tstr)
   write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

   !--- determine how big temp matrix must be, allocate temp matrix ---
   allocate(nCols(nb))

   nCols = 0
   kMax = 0
   do n=1,ns
      i = map%row(n)
      nCols(i) = nCols(i)+1
      kMax = max(kMax,nCols(i))
   end do
   write(6,F01) "max number of cols per row = ",kMax

   allocate(tempS  (nb,kMax))
   allocate(tempCol(nb,kMax))

   !--- fill the temp matrix arrays with data ---
   nCols = 0
   do n=1,ns

      if (debug > 0  .and. mod(n,nMod) == 0) then
         write(6,F01) "... working, max elements, current element = ",ns,n
         call shr_sys_flush(6)
      endif
 
      i = map%row(n)  ! s(n) belongs in row i
      k = nCols(i)+1  ! s(n) is k-th non-zero element in row i

      if (nCols(i) > kMax) then
         write(6,F01) "ERROR: temp S,col arrays not large enough, kMax = ",kMax
         call shr_sys_abort()
      endif

      nCols  (i)   = k           ! number of elements in row i
      tempCol(i,k) = map%col(n)  ! associated col
      tempS  (i,k) = map%s  (n)  ! matrix element
   end do

   !----------------------------------------------------------------------------
   write(6,F00) "fill a input/output matrix with row-sorted data"
   !----------------------------------------------------------------------------

   call date_and_time(dstr,tstr)
   write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

   n = 0
   do i=1,nb
   do k=1,nCols(i)
      n = n+1
      map%row(n) = i
      map%col(n) = tempCol(i,k)
      map%s  (n) = tempS  (i,k)
   end do
   end do

   deallocate(nCols,tempS,tempCol)

   call mapsort_checkSort(map) ! confirm rows are sorted

   !----------------------------------------------------------------------------
   write(6,F00) "sort columns within each row (assumes rows are sorted)"
   !----------------------------------------------------------------------------

   call date_and_time(dstr,tstr)
   write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

   call map_Sn1(map) ! determine where rows begin & end in s(n)

#ifdef  _OPENMP
   n = omp_get_max_threads()
   write(6,F01) 'FYI: this routine is threaded, omp_get_max_threads() = ',n
#else
   write(6,F00) 'FYI: this routine is not threaded'
#endif

!$OMP PARALLEL DO PRIVATE(i,done,n,nMin,nMax,nMin0,nMin2,nMax2,iTmp,rTmp,noSwap,dstr,tstr)
   do i=1,nb
      if (debug > 0  .and. mod(i,nMod) == 0) then
         write(6,F01) "... working on row ",i
         call date_and_time(dstr,tstr)
         write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)
         call shr_sys_flush(6)
      endif

      nMin0 = map%sn2(i) + 1          ! 1st element in row i
      nMin  = nMin0                   ! 1st  potentially out-of-order element in row i 
      nMax  = map%sn2(i) + map%sn1(i) ! last potentially out-of-order element in row i
      done = .false.
      do while ( .not. done )
         noSwap = .true.
         do n=nMin,nMax-1 ! all elements should be in the same row
         !  if (map%row(n) == map%row(n+1) .and. map%col(n) > map%col(n+1)) then
            if (map%col(n) > map%col(n+1)) then

               !--- swap adjacent out-of-order columns (within same row) ---
               iTmp         = map%col(n+1)
               map%col(n+1) = map%col(n)
               map%col(n)   = iTmp
               rTmp         = map%s(n+1)
               map%s(n+1)   = map%s(n)
               map%s(n)     = rTmp
   
               !--- note subset of out-of-order elements ---
               if (noSwap) then ! 1st swap
                  nMin2 = max(n-1,nMin0)
                  noSwap = .false.
               end if
               nMax2=n          ! last swap
            endif
         enddo
         if (noSwap) then
            done = .true.
         else ! narrow the search
            nMin=nMin2  ! 1st  potentially out-of-order element
            nMax=nMax2  ! last potentially out-of-order element
         endif
      enddo
   end do

   call mapsort_checkSort(map) ! confirm cols are sorted

   !----------------------------------------------------------------------------
   write(6,F00) "combine elements with same row/col (assumes matrix is sorted)"
   !----------------------------------------------------------------------------

   call date_and_time(dstr,tstr)
   write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

   write(6,F01) "... orig size of S = ",map%n_s
   i = 0
   j = 0
   nNew = 0
   count = 0
   do n=1,map%n_s
      if (map%row(n) == i  .and.  map%col(n) == j) then
         !--- same i,j as previous element => combine them ---
         count = count + 1
         map%s(nNew) = map%s(nNew) + map%s(n)
      else
         !--- different i,j from previous element => don't combine ---
         nNew = nNew + 1
         map%row(nNew) = map%row(n)
         map%col(nNew) = map%col(n)
         map%s  (nNew) = map%s  (n)
         i = map%row(n)
         j = map%col(n)
      endif
   enddo
   map%n_s = nNew
   write(6,F01) "... new  size of S = ",map%n_s
   write(6,F01) "... number of duplicate row/col = ",count

   call map_Sn1(map) ! determine where rows begin & end in s(n)

   write(6,F00) "Done."
   call date_and_time(dstr,tstr)
   write(6,F12) dstr(1:4),dstr(5:6),dstr(7:8) ,tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

END SUBROUTINE mapsort_byrow

!===============================================================================
!===============================================================================

SUBROUTINE mapsort_sortMatRC(map)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       

   !--- local ---
   integer(IN) :: i,m,n
   logical     :: rowOK,colOK
   integer(IN) :: t01 = 0         ! system-clock-timer number

#ifdef  _OPENMP
   integer(IN) :: omp_get_max_threads !  $OMP function call
#endif
   character(8)  :: dstr          ! F90 wall clock date string yyyymmdd
   character(10) :: tstr          ! F90 wall clock time string hhmmss.sss

   !--- formats ---
   character(*),parameter :: subName = "(mapsort_sortMatRC) "
   character(*),parameter :: F00   = "('(mapsort_sortMatRC) ',8a)"
   character(*),parameter :: F01   = "('(mapsort_sortMatRC) ',a,4i11)"
   character(*),parameter :: F10   = "('(mapsort_sortMatRC) ',a,i7, &
                                   &   '  date & time:',1x, &
                                   &   a4,2('-',a2),2x,a2,2(':',a2))"

!-------------------------------------------------------------------------------
! PURPOSE:
! o sorts the elements of an sMatrix to achieve uniformly increasing columns
!   within each given row
! o assumes the elements of an sMatrix already have uniformly increasing rows
!-------------------------------------------------------------------------------

   write(6,F01) "sort matrix, size = ",map%n_s

   if (t01 == 0) call shr_timer_get(t01,subName//"sort matrix")

   !----------------------------------------------------------------------------
   !check for correct row/column sorting
   !----------------------------------------------------------------------------
   call mapsort_checkSort(map)

   !----------------------------------------------------------------------------
   ! sort entire matrix
   !----------------------------------------------------------------------------
   write(6,F00) "sort entire matrix"
   call shr_timer_zero (t01)
   call shr_timer_start(t01)

   call date_and_time(dstr,tstr) ! F90 intrinsic routine
   write(6,F10) 'i=',0,dstr(1:4),dstr(5:6),dstr(7:8),tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

   n = 1
   m = map%n_s
   call mapsort_qsortRC(map%s(n:m),map%row(n:m),map%col(n:m))

   call shr_timer_stop(t01)
   call shr_timer_print(t01)

   !----------------------------------------------------------------------------
   ! verify matrix has been properly sorted
   !----------------------------------------------------------------------------
   call mapsort_checkSort(map,rowOK=rowOK,colOK=colOK)
   if (.not. rowOK ) write(6,F00) "ERROR: rows are NOT monotonically increasing"
   if (.not. colOK ) write(6,F00) "ERROR: cols are NOT monotonically increasing"
   if (.not. colOK .or. .not. rowOK) stop

END SUBROUTINE mapsort_sortMatRC

!===============================================================================
!===============================================================================

recursive SUBROUTINE mapsort_qsortRC(S,row,col)

   implicit none

   !--- arguments ---
   real   (R8) ::   S(:)
   integer(IN) :: row(:),col(:)

   !--- local ---
   integer(IN) :: ns  ! size of data array to sort
   integer(IN) :: m   ! marker that divides data array into two

   !--- formats ---
   character(*),parameter :: F00 = "('(mapsort_qsortRC) ',8a)"
   character(*),parameter :: F01 = "('(mapsort_qsortRC) ',a,5i6)"

!-------------------------------------------------------------------------------
! PURPOSE: 
!   sort all elements of S so that col(n) is strickly increasing
!   assumes that row(n) is a constant (ie. row(n) = row(m) for every n,m)
!-------------------------------------------------------------------------------

   ns = size(S)
   if ( ns > 1) then
      call mapsort_partitianRC(S,row,col,m)
      call mapsort_qsortRC   (S(1:m-1),row(1:m-1),col(1:m-1))
      call mapsort_qsortRC   (S(m:ns ),row(m:ns ),col(m:ns ))
   end if

END SUBROUTINE mapsort_qsortRC

!===============================================================================
!===============================================================================

SUBROUTINE mapsort_partitianRC(S,row,col,marker)

   implicit none

   !--- arguments ---
   real   (R8) :: S(:)     ! must rearrange along with col values
   integer(IN) :: row(:)   ! unused: assumed constant
   integer(IN) :: col(:)   ! sort wrt column value
   integer(IN) :: marker   ! partitian wrt this index

   !--- local ---
   integer(IN) :: i,j      ! generic index
   integer(IN) :: ns       ! size of S(:),row(:),col(:)
   integer(IN) :: pivotR   ! partitian wrt this row value...
   integer(IN) :: pivotC   ! ... and   wrt this col value
   real   (R8) :: rTemp    ! temp var for swapping
   integer(IN) :: iTemp    ! temp var for swapping

   !--- formats ---
   character(*),parameter :: F00 = "('(mapsort_partitianRC) ',8a)"
   character(*),parameter :: F01 = "('(mapsort_partitianRC) ',a,2i11)"

!-------------------------------------------------------------------------------
! PURPOSE: 
! o DOES NOT assume rows are sorted, assumes a completely unsorted matrix
! o rearrange elements in S & col and compute marker such that
!   if  n = marker  and  i <= n <= j   we have col(i) <= col(n) <= col(j)
!-------------------------------------------------------------------------------

   ns = size(S)
   if (ns < 2) then
      write(6,F01) "ERROR: ns < 2, ns = ",ns
      stop
   end if

   pivotC = col(ns/2) ! note: fortran truncation
   pivotR = row(ns/2) ! note: fortran truncation
!  pivotC = col(1)
!  pivotR = row(1)

   i = 0
   j = ns+1
   do
      !--- move j downward ---
      j = j-1
      do
        if  (row(j) <  pivotR)                        exit
        if  (row(j) == pivotR .and. col(j) <= pivotC) exit
        j = j-1
      end do
      !--- move i upward ---
      i = i+1
      do
        if  (row(j) >  pivotR)                         exit
        if  (row(j) == pivotR .and. col(j) >= pivotC ) exit
        i = i+1
      end do
      !--- if (i<j) then swap & continue, else return ---
      if ( i < j ) then
         !--- swap matrix elements ---
         rTemp  = S  (i)
         S  (i) = S  (j)
         S  (j) = rTemp
         !--- swap column index ---
         iTemp  = col(i)
         col(i) = col(j)
         col(j) = iTemp
         !--- swap row    index ---
         iTemp  = row(i)
         row(i) = row(j)
         row(j) = iTemp
      else if (i == j) then
         marker = i+1
         return
      else
         marker = i
         return
      end if
   end do

END SUBROUTINE mapsort_partitianRC

!===============================================================================
!===============================================================================
!===============================================================================

SUBROUTINE mapsort_sortMatC(map)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       

   !--- local ---
   integer(IN) :: i,m,n
   logical     :: rowOK,colOK
   integer(IN) :: t01 = 0         ! system-clock-timer number

#ifdef  _OPENMP
   integer(IN) :: omp_get_max_threads !  $OMP function call
#endif
   character(8)  :: dstr          ! F90 wall clock date string yyyymmdd
   character(10) :: tstr          ! F90 wall clock time string hhmmss.sss

   !--- formats ---
   character(*),parameter :: subName = "(mapsort_sortMatC) "
   character(*),parameter :: F00   = "('(mapsort_sortMatC) ',8a)"
   character(*),parameter :: F01   = "('(mapsort_sortMatC) ',a,4i11)"
   character(*),parameter :: F10   = "('(mapsort_sortMatC) ',a,i7, &
                                   &   '  date & time:',1x, &
                                   &   a4,2('-',a2),2x,a2,2(':',a2))"

!-------------------------------------------------------------------------------
! PURPOSE:
! o sorts the elements of an sMatrix to achieve uniformly increasing columns
!   within each given row
! o assumes the elements of an sMatrix already have uniformly increasing rows
!-------------------------------------------------------------------------------

   write(6,F01) "sort matrix, size = ",map%n_s

   if (t01 == 0) then
      call shr_timer_get(t01,subName//"sort matrix")
#ifdef  _OPENMP
      n = omp_get_max_threads()
      write(6,F01) 'FYI: this routine is threaded, omp_get_max_threads() = ',n
#else
      write(6,F01) 'FYI: this routine is not threaded'
#endif
   end if

   !----------------------------------------------------------------------------
   !check for correct row/column sorting
   !----------------------------------------------------------------------------

   call mapsort_checkSort(map,rowOK=rowOK)
   if (.not. rowOK ) then
      write(6,F00) "ERROR: rows are NOT monotonically increasing"
      stop
   end if

   !----------------------------------------------------------------------------
   ! sort the columns within each row
   !----------------------------------------------------------------------------
   write(6,F00) "sort the columns within each row of a matrix"
   write(6,F01) "min/max Sn1 = ",minval(map%Sn1),maxval(map%Sn1)
   write(6,F01) "min/max Sn2 = ",minval(map%Sn2),maxval(map%Sn2)
   call shr_timer_zero (t01)
   call shr_timer_start(t01)

   write(6,F01) "loop: i=1,nRows    where nRows = ",map%n_b    
   call date_and_time(dstr,tstr) ! F90 intrinsic routine
   write(6,F10) 'i=',0,dstr(1:4),dstr(5:6),dstr(7:8),tstr(1:2),tstr(3:4),tstr(5:6)
   call shr_sys_flush(6)

!$OMP PARALLEL DO PRIVATE(i,n,m)
   do i=1,map%n_b    
      !--- sort the columns in row i ------------------------
      if (mod(i,1000)==0) then
         call date_and_time(dstr,tstr) ! F90 intrinsic routine
         write(6,F10) 'i=',i,dstr(1:4),dstr(5:6),dstr(7:8),tstr(1:2),tstr(3:4),tstr(5:6)
         call shr_sys_flush(6)
      end if
      !------------------------------------------------------
      if ( map%sn1(i) > 1) then
         n = map%sn2(i) + 1          ! S(n) is 1st  element in row i
         m = map%sn2(i) + map%sn1(i) ! S(m) is last element in row i
         call mapsort_QsortC(map%s(n:m),map%row(n:m),map%col(n:m))
      end if
      !------------------------------------------------------
   end do
   call shr_timer_stop(t01)
   call shr_timer_print(t01)

   !----------------------------------------------------------------------------
   ! verify matrix has been properly sorted
   !----------------------------------------------------------------------------
   call mapsort_checkSort(map,rowOK=rowOK,colOK=colOK)
   if (.not. rowOK ) write(6,F00) "ERROR: rows are NOT monotonically increasing"
   if (.not. colOK ) write(6,F00) "ERROR: cols are NOT monotonically increasing"
   if (.not. colOK .or. .not. rowOK) stop

END SUBROUTINE mapsort_sortMatC

!===============================================================================
!===============================================================================

recursive SUBROUTINE mapsort_QsortC(S,row,col)

   implicit none

   !--- arguments ---
   real   (R8) ::   S(:)
   integer(IN) :: row(:),col(:)

   !--- local ---
   integer(IN) :: ns  ! size of data array to sort
   integer(IN) :: m   ! marker that divides data array into two

   !--- formats ---
   character(*),parameter :: F00 = "('(mapsort_QsortC) ',8a)"
   character(*),parameter :: F01 = "('(mapsort_QsortC) ',a,5i6)"

!-------------------------------------------------------------------------------
! PURPOSE: 
!   sort all elements of S so that col(n) is strickly increasing
!   assumes that row(n) is a constant (ie. row(n) = row(m) for every n,m)
!-------------------------------------------------------------------------------

   ns = size(S)
   if ( ns > 1) then
     call mapsort_partitianC(S,row,col,m)
     call mapsort_QsortC   (S(1:m-1),row(1:m-1),col(1:m-1))
     call mapsort_QsortC   (S(m:ns ),row(m:ns ),col(m:ns ))
   end if

END SUBROUTINE mapsort_QsortC

!===============================================================================
!===============================================================================

SUBROUTINE mapsort_partitianC(S,row,col,marker)

   implicit none

   !--- arguments ---
   real   (R8) :: S(:)     ! must rearrange along with col values
   integer(IN) :: row(:)   ! unused: assumed constant
   integer(IN) :: col(:)   ! sort wrt column value
   integer(IN) :: marker   ! partitian wrt this index

   !--- local ---
   integer(IN) :: i,j      ! generic index
   integer(IN) :: ns       ! size of S(:),row(:),col(:)
   integer(IN) :: pivot    ! partitian wrt this value
   real   (R8) :: rTemp    ! temp var for swapping
   integer(IN) :: iTemp    ! temp var for swapping

   !--- formats ---
   character(*),parameter :: F00 = "('(mapsort_partitianC) ',8a)"
   character(*),parameter :: F01 = "('(mapsort_partitianC) ',a,2i11)"

!-------------------------------------------------------------------------------
! PURPOSE: 
! o assumes rows are already sorted
! o rearrange elements in S & col and compute marker such that
!   if  n = marker  and  i <= n <= j   we have col(i) <= col(n) <= col(j)
!-------------------------------------------------------------------------------

   ns = size(S)
   if (ns < 2) then
      write(6,F01) "ERROR: ns < 2, ns = ",ns
      stop
   end if
   if (minval(row) /= maxval(row)) then
      write(6,F01) "ERROR: all elements not in same row"
      write(6,F01) "ERROR: row min/max = ",minval(row),maxval(row)
      stop
   end if

!  pivot = col(ns/2) ! note: fortran truncation
   pivot = col(1)

   i = 0
   j = ns+1
   do
      !--- move j downward ---
      j = j-1
      do
        if (col(j) <= pivot) exit
        j = j-1
      end do
      !--- move i upward ---
      i = i+1
      do
        if (col(i) >= pivot) exit
        i = i+1
      end do
      !--- if (i<j) then swap & continue, else return ---
      if ( i < j ) then
         rTemp  = S  (i)
         S  (i) = S  (j)
         S  (j) = rTemp
         iTemp  = col(i)
         col(i) = col(j)
         col(j) = iTemp
      else if (i == j) then
         marker = i+1
         return
      else
         marker = i
         return
      end if
   end do

END SUBROUTINE mapsort_partitianC

!===============================================================================
!===============================================================================

SUBROUTINE mapsort_sortH(map)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       

   !--- local ---
   integer n,thisrow,thiscol,n0,n1
   integer imin,imax,cnt,itmp,imin2,imax2
   double precision rtmp

!-------------------------------------------------------------------------------
! PURPOSE:
! o  subroutinized version of /fs/cgd/home0/hecht/csm/runoff/sort_map.F
! o  sorts the links in sMatrix "map" to achieve a uniformly increasing
!       map%row array.
! o  sorts the links in sMatrix "map" to achieve uniformly increasing
!       map%col for a given map%row value.
! o  assures that the array of links contains unique row-col pairs.
!-------------------------------------------------------------------------------

   imin=1
   imax=map%n_s
   cnt=map%n_s

   print *,'(mapsort_sortH): starting sort...'
   do while (cnt.gt.0)
   cnt=0
   do n=imin,imax-1
     if (map%row(n).gt.map%row(n+1)) then
       itmp=map%row(n+1)
       map%row(n+1)=map%row(n)
       map%row(n)=itmp
       itmp=map%col(n+1)
       map%col(n+1)=map%col(n)
       map%col(n)=itmp
       rtmp=map%s(n+1)
       map%s(n+1)=map%s(n)
       map%s(n)=rtmp
       cnt=cnt+1
       if (cnt.eq.1) imin2=n-1
       imax2=n
     endif
   enddo
   imin=max(imin2,1)
   imax=imax2
   enddo

   print *,'(mapsort_sortH): halfway done...'

   imin=1
   imax=map%n_s
   cnt=map%n_s

   do while (cnt.gt.0)
   cnt=0
   do n=imin,imax-1
     if (map%col(n).gt.map%col(n+1).and.map%row(n).eq.map%row(n+1)) then
       itmp=map%col(n+1)
       map%col(n+1)=map%col(n)
       map%col(n)=itmp
       rtmp=map%s(n+1)
       map%s(n+1)=map%s(n)
       map%s(n)=rtmp
       cnt=cnt+1
       if (cnt.eq.1) imin2=n-1
       imax2=n
     endif
   enddo
   imin=max(imin2,1)
   imax=imax2
   enddo
   print *,'(mapsort_sortH): done sorting for both row AND col'

   thisrow = 0
   thiscol = 0
   n0 = 0
   n1 = 0
   do n=1,map%n_s
     if (map%row(n).eq.thisrow.and.map%col(n).eq.thiscol) then
       n1 = n1 + 1
       map%s(n0) = map%s(n0)+map%s(n)
     else
       n0 = n0 + 1
       thisrow = map%row(n)
       thiscol = map%col(n)
       map%row(n0) = map%row(n)
       map%col(n0) = map%col(n)
       map%s(n0) = map%s(n)
     endif
   enddo
   map%n_s = n0
   print *,'(mapsort_sortH): # of repeat col->row links found ',n1
   print *,'(mapsort_sortH): now n_s = ',n0

END SUBROUTINE mapsort_sortH

!===============================================================================

SUBROUTINE mapsort_sortY(map)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       

   !--- local ---
   integer i,j,n,thisrow,thiscol,n0,n1,ncnt,nskip,nrow
   integer imin,imax,cnt,itmp,imin2,imax2
   integer, allocatable :: rowtmp(:),coltmp(:),stmp(:)
   logical rowok,colok
   double precision rtmp

!-------------------------------------------------------------------------------
! PURPOSE:
! o  subroutinized version of /fs/cgd/home0/hecht/csm/runoff/sort_map.F
! o  sorts the links in sMatrix "map" to achieve a uniformly increasing
!       map%row array.
! o  sorts the links in sMatrix "map" to achieve uniformly increasing
!       map%col for a given map%row value.
! o  assures that the array of links contains unique row-col pairs.
!-------------------------------------------------------------------------------

   allocate(stmp(map%n_s))
   allocate(rowtmp(map%n_s))
   allocate(coltmp(map%n_s))
   stmp = map%s
   rowtmp = map%row
   coltmp = map%col

!  check for correct row/column sorting  (copied from map_check)
   rowok = .true.
   colok = .true.
!  is row monotonically increasing?
   do n=2,map%n_s
     if (map%row(n-1) > map%row(n) ) rowok = .false.
   enddo
!  is col monotonically increasing for a given row?
   do i=1,map%n_s-1
      if (map%col(i).gt.map%col(i+1).and.map%row(i+1).eq.map%row(i)) then
         colok = .false.
      endif
   enddo

!  if (.not. rowok .and. .not. colok) then 
!    imin=1
!    imax=map%n_s
!    cnt=map%n_s
!    print *,'(mapsort_sortY): slow-sorting rows...'
!    do while (cnt.gt.0)
!    cnt=0
!    do n=imin,imax-1
!      if (map%row(n).gt.map%row(n+1)) then
!        itmp=map%row(n+1)
!        map%row(n+1)=map%row(n)
!        map%row(n)=itmp
!        itmp=map%col(n+1)
!        map%col(n+1)=map%col(n)
!        map%col(n)=itmp
!        rtmp=map%s(n+1)
!        map%s(n+1)=map%s(n)
!        map%s(n)=rtmp
!        cnt=cnt+1
!        if (cnt.eq.1) imin2=n-1
!        imax2=n
!      endif
!    enddo
!    imin=max(imin2,1)
!    imax=imax2
!    enddo
!  endif

!  if (.not. rowok .and. colok) then
!    cnt=1
!    print *,'(mapsort_sortY): fast-sorting rows...'
!    do j=1,map%n_b
!      n0 = 0
!      n1 = 0
!      do n=cnt,map%n_s
!        if (map%row(n).eq.j .and. n0.eq.0) n0=n
!        if (map%row(n).ne.j .and. n0.ne.0 .and. n1.eq.0) n1=n-1
!      enddo
!      if (n0.ne.0) then 
!        if (n1.eq.0) n1=n0
!        nrow = n1-n0+1
!        nskip = n0-cnt
!        map%row(cnt:cnt+nrow-1)=rowtmp(n0:n1)
!        map%col(cnt:cnt+nrow-1)=coltmp(n0:n1)
!        map%s(cnt:cnt+nrow-1)=stmp(n0:n1)
!        if (nskip.gt.0) then
!          map%row(cnt+nrow:cnt+nrow+nskip-1) = rowtmp(cnt:n0-1)
!          map%col(cnt+nrow:cnt+nrow+nskip-1) = coltmp(cnt:n0-1)
!          map%s(cnt+nrow:cnt+nrow+nskip-1) = stmp(cnt:n0-1)
!        endif
!        cnt = cnt+nrow
!        if (n1.lt.map%n_s) then
!          if (cnt+nskip .ne. n1+1) write(6,*) 'ERROR cnt+nskip .ne. n1+1'
!          map%row(n1+1:map%n_s) = rowtmp(n1+1:map%n_s)
!          map%col(n1+1:map%n_s) = coltmp(n1+1:map%n_s)
!          map%s(n1+1:map%n_s) = stmp(n1+1:map%n_s)
!        endif
!        rowtmp = map%row
!        coltmp = map%col
!        stmp = map%s
!      endif
!    enddo
!  endif

   if (.not. rowok) then
     call mapsort_byrow(map)
   endif

   if (.not. colok) then 
     imin=1
     imax=map%n_s
     cnt=map%n_s
     print *,'(mapsort_sortY): sorting columns...'
     do while (cnt.gt.0)
     cnt=0
     do n=imin,imax-1
       if (map%col(n).gt.map%col(n+1).and.map%row(n).eq.map%row(n+1)) then
         itmp=map%col(n+1)
         map%col(n+1)=map%col(n)
         map%col(n)=itmp
         rtmp=map%s(n+1)
         map%s(n+1)=map%s(n)
         map%s(n)=rtmp
         cnt=cnt+1
         if (cnt.eq.1) imin2=n-1
         imax2=n
       endif
     enddo
     imin=max(imin2,1)
     imax=imax2
     enddo
   endif

   print *,'(mapsort_sortY): done sorting for both row AND col'

   thisrow = 0
   thiscol = 0
   n0 = 0
   n1 = 0
   do n=1,map%n_s
     if (map%row(n).eq.thisrow.and.map%col(n).eq.thiscol) then
       n1 = n1 + 1
       map%s(n0) = map%s(n0)+map%s(n)
     else
       n0 = n0 + 1
       thisrow = map%row(n)
       thiscol = map%col(n)
       map%row(n0) = map%row(n)
       map%col(n0) = map%col(n)
       map%s(n0) = map%s(n)
     endif
   enddo
   map%n_s = n0
   print *,'(mapsort_sortY): # of repeat col->row links found ',n1
   print *,'(mapsort_sortY): now n_s = ',n0

END SUBROUTINE mapsort_sortY

!===============================================================================
!===============================================================================

SUBROUTINE mapsort_bubble(map)

   implicit none

   !--- arguments ---
   type(sMatrix), intent(inout) :: map       

   !--- local ---
   integer(IN) :: k,m,n          !
   logical     :: rowOK,colOK    !
   integer(IN) :: t01 = 0        ! system-clock-timer number
   real   (R8) :: rTemp          ! temp var for swapping
   integer(IN) :: iTemp          ! temp var for swapping
   real   (R8),pointer :: S  (:) ! 
   integer(IN),pointer :: row(:) ! 
   integer(IN),pointer :: col(:) ! 

   character(8)  :: dstr          ! F90 wall clock date string yyyymmdd
   character(10) :: tstr          ! F90 wall clock time string hhmmss.sss

   !--- formats ---
   character(*),parameter :: subName = "(mapsort_bubble) "
   character(*),parameter :: F00   = "('(mapsort_bubble) ',8a)"
   character(*),parameter :: F01   = "('(mapsort_bubble) ',a,4i11)"
   character(*),parameter :: F10   = "('(mapsort_bubble) ',a,i7, &
                                   &   '  date & time:',1x, &
                                   &   a4,2('-',a2),2x,a2,2(':',a2))"

!-------------------------------------------------------------------------------
! PURPOSE:
!-------------------------------------------------------------------------------

   write(6,F01) "sort entire matrix, size = ",map%n_s

   if (t01 == 0) call shr_timer_get(t01,subName//"sort matrix")

   !----------------------------------------------------------------------------
   !check for correct row/column sorting
   !----------------------------------------------------------------------------
   call mapsort_checkSort(map)

   !----------------------------------------------------------------------------
   ! sort entire matrix
   !----------------------------------------------------------------------------
   call shr_timer_zero (t01)
   call shr_timer_start(t01)

   S   => map%S
   row => map%row
   col => map%col

   do n = 1, map%n_s - 1
      !--- progress report ----------------------------------
      if (mod(n-1,10000)==0) then
         call date_and_time(dstr,tstr) ! F90 intrinsic routine
         write(6,F10) 'n=',n,dstr(1:4),dstr(5:6),dstr(7:8),tstr(1:2),tstr(3:4),tstr(5:6)
         call shr_sys_flush(6)
      end if
      !--- find desired element ---------------------------
      k = n
      do m = n+1, map%n_s
         if      (row(m) <  row(k)) then
            k = m
         else if (row(m) == row(k) .and. col(m) < col(k)) then
            k = m
         end if
      end do
      !--- put desired element into place -----------------
      if ( n /= k ) then
         !--- swap matrix elements ---
         rTemp  = S  (n)
         S  (n) = S  (k)
         S  (k) = rTemp
         !--- swap column index ---
         iTemp  = col(n)
         col(n) = col(k)
         col(k) = iTemp
         !--- swap row    index ---
         iTemp  = row(n)
         row(n) = row(k)
         row(k) = iTemp
      end if
   end do

   call shr_timer_stop (t01)
   call shr_timer_print(t01)

   !----------------------------------------------------------------------------
   ! verify matrix has been properly sorted
   !----------------------------------------------------------------------------
   call mapsort_checkSort(map,rowOK=rowOK,colOK=colOK)
   if (.not. rowOK ) write(6,F00) "ERROR: rows are NOT monotonically increasing"
   if (.not. colOK ) write(6,F00) "ERROR: cols are NOT monotonically increasing"
   if (.not. colOK .or. .not. rowOK) stop

END SUBROUTINE mapsort_bubble

!===============================================================================
!===============================================================================

END MODULE mapsort_mod
